/* Autogenerated: 'src/ExtractionOCaml/word_by_word_montgomery' --lang Java --cmovznz-by-mul --widen-carry --widen-bytes --internal-static --package-name fiat_crypto --class-case UpperCamelCase --no-field-element-typedefs Secp256K1 32 '2^256 - 2^32 - 977' mul square add sub opp from_montgomery to_montgomery nonzero selectznz to_bytes from_bytes one msat divstep divstep_precomp */
/* curve description: Secp256K1 */
/* machine_wordsize = 32 (from "32") */
/* requested operations: mul, square, add, sub, opp, from_montgomery, to_montgomery, nonzero, selectznz, to_bytes, from_bytes, one, msat, divstep, divstep_precomp */
/* m = 0xfffffffffffffffffffffffffffffffffffffffffffffffffffffffefffffc2f (from "2^256 - 2^32 - 977") */
/*                                                                    */
/* NOTE: In addition to the bounds specified above each function, all */
/*   functions synthesized for this Montgomery arithmetic require the */
/*   input to be strictly less than the prime modulus (m), and also   */
/*   require the input to be in the unique saturated representation.  */
/*   All functions also ensure that these two properties are true of  */
/*   return values.                                                   */
/*  */
/* Computed values: */
/*   eval z = z[0] + (z[1] << 32) + (z[2] << 64) + (z[3] << 96) + (z[4] << 128) + (z[5] << 160) + (z[6] << 192) + (z[7] << 224) */
/*   bytes_eval z = z[0] + (z[1] << 8) + (z[2] << 16) + (z[3] << 24) + (z[4] << 32) + (z[5] << 40) + (z[6] << 48) + (z[7] << 56) + (z[8] << 64) + (z[9] << 72) + (z[10] << 80) + (z[11] << 88) + (z[12] << 96) + (z[13] << 104) + (z[14] << 112) + (z[15] << 120) + (z[16] << 128) + (z[17] << 136) + (z[18] << 144) + (z[19] << 152) + (z[20] << 160) + (z[21] << 168) + (z[22] << 176) + (z[23] << 184) + (z[24] << 192) + (z[25] << 200) + (z[26] << 208) + (z[27] << 216) + (z[28] << 224) + (z[29] << 232) + (z[30] << 240) + (z[31] << 248) */
/*   twos_complement_eval z = let x1 := z[0] + (z[1] << 32) + (z[2] << 64) + (z[3] << 96) + (z[4] << 128) + (z[5] << 160) + (z[6] << 192) + (z[7] << 224) in */
/*                            if x1 & (2^256-1) < 2^255 then x1 & (2^256-1) else (x1 & (2^256-1)) - 2^256 */

package fiat_crypto;

public final class FiatSecp256K1 {

static class Box<T> {
  private T value;
  public Box(T value) { this.value = value; }
  public void set(T value) { this.value = value; }
  public T get() { return this.value; }
}



/**
 * The function fiat_Secp256K1_addcarryx_u32 is an addition with carry. <p>
 * <p>
 * Postconditions: <p>
 *   out1 = (arg1 + arg2 + arg3) mod 2^32 <p>
 *   out2 = ⌊(arg1 + arg2 + arg3) / 2^32⌋ <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [0x0 ~&gt; 0x1] <p>
 *   arg2: [0x0 ~&gt; 0xffffffff] <p>
 *   arg3: [0x0 ~&gt; 0xffffffff] <p>
 * Output Bounds: <p>
 *   out1: [0x0 ~&gt; 0xffffffff] <p>
 *   out2: [0x0 ~&gt; 0x1] <p>
 */
static void fiat_Secp256K1_addcarryx_u32(Box<Integer> out1, Box<Integer> out2, int arg1, int arg2, int arg3) {
  long x1 = (((long) Integer.toUnsignedLong(((Number) (arg1)).intValue()) + (long) Integer.toUnsignedLong(((Number) (arg2)).intValue())) + (long) Integer.toUnsignedLong(((Number) (arg3)).intValue()));
  int x2 = ((int) Integer.toUnsignedLong(((Number) (x1)).intValue()) & 0xffffffff);
  int x3 = (int) Integer.toUnsignedLong(((Number) ((x1 >>> 32))).intValue());
  out1.set(x2);
  out2.set(x3);
}

/**
 * The function fiat_Secp256K1_subborrowx_u32 is a subtraction with borrow. <p>
 * <p>
 * Postconditions: <p>
 *   out1 = (-arg1 + arg2 + -arg3) mod 2^32 <p>
 *   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^32⌋ <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [0x0 ~&gt; 0x1] <p>
 *   arg2: [0x0 ~&gt; 0xffffffff] <p>
 *   arg3: [0x0 ~&gt; 0xffffffff] <p>
 * Output Bounds: <p>
 *   out1: [0x0 ~&gt; 0xffffffff] <p>
 *   out2: [0x0 ~&gt; 0x1] <p>
 */
static void fiat_Secp256K1_subborrowx_u32(Box<Integer> out1, Box<Integer> out2, int arg1, int arg2, int arg3) {
  long x1 = (((long) Integer.toUnsignedLong(((Number) (arg2)).intValue()) - (long) Integer.toUnsignedLong(((Number) (arg1)).intValue())) - (long) Integer.toUnsignedLong(((Number) (arg3)).intValue()));
  int x2 = (int) Integer.toUnsignedLong(((Number) ((x1 >>> 32))).intValue());
  int x3 = ((int) Integer.toUnsignedLong(((Number) (x1)).intValue()) & 0xffffffff);
  out1.set(x3);
  out2.set(((int) Integer.toUnsignedLong(((Number) (0x0)).intValue()) - (int) Integer.toUnsignedLong(((Number) (x2)).intValue())));
}

/**
 * The function fiat_Secp256K1_mulx_u32 is a multiplication, returning the full double-width result. <p>
 * <p>
 * Postconditions: <p>
 *   out1 = (arg1 * arg2) mod 2^32 <p>
 *   out2 = ⌊arg1 * arg2 / 2^32⌋ <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [0x0 ~&gt; 0xffffffff] <p>
 *   arg2: [0x0 ~&gt; 0xffffffff] <p>
 * Output Bounds: <p>
 *   out1: [0x0 ~&gt; 0xffffffff] <p>
 *   out2: [0x0 ~&gt; 0xffffffff] <p>
 */
static void fiat_Secp256K1_mulx_u32(Box<Integer> out1, Box<Integer> out2, int arg1, int arg2) {
  long x1 = ((long) Integer.toUnsignedLong(((Number) (arg1)).intValue()) * (long) Integer.toUnsignedLong(((Number) (arg2)).intValue()));
  int x2 = ((int) Integer.toUnsignedLong(((Number) (x1)).intValue()) & 0xffffffff);
  int x3 = (int) Integer.toUnsignedLong(((Number) ((x1 >>> 32))).intValue());
  out1.set(x2);
  out2.set(x3);
}

/**
 * The function fiat_Secp256K1_cmovznz_u32 is a single-word conditional move. <p>
 * <p>
 * Postconditions: <p>
 *   out1 = (if arg1 = 0 then arg2 else arg3) <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [0x0 ~&gt; 0x1] <p>
 *   arg2: [0x0 ~&gt; 0xffffffff] <p>
 *   arg3: [0x0 ~&gt; 0xffffffff] <p>
 * Output Bounds: <p>
 *   out1: [0x0 ~&gt; 0xffffffff] <p>
 */
static void fiat_Secp256K1_cmovznz_u32(Box<Integer> out1, int arg1, int arg2, int arg3) {
  int x1 = (arg1 * 0xffffffff);
  int x2 = ((x1 & arg3) | ((~x1) & arg2));
  out1.set(x2);
}

/**
 * The function fiat_Secp256K1_mul multiplies two field elements in the Montgomery domain. <p>
 * <p>
 * Preconditions: <p>
 *   0 ≤ eval arg1 &lt; m <p>
 *   0 ≤ eval arg2 &lt; m <p>
 * Postconditions: <p>
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m <p>
 *   0 ≤ eval out1 &lt; m <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 *   arg2: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_mul(int[] out1, final int[] arg1, final int[] arg2) {
  int x1 = (arg1[1]);
  int x2 = (arg1[2]);
  int x3 = (arg1[3]);
  int x4 = (arg1[4]);
  int x5 = (arg1[5]);
  int x6 = (arg1[6]);
  int x7 = (arg1[7]);
  int x8 = (arg1[0]);
  Box<Integer> x9 = new Box<Integer>((int)0);
  Box<Integer> x10 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x9, x10, x8, (arg2[7]));
  Box<Integer> x11 = new Box<Integer>((int)0);
  Box<Integer> x12 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x11, x12, x8, (arg2[6]));
  Box<Integer> x13 = new Box<Integer>((int)0);
  Box<Integer> x14 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x13, x14, x8, (arg2[5]));
  Box<Integer> x15 = new Box<Integer>((int)0);
  Box<Integer> x16 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x15, x16, x8, (arg2[4]));
  Box<Integer> x17 = new Box<Integer>((int)0);
  Box<Integer> x18 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x17, x18, x8, (arg2[3]));
  Box<Integer> x19 = new Box<Integer>((int)0);
  Box<Integer> x20 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x19, x20, x8, (arg2[2]));
  Box<Integer> x21 = new Box<Integer>((int)0);
  Box<Integer> x22 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x21, x22, x8, (arg2[1]));
  Box<Integer> x23 = new Box<Integer>((int)0);
  Box<Integer> x24 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x23, x24, x8, (arg2[0]));
  Box<Integer> x25 = new Box<Integer>((int)0);
  Box<Integer> x26 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x25, x26, 0x0, (x24).get(), (x21).get());
  Box<Integer> x27 = new Box<Integer>((int)0);
  Box<Integer> x28 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x27, x28, (x26).get(), (x22).get(), (x19).get());
  Box<Integer> x29 = new Box<Integer>((int)0);
  Box<Integer> x30 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x29, x30, (x28).get(), (x20).get(), (x17).get());
  Box<Integer> x31 = new Box<Integer>((int)0);
  Box<Integer> x32 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x31, x32, (x30).get(), (x18).get(), (x15).get());
  Box<Integer> x33 = new Box<Integer>((int)0);
  Box<Integer> x34 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x33, x34, (x32).get(), (x16).get(), (x13).get());
  Box<Integer> x35 = new Box<Integer>((int)0);
  Box<Integer> x36 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x35, x36, (x34).get(), (x14).get(), (x11).get());
  Box<Integer> x37 = new Box<Integer>((int)0);
  Box<Integer> x38 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x37, x38, (x36).get(), (x12).get(), (x9).get());
  int x39 = ((x38).get() + (x10).get());
  Box<Integer> x40 = new Box<Integer>((int)0);
  Box<Integer> x41 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x40, x41, (x23).get(), 0xd2253531);
  Box<Integer> x42 = new Box<Integer>((int)0);
  Box<Integer> x43 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x42, x43, (x40).get(), 0xffffffff);
  Box<Integer> x44 = new Box<Integer>((int)0);
  Box<Integer> x45 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x44, x45, (x40).get(), 0xffffffff);
  Box<Integer> x46 = new Box<Integer>((int)0);
  Box<Integer> x47 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x46, x47, (x40).get(), 0xffffffff);
  Box<Integer> x48 = new Box<Integer>((int)0);
  Box<Integer> x49 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x48, x49, (x40).get(), 0xffffffff);
  Box<Integer> x50 = new Box<Integer>((int)0);
  Box<Integer> x51 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x50, x51, (x40).get(), 0xffffffff);
  Box<Integer> x52 = new Box<Integer>((int)0);
  Box<Integer> x53 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x52, x53, (x40).get(), 0xffffffff);
  Box<Integer> x54 = new Box<Integer>((int)0);
  Box<Integer> x55 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x54, x55, (x40).get(), 0xfffffffe);
  Box<Integer> x56 = new Box<Integer>((int)0);
  Box<Integer> x57 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x56, x57, (x40).get(), 0xfffffc2f);
  Box<Integer> x58 = new Box<Integer>((int)0);
  Box<Integer> x59 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x58, x59, 0x0, (x57).get(), (x54).get());
  Box<Integer> x60 = new Box<Integer>((int)0);
  Box<Integer> x61 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x60, x61, (x59).get(), (x55).get(), (x52).get());
  Box<Integer> x62 = new Box<Integer>((int)0);
  Box<Integer> x63 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x62, x63, (x61).get(), (x53).get(), (x50).get());
  Box<Integer> x64 = new Box<Integer>((int)0);
  Box<Integer> x65 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x64, x65, (x63).get(), (x51).get(), (x48).get());
  Box<Integer> x66 = new Box<Integer>((int)0);
  Box<Integer> x67 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x66, x67, (x65).get(), (x49).get(), (x46).get());
  Box<Integer> x68 = new Box<Integer>((int)0);
  Box<Integer> x69 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x68, x69, (x67).get(), (x47).get(), (x44).get());
  Box<Integer> x70 = new Box<Integer>((int)0);
  Box<Integer> x71 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x70, x71, (x69).get(), (x45).get(), (x42).get());
  int x72 = ((x71).get() + (x43).get());
  Box<Integer> x73 = new Box<Integer>((int)0);
  Box<Integer> x74 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x73, x74, 0x0, (x23).get(), (x56).get());
  Box<Integer> x75 = new Box<Integer>((int)0);
  Box<Integer> x76 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x75, x76, (x74).get(), (x25).get(), (x58).get());
  Box<Integer> x77 = new Box<Integer>((int)0);
  Box<Integer> x78 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x77, x78, (x76).get(), (x27).get(), (x60).get());
  Box<Integer> x79 = new Box<Integer>((int)0);
  Box<Integer> x80 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x79, x80, (x78).get(), (x29).get(), (x62).get());
  Box<Integer> x81 = new Box<Integer>((int)0);
  Box<Integer> x82 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x81, x82, (x80).get(), (x31).get(), (x64).get());
  Box<Integer> x83 = new Box<Integer>((int)0);
  Box<Integer> x84 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x83, x84, (x82).get(), (x33).get(), (x66).get());
  Box<Integer> x85 = new Box<Integer>((int)0);
  Box<Integer> x86 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x85, x86, (x84).get(), (x35).get(), (x68).get());
  Box<Integer> x87 = new Box<Integer>((int)0);
  Box<Integer> x88 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x87, x88, (x86).get(), (x37).get(), (x70).get());
  Box<Integer> x89 = new Box<Integer>((int)0);
  Box<Integer> x90 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x89, x90, (x88).get(), x39, x72);
  Box<Integer> x91 = new Box<Integer>((int)0);
  Box<Integer> x92 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x91, x92, x1, (arg2[7]));
  Box<Integer> x93 = new Box<Integer>((int)0);
  Box<Integer> x94 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x93, x94, x1, (arg2[6]));
  Box<Integer> x95 = new Box<Integer>((int)0);
  Box<Integer> x96 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x95, x96, x1, (arg2[5]));
  Box<Integer> x97 = new Box<Integer>((int)0);
  Box<Integer> x98 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x97, x98, x1, (arg2[4]));
  Box<Integer> x99 = new Box<Integer>((int)0);
  Box<Integer> x100 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x99, x100, x1, (arg2[3]));
  Box<Integer> x101 = new Box<Integer>((int)0);
  Box<Integer> x102 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x101, x102, x1, (arg2[2]));
  Box<Integer> x103 = new Box<Integer>((int)0);
  Box<Integer> x104 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x103, x104, x1, (arg2[1]));
  Box<Integer> x105 = new Box<Integer>((int)0);
  Box<Integer> x106 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x105, x106, x1, (arg2[0]));
  Box<Integer> x107 = new Box<Integer>((int)0);
  Box<Integer> x108 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x107, x108, 0x0, (x106).get(), (x103).get());
  Box<Integer> x109 = new Box<Integer>((int)0);
  Box<Integer> x110 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x109, x110, (x108).get(), (x104).get(), (x101).get());
  Box<Integer> x111 = new Box<Integer>((int)0);
  Box<Integer> x112 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x111, x112, (x110).get(), (x102).get(), (x99).get());
  Box<Integer> x113 = new Box<Integer>((int)0);
  Box<Integer> x114 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x113, x114, (x112).get(), (x100).get(), (x97).get());
  Box<Integer> x115 = new Box<Integer>((int)0);
  Box<Integer> x116 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x115, x116, (x114).get(), (x98).get(), (x95).get());
  Box<Integer> x117 = new Box<Integer>((int)0);
  Box<Integer> x118 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x117, x118, (x116).get(), (x96).get(), (x93).get());
  Box<Integer> x119 = new Box<Integer>((int)0);
  Box<Integer> x120 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x119, x120, (x118).get(), (x94).get(), (x91).get());
  int x121 = ((x120).get() + (x92).get());
  Box<Integer> x122 = new Box<Integer>((int)0);
  Box<Integer> x123 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x122, x123, 0x0, (x75).get(), (x105).get());
  Box<Integer> x124 = new Box<Integer>((int)0);
  Box<Integer> x125 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x124, x125, (x123).get(), (x77).get(), (x107).get());
  Box<Integer> x126 = new Box<Integer>((int)0);
  Box<Integer> x127 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x126, x127, (x125).get(), (x79).get(), (x109).get());
  Box<Integer> x128 = new Box<Integer>((int)0);
  Box<Integer> x129 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x128, x129, (x127).get(), (x81).get(), (x111).get());
  Box<Integer> x130 = new Box<Integer>((int)0);
  Box<Integer> x131 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x130, x131, (x129).get(), (x83).get(), (x113).get());
  Box<Integer> x132 = new Box<Integer>((int)0);
  Box<Integer> x133 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x132, x133, (x131).get(), (x85).get(), (x115).get());
  Box<Integer> x134 = new Box<Integer>((int)0);
  Box<Integer> x135 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x134, x135, (x133).get(), (x87).get(), (x117).get());
  Box<Integer> x136 = new Box<Integer>((int)0);
  Box<Integer> x137 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x136, x137, (x135).get(), (x89).get(), (x119).get());
  Box<Integer> x138 = new Box<Integer>((int)0);
  Box<Integer> x139 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x138, x139, (x137).get(), (x90).get(), x121);
  Box<Integer> x140 = new Box<Integer>((int)0);
  Box<Integer> x141 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x140, x141, (x122).get(), 0xd2253531);
  Box<Integer> x142 = new Box<Integer>((int)0);
  Box<Integer> x143 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x142, x143, (x140).get(), 0xffffffff);
  Box<Integer> x144 = new Box<Integer>((int)0);
  Box<Integer> x145 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x144, x145, (x140).get(), 0xffffffff);
  Box<Integer> x146 = new Box<Integer>((int)0);
  Box<Integer> x147 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x146, x147, (x140).get(), 0xffffffff);
  Box<Integer> x148 = new Box<Integer>((int)0);
  Box<Integer> x149 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x148, x149, (x140).get(), 0xffffffff);
  Box<Integer> x150 = new Box<Integer>((int)0);
  Box<Integer> x151 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x150, x151, (x140).get(), 0xffffffff);
  Box<Integer> x152 = new Box<Integer>((int)0);
  Box<Integer> x153 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x152, x153, (x140).get(), 0xffffffff);
  Box<Integer> x154 = new Box<Integer>((int)0);
  Box<Integer> x155 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x154, x155, (x140).get(), 0xfffffffe);
  Box<Integer> x156 = new Box<Integer>((int)0);
  Box<Integer> x157 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x156, x157, (x140).get(), 0xfffffc2f);
  Box<Integer> x158 = new Box<Integer>((int)0);
  Box<Integer> x159 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x158, x159, 0x0, (x157).get(), (x154).get());
  Box<Integer> x160 = new Box<Integer>((int)0);
  Box<Integer> x161 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x160, x161, (x159).get(), (x155).get(), (x152).get());
  Box<Integer> x162 = new Box<Integer>((int)0);
  Box<Integer> x163 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x162, x163, (x161).get(), (x153).get(), (x150).get());
  Box<Integer> x164 = new Box<Integer>((int)0);
  Box<Integer> x165 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x164, x165, (x163).get(), (x151).get(), (x148).get());
  Box<Integer> x166 = new Box<Integer>((int)0);
  Box<Integer> x167 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x166, x167, (x165).get(), (x149).get(), (x146).get());
  Box<Integer> x168 = new Box<Integer>((int)0);
  Box<Integer> x169 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x168, x169, (x167).get(), (x147).get(), (x144).get());
  Box<Integer> x170 = new Box<Integer>((int)0);
  Box<Integer> x171 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x170, x171, (x169).get(), (x145).get(), (x142).get());
  int x172 = ((x171).get() + (x143).get());
  Box<Integer> x173 = new Box<Integer>((int)0);
  Box<Integer> x174 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x173, x174, 0x0, (x122).get(), (x156).get());
  Box<Integer> x175 = new Box<Integer>((int)0);
  Box<Integer> x176 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x175, x176, (x174).get(), (x124).get(), (x158).get());
  Box<Integer> x177 = new Box<Integer>((int)0);
  Box<Integer> x178 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x177, x178, (x176).get(), (x126).get(), (x160).get());
  Box<Integer> x179 = new Box<Integer>((int)0);
  Box<Integer> x180 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x179, x180, (x178).get(), (x128).get(), (x162).get());
  Box<Integer> x181 = new Box<Integer>((int)0);
  Box<Integer> x182 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x181, x182, (x180).get(), (x130).get(), (x164).get());
  Box<Integer> x183 = new Box<Integer>((int)0);
  Box<Integer> x184 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x183, x184, (x182).get(), (x132).get(), (x166).get());
  Box<Integer> x185 = new Box<Integer>((int)0);
  Box<Integer> x186 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x185, x186, (x184).get(), (x134).get(), (x168).get());
  Box<Integer> x187 = new Box<Integer>((int)0);
  Box<Integer> x188 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x187, x188, (x186).get(), (x136).get(), (x170).get());
  Box<Integer> x189 = new Box<Integer>((int)0);
  Box<Integer> x190 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x189, x190, (x188).get(), (x138).get(), x172);
  int x191 = ((x190).get() + (x139).get());
  Box<Integer> x192 = new Box<Integer>((int)0);
  Box<Integer> x193 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x192, x193, x2, (arg2[7]));
  Box<Integer> x194 = new Box<Integer>((int)0);
  Box<Integer> x195 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x194, x195, x2, (arg2[6]));
  Box<Integer> x196 = new Box<Integer>((int)0);
  Box<Integer> x197 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x196, x197, x2, (arg2[5]));
  Box<Integer> x198 = new Box<Integer>((int)0);
  Box<Integer> x199 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x198, x199, x2, (arg2[4]));
  Box<Integer> x200 = new Box<Integer>((int)0);
  Box<Integer> x201 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x200, x201, x2, (arg2[3]));
  Box<Integer> x202 = new Box<Integer>((int)0);
  Box<Integer> x203 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x202, x203, x2, (arg2[2]));
  Box<Integer> x204 = new Box<Integer>((int)0);
  Box<Integer> x205 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x204, x205, x2, (arg2[1]));
  Box<Integer> x206 = new Box<Integer>((int)0);
  Box<Integer> x207 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x206, x207, x2, (arg2[0]));
  Box<Integer> x208 = new Box<Integer>((int)0);
  Box<Integer> x209 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x208, x209, 0x0, (x207).get(), (x204).get());
  Box<Integer> x210 = new Box<Integer>((int)0);
  Box<Integer> x211 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x210, x211, (x209).get(), (x205).get(), (x202).get());
  Box<Integer> x212 = new Box<Integer>((int)0);
  Box<Integer> x213 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x212, x213, (x211).get(), (x203).get(), (x200).get());
  Box<Integer> x214 = new Box<Integer>((int)0);
  Box<Integer> x215 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x214, x215, (x213).get(), (x201).get(), (x198).get());
  Box<Integer> x216 = new Box<Integer>((int)0);
  Box<Integer> x217 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x216, x217, (x215).get(), (x199).get(), (x196).get());
  Box<Integer> x218 = new Box<Integer>((int)0);
  Box<Integer> x219 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x218, x219, (x217).get(), (x197).get(), (x194).get());
  Box<Integer> x220 = new Box<Integer>((int)0);
  Box<Integer> x221 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x220, x221, (x219).get(), (x195).get(), (x192).get());
  int x222 = ((x221).get() + (x193).get());
  Box<Integer> x223 = new Box<Integer>((int)0);
  Box<Integer> x224 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x223, x224, 0x0, (x175).get(), (x206).get());
  Box<Integer> x225 = new Box<Integer>((int)0);
  Box<Integer> x226 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x225, x226, (x224).get(), (x177).get(), (x208).get());
  Box<Integer> x227 = new Box<Integer>((int)0);
  Box<Integer> x228 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x227, x228, (x226).get(), (x179).get(), (x210).get());
  Box<Integer> x229 = new Box<Integer>((int)0);
  Box<Integer> x230 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x229, x230, (x228).get(), (x181).get(), (x212).get());
  Box<Integer> x231 = new Box<Integer>((int)0);
  Box<Integer> x232 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x231, x232, (x230).get(), (x183).get(), (x214).get());
  Box<Integer> x233 = new Box<Integer>((int)0);
  Box<Integer> x234 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x233, x234, (x232).get(), (x185).get(), (x216).get());
  Box<Integer> x235 = new Box<Integer>((int)0);
  Box<Integer> x236 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x235, x236, (x234).get(), (x187).get(), (x218).get());
  Box<Integer> x237 = new Box<Integer>((int)0);
  Box<Integer> x238 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x237, x238, (x236).get(), (x189).get(), (x220).get());
  Box<Integer> x239 = new Box<Integer>((int)0);
  Box<Integer> x240 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x239, x240, (x238).get(), x191, x222);
  Box<Integer> x241 = new Box<Integer>((int)0);
  Box<Integer> x242 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x241, x242, (x223).get(), 0xd2253531);
  Box<Integer> x243 = new Box<Integer>((int)0);
  Box<Integer> x244 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x243, x244, (x241).get(), 0xffffffff);
  Box<Integer> x245 = new Box<Integer>((int)0);
  Box<Integer> x246 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x245, x246, (x241).get(), 0xffffffff);
  Box<Integer> x247 = new Box<Integer>((int)0);
  Box<Integer> x248 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x247, x248, (x241).get(), 0xffffffff);
  Box<Integer> x249 = new Box<Integer>((int)0);
  Box<Integer> x250 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x249, x250, (x241).get(), 0xffffffff);
  Box<Integer> x251 = new Box<Integer>((int)0);
  Box<Integer> x252 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x251, x252, (x241).get(), 0xffffffff);
  Box<Integer> x253 = new Box<Integer>((int)0);
  Box<Integer> x254 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x253, x254, (x241).get(), 0xffffffff);
  Box<Integer> x255 = new Box<Integer>((int)0);
  Box<Integer> x256 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x255, x256, (x241).get(), 0xfffffffe);
  Box<Integer> x257 = new Box<Integer>((int)0);
  Box<Integer> x258 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x257, x258, (x241).get(), 0xfffffc2f);
  Box<Integer> x259 = new Box<Integer>((int)0);
  Box<Integer> x260 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x259, x260, 0x0, (x258).get(), (x255).get());
  Box<Integer> x261 = new Box<Integer>((int)0);
  Box<Integer> x262 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x261, x262, (x260).get(), (x256).get(), (x253).get());
  Box<Integer> x263 = new Box<Integer>((int)0);
  Box<Integer> x264 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x263, x264, (x262).get(), (x254).get(), (x251).get());
  Box<Integer> x265 = new Box<Integer>((int)0);
  Box<Integer> x266 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x265, x266, (x264).get(), (x252).get(), (x249).get());
  Box<Integer> x267 = new Box<Integer>((int)0);
  Box<Integer> x268 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x267, x268, (x266).get(), (x250).get(), (x247).get());
  Box<Integer> x269 = new Box<Integer>((int)0);
  Box<Integer> x270 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x269, x270, (x268).get(), (x248).get(), (x245).get());
  Box<Integer> x271 = new Box<Integer>((int)0);
  Box<Integer> x272 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x271, x272, (x270).get(), (x246).get(), (x243).get());
  int x273 = ((x272).get() + (x244).get());
  Box<Integer> x274 = new Box<Integer>((int)0);
  Box<Integer> x275 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x274, x275, 0x0, (x223).get(), (x257).get());
  Box<Integer> x276 = new Box<Integer>((int)0);
  Box<Integer> x277 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x276, x277, (x275).get(), (x225).get(), (x259).get());
  Box<Integer> x278 = new Box<Integer>((int)0);
  Box<Integer> x279 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x278, x279, (x277).get(), (x227).get(), (x261).get());
  Box<Integer> x280 = new Box<Integer>((int)0);
  Box<Integer> x281 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x280, x281, (x279).get(), (x229).get(), (x263).get());
  Box<Integer> x282 = new Box<Integer>((int)0);
  Box<Integer> x283 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x282, x283, (x281).get(), (x231).get(), (x265).get());
  Box<Integer> x284 = new Box<Integer>((int)0);
  Box<Integer> x285 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x284, x285, (x283).get(), (x233).get(), (x267).get());
  Box<Integer> x286 = new Box<Integer>((int)0);
  Box<Integer> x287 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x286, x287, (x285).get(), (x235).get(), (x269).get());
  Box<Integer> x288 = new Box<Integer>((int)0);
  Box<Integer> x289 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x288, x289, (x287).get(), (x237).get(), (x271).get());
  Box<Integer> x290 = new Box<Integer>((int)0);
  Box<Integer> x291 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x290, x291, (x289).get(), (x239).get(), x273);
  int x292 = ((x291).get() + (x240).get());
  Box<Integer> x293 = new Box<Integer>((int)0);
  Box<Integer> x294 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x293, x294, x3, (arg2[7]));
  Box<Integer> x295 = new Box<Integer>((int)0);
  Box<Integer> x296 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x295, x296, x3, (arg2[6]));
  Box<Integer> x297 = new Box<Integer>((int)0);
  Box<Integer> x298 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x297, x298, x3, (arg2[5]));
  Box<Integer> x299 = new Box<Integer>((int)0);
  Box<Integer> x300 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x299, x300, x3, (arg2[4]));
  Box<Integer> x301 = new Box<Integer>((int)0);
  Box<Integer> x302 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x301, x302, x3, (arg2[3]));
  Box<Integer> x303 = new Box<Integer>((int)0);
  Box<Integer> x304 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x303, x304, x3, (arg2[2]));
  Box<Integer> x305 = new Box<Integer>((int)0);
  Box<Integer> x306 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x305, x306, x3, (arg2[1]));
  Box<Integer> x307 = new Box<Integer>((int)0);
  Box<Integer> x308 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x307, x308, x3, (arg2[0]));
  Box<Integer> x309 = new Box<Integer>((int)0);
  Box<Integer> x310 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x309, x310, 0x0, (x308).get(), (x305).get());
  Box<Integer> x311 = new Box<Integer>((int)0);
  Box<Integer> x312 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x311, x312, (x310).get(), (x306).get(), (x303).get());
  Box<Integer> x313 = new Box<Integer>((int)0);
  Box<Integer> x314 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x313, x314, (x312).get(), (x304).get(), (x301).get());
  Box<Integer> x315 = new Box<Integer>((int)0);
  Box<Integer> x316 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x315, x316, (x314).get(), (x302).get(), (x299).get());
  Box<Integer> x317 = new Box<Integer>((int)0);
  Box<Integer> x318 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x317, x318, (x316).get(), (x300).get(), (x297).get());
  Box<Integer> x319 = new Box<Integer>((int)0);
  Box<Integer> x320 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x319, x320, (x318).get(), (x298).get(), (x295).get());
  Box<Integer> x321 = new Box<Integer>((int)0);
  Box<Integer> x322 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x321, x322, (x320).get(), (x296).get(), (x293).get());
  int x323 = ((x322).get() + (x294).get());
  Box<Integer> x324 = new Box<Integer>((int)0);
  Box<Integer> x325 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x324, x325, 0x0, (x276).get(), (x307).get());
  Box<Integer> x326 = new Box<Integer>((int)0);
  Box<Integer> x327 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x326, x327, (x325).get(), (x278).get(), (x309).get());
  Box<Integer> x328 = new Box<Integer>((int)0);
  Box<Integer> x329 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x328, x329, (x327).get(), (x280).get(), (x311).get());
  Box<Integer> x330 = new Box<Integer>((int)0);
  Box<Integer> x331 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x330, x331, (x329).get(), (x282).get(), (x313).get());
  Box<Integer> x332 = new Box<Integer>((int)0);
  Box<Integer> x333 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x332, x333, (x331).get(), (x284).get(), (x315).get());
  Box<Integer> x334 = new Box<Integer>((int)0);
  Box<Integer> x335 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x334, x335, (x333).get(), (x286).get(), (x317).get());
  Box<Integer> x336 = new Box<Integer>((int)0);
  Box<Integer> x337 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x336, x337, (x335).get(), (x288).get(), (x319).get());
  Box<Integer> x338 = new Box<Integer>((int)0);
  Box<Integer> x339 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x338, x339, (x337).get(), (x290).get(), (x321).get());
  Box<Integer> x340 = new Box<Integer>((int)0);
  Box<Integer> x341 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x340, x341, (x339).get(), x292, x323);
  Box<Integer> x342 = new Box<Integer>((int)0);
  Box<Integer> x343 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x342, x343, (x324).get(), 0xd2253531);
  Box<Integer> x344 = new Box<Integer>((int)0);
  Box<Integer> x345 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x344, x345, (x342).get(), 0xffffffff);
  Box<Integer> x346 = new Box<Integer>((int)0);
  Box<Integer> x347 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x346, x347, (x342).get(), 0xffffffff);
  Box<Integer> x348 = new Box<Integer>((int)0);
  Box<Integer> x349 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x348, x349, (x342).get(), 0xffffffff);
  Box<Integer> x350 = new Box<Integer>((int)0);
  Box<Integer> x351 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x350, x351, (x342).get(), 0xffffffff);
  Box<Integer> x352 = new Box<Integer>((int)0);
  Box<Integer> x353 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x352, x353, (x342).get(), 0xffffffff);
  Box<Integer> x354 = new Box<Integer>((int)0);
  Box<Integer> x355 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x354, x355, (x342).get(), 0xffffffff);
  Box<Integer> x356 = new Box<Integer>((int)0);
  Box<Integer> x357 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x356, x357, (x342).get(), 0xfffffffe);
  Box<Integer> x358 = new Box<Integer>((int)0);
  Box<Integer> x359 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x358, x359, (x342).get(), 0xfffffc2f);
  Box<Integer> x360 = new Box<Integer>((int)0);
  Box<Integer> x361 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x360, x361, 0x0, (x359).get(), (x356).get());
  Box<Integer> x362 = new Box<Integer>((int)0);
  Box<Integer> x363 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x362, x363, (x361).get(), (x357).get(), (x354).get());
  Box<Integer> x364 = new Box<Integer>((int)0);
  Box<Integer> x365 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x364, x365, (x363).get(), (x355).get(), (x352).get());
  Box<Integer> x366 = new Box<Integer>((int)0);
  Box<Integer> x367 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x366, x367, (x365).get(), (x353).get(), (x350).get());
  Box<Integer> x368 = new Box<Integer>((int)0);
  Box<Integer> x369 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x368, x369, (x367).get(), (x351).get(), (x348).get());
  Box<Integer> x370 = new Box<Integer>((int)0);
  Box<Integer> x371 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x370, x371, (x369).get(), (x349).get(), (x346).get());
  Box<Integer> x372 = new Box<Integer>((int)0);
  Box<Integer> x373 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x372, x373, (x371).get(), (x347).get(), (x344).get());
  int x374 = ((x373).get() + (x345).get());
  Box<Integer> x375 = new Box<Integer>((int)0);
  Box<Integer> x376 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x375, x376, 0x0, (x324).get(), (x358).get());
  Box<Integer> x377 = new Box<Integer>((int)0);
  Box<Integer> x378 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x377, x378, (x376).get(), (x326).get(), (x360).get());
  Box<Integer> x379 = new Box<Integer>((int)0);
  Box<Integer> x380 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x379, x380, (x378).get(), (x328).get(), (x362).get());
  Box<Integer> x381 = new Box<Integer>((int)0);
  Box<Integer> x382 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x381, x382, (x380).get(), (x330).get(), (x364).get());
  Box<Integer> x383 = new Box<Integer>((int)0);
  Box<Integer> x384 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x383, x384, (x382).get(), (x332).get(), (x366).get());
  Box<Integer> x385 = new Box<Integer>((int)0);
  Box<Integer> x386 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x385, x386, (x384).get(), (x334).get(), (x368).get());
  Box<Integer> x387 = new Box<Integer>((int)0);
  Box<Integer> x388 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x387, x388, (x386).get(), (x336).get(), (x370).get());
  Box<Integer> x389 = new Box<Integer>((int)0);
  Box<Integer> x390 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x389, x390, (x388).get(), (x338).get(), (x372).get());
  Box<Integer> x391 = new Box<Integer>((int)0);
  Box<Integer> x392 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x391, x392, (x390).get(), (x340).get(), x374);
  int x393 = ((x392).get() + (x341).get());
  Box<Integer> x394 = new Box<Integer>((int)0);
  Box<Integer> x395 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x394, x395, x4, (arg2[7]));
  Box<Integer> x396 = new Box<Integer>((int)0);
  Box<Integer> x397 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x396, x397, x4, (arg2[6]));
  Box<Integer> x398 = new Box<Integer>((int)0);
  Box<Integer> x399 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x398, x399, x4, (arg2[5]));
  Box<Integer> x400 = new Box<Integer>((int)0);
  Box<Integer> x401 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x400, x401, x4, (arg2[4]));
  Box<Integer> x402 = new Box<Integer>((int)0);
  Box<Integer> x403 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x402, x403, x4, (arg2[3]));
  Box<Integer> x404 = new Box<Integer>((int)0);
  Box<Integer> x405 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x404, x405, x4, (arg2[2]));
  Box<Integer> x406 = new Box<Integer>((int)0);
  Box<Integer> x407 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x406, x407, x4, (arg2[1]));
  Box<Integer> x408 = new Box<Integer>((int)0);
  Box<Integer> x409 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x408, x409, x4, (arg2[0]));
  Box<Integer> x410 = new Box<Integer>((int)0);
  Box<Integer> x411 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x410, x411, 0x0, (x409).get(), (x406).get());
  Box<Integer> x412 = new Box<Integer>((int)0);
  Box<Integer> x413 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x412, x413, (x411).get(), (x407).get(), (x404).get());
  Box<Integer> x414 = new Box<Integer>((int)0);
  Box<Integer> x415 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x414, x415, (x413).get(), (x405).get(), (x402).get());
  Box<Integer> x416 = new Box<Integer>((int)0);
  Box<Integer> x417 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x416, x417, (x415).get(), (x403).get(), (x400).get());
  Box<Integer> x418 = new Box<Integer>((int)0);
  Box<Integer> x419 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x418, x419, (x417).get(), (x401).get(), (x398).get());
  Box<Integer> x420 = new Box<Integer>((int)0);
  Box<Integer> x421 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x420, x421, (x419).get(), (x399).get(), (x396).get());
  Box<Integer> x422 = new Box<Integer>((int)0);
  Box<Integer> x423 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x422, x423, (x421).get(), (x397).get(), (x394).get());
  int x424 = ((x423).get() + (x395).get());
  Box<Integer> x425 = new Box<Integer>((int)0);
  Box<Integer> x426 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x425, x426, 0x0, (x377).get(), (x408).get());
  Box<Integer> x427 = new Box<Integer>((int)0);
  Box<Integer> x428 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x427, x428, (x426).get(), (x379).get(), (x410).get());
  Box<Integer> x429 = new Box<Integer>((int)0);
  Box<Integer> x430 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x429, x430, (x428).get(), (x381).get(), (x412).get());
  Box<Integer> x431 = new Box<Integer>((int)0);
  Box<Integer> x432 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x431, x432, (x430).get(), (x383).get(), (x414).get());
  Box<Integer> x433 = new Box<Integer>((int)0);
  Box<Integer> x434 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x433, x434, (x432).get(), (x385).get(), (x416).get());
  Box<Integer> x435 = new Box<Integer>((int)0);
  Box<Integer> x436 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x435, x436, (x434).get(), (x387).get(), (x418).get());
  Box<Integer> x437 = new Box<Integer>((int)0);
  Box<Integer> x438 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x437, x438, (x436).get(), (x389).get(), (x420).get());
  Box<Integer> x439 = new Box<Integer>((int)0);
  Box<Integer> x440 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x439, x440, (x438).get(), (x391).get(), (x422).get());
  Box<Integer> x441 = new Box<Integer>((int)0);
  Box<Integer> x442 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x441, x442, (x440).get(), x393, x424);
  Box<Integer> x443 = new Box<Integer>((int)0);
  Box<Integer> x444 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x443, x444, (x425).get(), 0xd2253531);
  Box<Integer> x445 = new Box<Integer>((int)0);
  Box<Integer> x446 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x445, x446, (x443).get(), 0xffffffff);
  Box<Integer> x447 = new Box<Integer>((int)0);
  Box<Integer> x448 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x447, x448, (x443).get(), 0xffffffff);
  Box<Integer> x449 = new Box<Integer>((int)0);
  Box<Integer> x450 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x449, x450, (x443).get(), 0xffffffff);
  Box<Integer> x451 = new Box<Integer>((int)0);
  Box<Integer> x452 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x451, x452, (x443).get(), 0xffffffff);
  Box<Integer> x453 = new Box<Integer>((int)0);
  Box<Integer> x454 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x453, x454, (x443).get(), 0xffffffff);
  Box<Integer> x455 = new Box<Integer>((int)0);
  Box<Integer> x456 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x455, x456, (x443).get(), 0xffffffff);
  Box<Integer> x457 = new Box<Integer>((int)0);
  Box<Integer> x458 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x457, x458, (x443).get(), 0xfffffffe);
  Box<Integer> x459 = new Box<Integer>((int)0);
  Box<Integer> x460 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x459, x460, (x443).get(), 0xfffffc2f);
  Box<Integer> x461 = new Box<Integer>((int)0);
  Box<Integer> x462 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x461, x462, 0x0, (x460).get(), (x457).get());
  Box<Integer> x463 = new Box<Integer>((int)0);
  Box<Integer> x464 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x463, x464, (x462).get(), (x458).get(), (x455).get());
  Box<Integer> x465 = new Box<Integer>((int)0);
  Box<Integer> x466 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x465, x466, (x464).get(), (x456).get(), (x453).get());
  Box<Integer> x467 = new Box<Integer>((int)0);
  Box<Integer> x468 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x467, x468, (x466).get(), (x454).get(), (x451).get());
  Box<Integer> x469 = new Box<Integer>((int)0);
  Box<Integer> x470 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x469, x470, (x468).get(), (x452).get(), (x449).get());
  Box<Integer> x471 = new Box<Integer>((int)0);
  Box<Integer> x472 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x471, x472, (x470).get(), (x450).get(), (x447).get());
  Box<Integer> x473 = new Box<Integer>((int)0);
  Box<Integer> x474 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x473, x474, (x472).get(), (x448).get(), (x445).get());
  int x475 = ((x474).get() + (x446).get());
  Box<Integer> x476 = new Box<Integer>((int)0);
  Box<Integer> x477 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x476, x477, 0x0, (x425).get(), (x459).get());
  Box<Integer> x478 = new Box<Integer>((int)0);
  Box<Integer> x479 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x478, x479, (x477).get(), (x427).get(), (x461).get());
  Box<Integer> x480 = new Box<Integer>((int)0);
  Box<Integer> x481 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x480, x481, (x479).get(), (x429).get(), (x463).get());
  Box<Integer> x482 = new Box<Integer>((int)0);
  Box<Integer> x483 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x482, x483, (x481).get(), (x431).get(), (x465).get());
  Box<Integer> x484 = new Box<Integer>((int)0);
  Box<Integer> x485 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x484, x485, (x483).get(), (x433).get(), (x467).get());
  Box<Integer> x486 = new Box<Integer>((int)0);
  Box<Integer> x487 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x486, x487, (x485).get(), (x435).get(), (x469).get());
  Box<Integer> x488 = new Box<Integer>((int)0);
  Box<Integer> x489 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x488, x489, (x487).get(), (x437).get(), (x471).get());
  Box<Integer> x490 = new Box<Integer>((int)0);
  Box<Integer> x491 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x490, x491, (x489).get(), (x439).get(), (x473).get());
  Box<Integer> x492 = new Box<Integer>((int)0);
  Box<Integer> x493 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x492, x493, (x491).get(), (x441).get(), x475);
  int x494 = ((x493).get() + (x442).get());
  Box<Integer> x495 = new Box<Integer>((int)0);
  Box<Integer> x496 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x495, x496, x5, (arg2[7]));
  Box<Integer> x497 = new Box<Integer>((int)0);
  Box<Integer> x498 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x497, x498, x5, (arg2[6]));
  Box<Integer> x499 = new Box<Integer>((int)0);
  Box<Integer> x500 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x499, x500, x5, (arg2[5]));
  Box<Integer> x501 = new Box<Integer>((int)0);
  Box<Integer> x502 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x501, x502, x5, (arg2[4]));
  Box<Integer> x503 = new Box<Integer>((int)0);
  Box<Integer> x504 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x503, x504, x5, (arg2[3]));
  Box<Integer> x505 = new Box<Integer>((int)0);
  Box<Integer> x506 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x505, x506, x5, (arg2[2]));
  Box<Integer> x507 = new Box<Integer>((int)0);
  Box<Integer> x508 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x507, x508, x5, (arg2[1]));
  Box<Integer> x509 = new Box<Integer>((int)0);
  Box<Integer> x510 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x509, x510, x5, (arg2[0]));
  Box<Integer> x511 = new Box<Integer>((int)0);
  Box<Integer> x512 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x511, x512, 0x0, (x510).get(), (x507).get());
  Box<Integer> x513 = new Box<Integer>((int)0);
  Box<Integer> x514 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x513, x514, (x512).get(), (x508).get(), (x505).get());
  Box<Integer> x515 = new Box<Integer>((int)0);
  Box<Integer> x516 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x515, x516, (x514).get(), (x506).get(), (x503).get());
  Box<Integer> x517 = new Box<Integer>((int)0);
  Box<Integer> x518 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x517, x518, (x516).get(), (x504).get(), (x501).get());
  Box<Integer> x519 = new Box<Integer>((int)0);
  Box<Integer> x520 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x519, x520, (x518).get(), (x502).get(), (x499).get());
  Box<Integer> x521 = new Box<Integer>((int)0);
  Box<Integer> x522 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x521, x522, (x520).get(), (x500).get(), (x497).get());
  Box<Integer> x523 = new Box<Integer>((int)0);
  Box<Integer> x524 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x523, x524, (x522).get(), (x498).get(), (x495).get());
  int x525 = ((x524).get() + (x496).get());
  Box<Integer> x526 = new Box<Integer>((int)0);
  Box<Integer> x527 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x526, x527, 0x0, (x478).get(), (x509).get());
  Box<Integer> x528 = new Box<Integer>((int)0);
  Box<Integer> x529 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x528, x529, (x527).get(), (x480).get(), (x511).get());
  Box<Integer> x530 = new Box<Integer>((int)0);
  Box<Integer> x531 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x530, x531, (x529).get(), (x482).get(), (x513).get());
  Box<Integer> x532 = new Box<Integer>((int)0);
  Box<Integer> x533 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x532, x533, (x531).get(), (x484).get(), (x515).get());
  Box<Integer> x534 = new Box<Integer>((int)0);
  Box<Integer> x535 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x534, x535, (x533).get(), (x486).get(), (x517).get());
  Box<Integer> x536 = new Box<Integer>((int)0);
  Box<Integer> x537 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x536, x537, (x535).get(), (x488).get(), (x519).get());
  Box<Integer> x538 = new Box<Integer>((int)0);
  Box<Integer> x539 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x538, x539, (x537).get(), (x490).get(), (x521).get());
  Box<Integer> x540 = new Box<Integer>((int)0);
  Box<Integer> x541 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x540, x541, (x539).get(), (x492).get(), (x523).get());
  Box<Integer> x542 = new Box<Integer>((int)0);
  Box<Integer> x543 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x542, x543, (x541).get(), x494, x525);
  Box<Integer> x544 = new Box<Integer>((int)0);
  Box<Integer> x545 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x544, x545, (x526).get(), 0xd2253531);
  Box<Integer> x546 = new Box<Integer>((int)0);
  Box<Integer> x547 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x546, x547, (x544).get(), 0xffffffff);
  Box<Integer> x548 = new Box<Integer>((int)0);
  Box<Integer> x549 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x548, x549, (x544).get(), 0xffffffff);
  Box<Integer> x550 = new Box<Integer>((int)0);
  Box<Integer> x551 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x550, x551, (x544).get(), 0xffffffff);
  Box<Integer> x552 = new Box<Integer>((int)0);
  Box<Integer> x553 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x552, x553, (x544).get(), 0xffffffff);
  Box<Integer> x554 = new Box<Integer>((int)0);
  Box<Integer> x555 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x554, x555, (x544).get(), 0xffffffff);
  Box<Integer> x556 = new Box<Integer>((int)0);
  Box<Integer> x557 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x556, x557, (x544).get(), 0xffffffff);
  Box<Integer> x558 = new Box<Integer>((int)0);
  Box<Integer> x559 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x558, x559, (x544).get(), 0xfffffffe);
  Box<Integer> x560 = new Box<Integer>((int)0);
  Box<Integer> x561 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x560, x561, (x544).get(), 0xfffffc2f);
  Box<Integer> x562 = new Box<Integer>((int)0);
  Box<Integer> x563 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x562, x563, 0x0, (x561).get(), (x558).get());
  Box<Integer> x564 = new Box<Integer>((int)0);
  Box<Integer> x565 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x564, x565, (x563).get(), (x559).get(), (x556).get());
  Box<Integer> x566 = new Box<Integer>((int)0);
  Box<Integer> x567 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x566, x567, (x565).get(), (x557).get(), (x554).get());
  Box<Integer> x568 = new Box<Integer>((int)0);
  Box<Integer> x569 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x568, x569, (x567).get(), (x555).get(), (x552).get());
  Box<Integer> x570 = new Box<Integer>((int)0);
  Box<Integer> x571 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x570, x571, (x569).get(), (x553).get(), (x550).get());
  Box<Integer> x572 = new Box<Integer>((int)0);
  Box<Integer> x573 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x572, x573, (x571).get(), (x551).get(), (x548).get());
  Box<Integer> x574 = new Box<Integer>((int)0);
  Box<Integer> x575 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x574, x575, (x573).get(), (x549).get(), (x546).get());
  int x576 = ((x575).get() + (x547).get());
  Box<Integer> x577 = new Box<Integer>((int)0);
  Box<Integer> x578 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x577, x578, 0x0, (x526).get(), (x560).get());
  Box<Integer> x579 = new Box<Integer>((int)0);
  Box<Integer> x580 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x579, x580, (x578).get(), (x528).get(), (x562).get());
  Box<Integer> x581 = new Box<Integer>((int)0);
  Box<Integer> x582 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x581, x582, (x580).get(), (x530).get(), (x564).get());
  Box<Integer> x583 = new Box<Integer>((int)0);
  Box<Integer> x584 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x583, x584, (x582).get(), (x532).get(), (x566).get());
  Box<Integer> x585 = new Box<Integer>((int)0);
  Box<Integer> x586 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x585, x586, (x584).get(), (x534).get(), (x568).get());
  Box<Integer> x587 = new Box<Integer>((int)0);
  Box<Integer> x588 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x587, x588, (x586).get(), (x536).get(), (x570).get());
  Box<Integer> x589 = new Box<Integer>((int)0);
  Box<Integer> x590 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x589, x590, (x588).get(), (x538).get(), (x572).get());
  Box<Integer> x591 = new Box<Integer>((int)0);
  Box<Integer> x592 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x591, x592, (x590).get(), (x540).get(), (x574).get());
  Box<Integer> x593 = new Box<Integer>((int)0);
  Box<Integer> x594 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x593, x594, (x592).get(), (x542).get(), x576);
  int x595 = ((x594).get() + (x543).get());
  Box<Integer> x596 = new Box<Integer>((int)0);
  Box<Integer> x597 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x596, x597, x6, (arg2[7]));
  Box<Integer> x598 = new Box<Integer>((int)0);
  Box<Integer> x599 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x598, x599, x6, (arg2[6]));
  Box<Integer> x600 = new Box<Integer>((int)0);
  Box<Integer> x601 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x600, x601, x6, (arg2[5]));
  Box<Integer> x602 = new Box<Integer>((int)0);
  Box<Integer> x603 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x602, x603, x6, (arg2[4]));
  Box<Integer> x604 = new Box<Integer>((int)0);
  Box<Integer> x605 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x604, x605, x6, (arg2[3]));
  Box<Integer> x606 = new Box<Integer>((int)0);
  Box<Integer> x607 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x606, x607, x6, (arg2[2]));
  Box<Integer> x608 = new Box<Integer>((int)0);
  Box<Integer> x609 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x608, x609, x6, (arg2[1]));
  Box<Integer> x610 = new Box<Integer>((int)0);
  Box<Integer> x611 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x610, x611, x6, (arg2[0]));
  Box<Integer> x612 = new Box<Integer>((int)0);
  Box<Integer> x613 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x612, x613, 0x0, (x611).get(), (x608).get());
  Box<Integer> x614 = new Box<Integer>((int)0);
  Box<Integer> x615 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x614, x615, (x613).get(), (x609).get(), (x606).get());
  Box<Integer> x616 = new Box<Integer>((int)0);
  Box<Integer> x617 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x616, x617, (x615).get(), (x607).get(), (x604).get());
  Box<Integer> x618 = new Box<Integer>((int)0);
  Box<Integer> x619 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x618, x619, (x617).get(), (x605).get(), (x602).get());
  Box<Integer> x620 = new Box<Integer>((int)0);
  Box<Integer> x621 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x620, x621, (x619).get(), (x603).get(), (x600).get());
  Box<Integer> x622 = new Box<Integer>((int)0);
  Box<Integer> x623 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x622, x623, (x621).get(), (x601).get(), (x598).get());
  Box<Integer> x624 = new Box<Integer>((int)0);
  Box<Integer> x625 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x624, x625, (x623).get(), (x599).get(), (x596).get());
  int x626 = ((x625).get() + (x597).get());
  Box<Integer> x627 = new Box<Integer>((int)0);
  Box<Integer> x628 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x627, x628, 0x0, (x579).get(), (x610).get());
  Box<Integer> x629 = new Box<Integer>((int)0);
  Box<Integer> x630 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x629, x630, (x628).get(), (x581).get(), (x612).get());
  Box<Integer> x631 = new Box<Integer>((int)0);
  Box<Integer> x632 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x631, x632, (x630).get(), (x583).get(), (x614).get());
  Box<Integer> x633 = new Box<Integer>((int)0);
  Box<Integer> x634 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x633, x634, (x632).get(), (x585).get(), (x616).get());
  Box<Integer> x635 = new Box<Integer>((int)0);
  Box<Integer> x636 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x635, x636, (x634).get(), (x587).get(), (x618).get());
  Box<Integer> x637 = new Box<Integer>((int)0);
  Box<Integer> x638 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x637, x638, (x636).get(), (x589).get(), (x620).get());
  Box<Integer> x639 = new Box<Integer>((int)0);
  Box<Integer> x640 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x639, x640, (x638).get(), (x591).get(), (x622).get());
  Box<Integer> x641 = new Box<Integer>((int)0);
  Box<Integer> x642 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x641, x642, (x640).get(), (x593).get(), (x624).get());
  Box<Integer> x643 = new Box<Integer>((int)0);
  Box<Integer> x644 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x643, x644, (x642).get(), x595, x626);
  Box<Integer> x645 = new Box<Integer>((int)0);
  Box<Integer> x646 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x645, x646, (x627).get(), 0xd2253531);
  Box<Integer> x647 = new Box<Integer>((int)0);
  Box<Integer> x648 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x647, x648, (x645).get(), 0xffffffff);
  Box<Integer> x649 = new Box<Integer>((int)0);
  Box<Integer> x650 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x649, x650, (x645).get(), 0xffffffff);
  Box<Integer> x651 = new Box<Integer>((int)0);
  Box<Integer> x652 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x651, x652, (x645).get(), 0xffffffff);
  Box<Integer> x653 = new Box<Integer>((int)0);
  Box<Integer> x654 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x653, x654, (x645).get(), 0xffffffff);
  Box<Integer> x655 = new Box<Integer>((int)0);
  Box<Integer> x656 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x655, x656, (x645).get(), 0xffffffff);
  Box<Integer> x657 = new Box<Integer>((int)0);
  Box<Integer> x658 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x657, x658, (x645).get(), 0xffffffff);
  Box<Integer> x659 = new Box<Integer>((int)0);
  Box<Integer> x660 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x659, x660, (x645).get(), 0xfffffffe);
  Box<Integer> x661 = new Box<Integer>((int)0);
  Box<Integer> x662 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x661, x662, (x645).get(), 0xfffffc2f);
  Box<Integer> x663 = new Box<Integer>((int)0);
  Box<Integer> x664 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x663, x664, 0x0, (x662).get(), (x659).get());
  Box<Integer> x665 = new Box<Integer>((int)0);
  Box<Integer> x666 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x665, x666, (x664).get(), (x660).get(), (x657).get());
  Box<Integer> x667 = new Box<Integer>((int)0);
  Box<Integer> x668 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x667, x668, (x666).get(), (x658).get(), (x655).get());
  Box<Integer> x669 = new Box<Integer>((int)0);
  Box<Integer> x670 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x669, x670, (x668).get(), (x656).get(), (x653).get());
  Box<Integer> x671 = new Box<Integer>((int)0);
  Box<Integer> x672 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x671, x672, (x670).get(), (x654).get(), (x651).get());
  Box<Integer> x673 = new Box<Integer>((int)0);
  Box<Integer> x674 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x673, x674, (x672).get(), (x652).get(), (x649).get());
  Box<Integer> x675 = new Box<Integer>((int)0);
  Box<Integer> x676 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x675, x676, (x674).get(), (x650).get(), (x647).get());
  int x677 = ((x676).get() + (x648).get());
  Box<Integer> x678 = new Box<Integer>((int)0);
  Box<Integer> x679 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x678, x679, 0x0, (x627).get(), (x661).get());
  Box<Integer> x680 = new Box<Integer>((int)0);
  Box<Integer> x681 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x680, x681, (x679).get(), (x629).get(), (x663).get());
  Box<Integer> x682 = new Box<Integer>((int)0);
  Box<Integer> x683 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x682, x683, (x681).get(), (x631).get(), (x665).get());
  Box<Integer> x684 = new Box<Integer>((int)0);
  Box<Integer> x685 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x684, x685, (x683).get(), (x633).get(), (x667).get());
  Box<Integer> x686 = new Box<Integer>((int)0);
  Box<Integer> x687 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x686, x687, (x685).get(), (x635).get(), (x669).get());
  Box<Integer> x688 = new Box<Integer>((int)0);
  Box<Integer> x689 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x688, x689, (x687).get(), (x637).get(), (x671).get());
  Box<Integer> x690 = new Box<Integer>((int)0);
  Box<Integer> x691 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x690, x691, (x689).get(), (x639).get(), (x673).get());
  Box<Integer> x692 = new Box<Integer>((int)0);
  Box<Integer> x693 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x692, x693, (x691).get(), (x641).get(), (x675).get());
  Box<Integer> x694 = new Box<Integer>((int)0);
  Box<Integer> x695 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x694, x695, (x693).get(), (x643).get(), x677);
  int x696 = ((x695).get() + (x644).get());
  Box<Integer> x697 = new Box<Integer>((int)0);
  Box<Integer> x698 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x697, x698, x7, (arg2[7]));
  Box<Integer> x699 = new Box<Integer>((int)0);
  Box<Integer> x700 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x699, x700, x7, (arg2[6]));
  Box<Integer> x701 = new Box<Integer>((int)0);
  Box<Integer> x702 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x701, x702, x7, (arg2[5]));
  Box<Integer> x703 = new Box<Integer>((int)0);
  Box<Integer> x704 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x703, x704, x7, (arg2[4]));
  Box<Integer> x705 = new Box<Integer>((int)0);
  Box<Integer> x706 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x705, x706, x7, (arg2[3]));
  Box<Integer> x707 = new Box<Integer>((int)0);
  Box<Integer> x708 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x707, x708, x7, (arg2[2]));
  Box<Integer> x709 = new Box<Integer>((int)0);
  Box<Integer> x710 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x709, x710, x7, (arg2[1]));
  Box<Integer> x711 = new Box<Integer>((int)0);
  Box<Integer> x712 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x711, x712, x7, (arg2[0]));
  Box<Integer> x713 = new Box<Integer>((int)0);
  Box<Integer> x714 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x713, x714, 0x0, (x712).get(), (x709).get());
  Box<Integer> x715 = new Box<Integer>((int)0);
  Box<Integer> x716 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x715, x716, (x714).get(), (x710).get(), (x707).get());
  Box<Integer> x717 = new Box<Integer>((int)0);
  Box<Integer> x718 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x717, x718, (x716).get(), (x708).get(), (x705).get());
  Box<Integer> x719 = new Box<Integer>((int)0);
  Box<Integer> x720 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x719, x720, (x718).get(), (x706).get(), (x703).get());
  Box<Integer> x721 = new Box<Integer>((int)0);
  Box<Integer> x722 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x721, x722, (x720).get(), (x704).get(), (x701).get());
  Box<Integer> x723 = new Box<Integer>((int)0);
  Box<Integer> x724 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x723, x724, (x722).get(), (x702).get(), (x699).get());
  Box<Integer> x725 = new Box<Integer>((int)0);
  Box<Integer> x726 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x725, x726, (x724).get(), (x700).get(), (x697).get());
  int x727 = ((x726).get() + (x698).get());
  Box<Integer> x728 = new Box<Integer>((int)0);
  Box<Integer> x729 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x728, x729, 0x0, (x680).get(), (x711).get());
  Box<Integer> x730 = new Box<Integer>((int)0);
  Box<Integer> x731 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x730, x731, (x729).get(), (x682).get(), (x713).get());
  Box<Integer> x732 = new Box<Integer>((int)0);
  Box<Integer> x733 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x732, x733, (x731).get(), (x684).get(), (x715).get());
  Box<Integer> x734 = new Box<Integer>((int)0);
  Box<Integer> x735 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x734, x735, (x733).get(), (x686).get(), (x717).get());
  Box<Integer> x736 = new Box<Integer>((int)0);
  Box<Integer> x737 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x736, x737, (x735).get(), (x688).get(), (x719).get());
  Box<Integer> x738 = new Box<Integer>((int)0);
  Box<Integer> x739 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x738, x739, (x737).get(), (x690).get(), (x721).get());
  Box<Integer> x740 = new Box<Integer>((int)0);
  Box<Integer> x741 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x740, x741, (x739).get(), (x692).get(), (x723).get());
  Box<Integer> x742 = new Box<Integer>((int)0);
  Box<Integer> x743 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x742, x743, (x741).get(), (x694).get(), (x725).get());
  Box<Integer> x744 = new Box<Integer>((int)0);
  Box<Integer> x745 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x744, x745, (x743).get(), x696, x727);
  Box<Integer> x746 = new Box<Integer>((int)0);
  Box<Integer> x747 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x746, x747, (x728).get(), 0xd2253531);
  Box<Integer> x748 = new Box<Integer>((int)0);
  Box<Integer> x749 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x748, x749, (x746).get(), 0xffffffff);
  Box<Integer> x750 = new Box<Integer>((int)0);
  Box<Integer> x751 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x750, x751, (x746).get(), 0xffffffff);
  Box<Integer> x752 = new Box<Integer>((int)0);
  Box<Integer> x753 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x752, x753, (x746).get(), 0xffffffff);
  Box<Integer> x754 = new Box<Integer>((int)0);
  Box<Integer> x755 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x754, x755, (x746).get(), 0xffffffff);
  Box<Integer> x756 = new Box<Integer>((int)0);
  Box<Integer> x757 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x756, x757, (x746).get(), 0xffffffff);
  Box<Integer> x758 = new Box<Integer>((int)0);
  Box<Integer> x759 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x758, x759, (x746).get(), 0xffffffff);
  Box<Integer> x760 = new Box<Integer>((int)0);
  Box<Integer> x761 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x760, x761, (x746).get(), 0xfffffffe);
  Box<Integer> x762 = new Box<Integer>((int)0);
  Box<Integer> x763 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x762, x763, (x746).get(), 0xfffffc2f);
  Box<Integer> x764 = new Box<Integer>((int)0);
  Box<Integer> x765 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x764, x765, 0x0, (x763).get(), (x760).get());
  Box<Integer> x766 = new Box<Integer>((int)0);
  Box<Integer> x767 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x766, x767, (x765).get(), (x761).get(), (x758).get());
  Box<Integer> x768 = new Box<Integer>((int)0);
  Box<Integer> x769 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x768, x769, (x767).get(), (x759).get(), (x756).get());
  Box<Integer> x770 = new Box<Integer>((int)0);
  Box<Integer> x771 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x770, x771, (x769).get(), (x757).get(), (x754).get());
  Box<Integer> x772 = new Box<Integer>((int)0);
  Box<Integer> x773 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x772, x773, (x771).get(), (x755).get(), (x752).get());
  Box<Integer> x774 = new Box<Integer>((int)0);
  Box<Integer> x775 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x774, x775, (x773).get(), (x753).get(), (x750).get());
  Box<Integer> x776 = new Box<Integer>((int)0);
  Box<Integer> x777 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x776, x777, (x775).get(), (x751).get(), (x748).get());
  int x778 = ((x777).get() + (x749).get());
  Box<Integer> x779 = new Box<Integer>((int)0);
  Box<Integer> x780 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x779, x780, 0x0, (x728).get(), (x762).get());
  Box<Integer> x781 = new Box<Integer>((int)0);
  Box<Integer> x782 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x781, x782, (x780).get(), (x730).get(), (x764).get());
  Box<Integer> x783 = new Box<Integer>((int)0);
  Box<Integer> x784 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x783, x784, (x782).get(), (x732).get(), (x766).get());
  Box<Integer> x785 = new Box<Integer>((int)0);
  Box<Integer> x786 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x785, x786, (x784).get(), (x734).get(), (x768).get());
  Box<Integer> x787 = new Box<Integer>((int)0);
  Box<Integer> x788 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x787, x788, (x786).get(), (x736).get(), (x770).get());
  Box<Integer> x789 = new Box<Integer>((int)0);
  Box<Integer> x790 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x789, x790, (x788).get(), (x738).get(), (x772).get());
  Box<Integer> x791 = new Box<Integer>((int)0);
  Box<Integer> x792 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x791, x792, (x790).get(), (x740).get(), (x774).get());
  Box<Integer> x793 = new Box<Integer>((int)0);
  Box<Integer> x794 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x793, x794, (x792).get(), (x742).get(), (x776).get());
  Box<Integer> x795 = new Box<Integer>((int)0);
  Box<Integer> x796 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x795, x796, (x794).get(), (x744).get(), x778);
  int x797 = ((x796).get() + (x745).get());
  Box<Integer> x798 = new Box<Integer>((int)0);
  Box<Integer> x799 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x798, x799, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x781).get(), 0xfffffc2f);
  Box<Integer> x800 = new Box<Integer>((int)0);
  Box<Integer> x801 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x800, x801, (x799).get(), (x783).get(), 0xfffffffe);
  Box<Integer> x802 = new Box<Integer>((int)0);
  Box<Integer> x803 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x802, x803, (x801).get(), (x785).get(), 0xffffffff);
  Box<Integer> x804 = new Box<Integer>((int)0);
  Box<Integer> x805 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x804, x805, (x803).get(), (x787).get(), 0xffffffff);
  Box<Integer> x806 = new Box<Integer>((int)0);
  Box<Integer> x807 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x806, x807, (x805).get(), (x789).get(), 0xffffffff);
  Box<Integer> x808 = new Box<Integer>((int)0);
  Box<Integer> x809 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x808, x809, (x807).get(), (x791).get(), 0xffffffff);
  Box<Integer> x810 = new Box<Integer>((int)0);
  Box<Integer> x811 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x810, x811, (x809).get(), (x793).get(), 0xffffffff);
  Box<Integer> x812 = new Box<Integer>((int)0);
  Box<Integer> x813 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x812, x813, (x811).get(), (x795).get(), 0xffffffff);
  Box<Integer> x814 = new Box<Integer>((int)0);
  Box<Integer> x815 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x814, x815, (x813).get(), x797, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x816 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x816, (x815).get(), (x798).get(), (x781).get());
  Box<Integer> x817 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x817, (x815).get(), (x800).get(), (x783).get());
  Box<Integer> x818 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x818, (x815).get(), (x802).get(), (x785).get());
  Box<Integer> x819 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x819, (x815).get(), (x804).get(), (x787).get());
  Box<Integer> x820 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x820, (x815).get(), (x806).get(), (x789).get());
  Box<Integer> x821 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x821, (x815).get(), (x808).get(), (x791).get());
  Box<Integer> x822 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x822, (x815).get(), (x810).get(), (x793).get());
  Box<Integer> x823 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x823, (x815).get(), (x812).get(), (x795).get());
  out1[0] = (x816).get();
  out1[1] = (x817).get();
  out1[2] = (x818).get();
  out1[3] = (x819).get();
  out1[4] = (x820).get();
  out1[5] = (x821).get();
  out1[6] = (x822).get();
  out1[7] = (x823).get();
}

/**
 * The function fiat_Secp256K1_square squares a field element in the Montgomery domain. <p>
 * <p>
 * Preconditions: <p>
 *   0 ≤ eval arg1 &lt; m <p>
 * Postconditions: <p>
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m <p>
 *   0 ≤ eval out1 &lt; m <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_square(int[] out1, final int[] arg1) {
  int x1 = (arg1[1]);
  int x2 = (arg1[2]);
  int x3 = (arg1[3]);
  int x4 = (arg1[4]);
  int x5 = (arg1[5]);
  int x6 = (arg1[6]);
  int x7 = (arg1[7]);
  int x8 = (arg1[0]);
  Box<Integer> x9 = new Box<Integer>((int)0);
  Box<Integer> x10 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x9, x10, x8, (arg1[7]));
  Box<Integer> x11 = new Box<Integer>((int)0);
  Box<Integer> x12 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x11, x12, x8, (arg1[6]));
  Box<Integer> x13 = new Box<Integer>((int)0);
  Box<Integer> x14 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x13, x14, x8, (arg1[5]));
  Box<Integer> x15 = new Box<Integer>((int)0);
  Box<Integer> x16 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x15, x16, x8, (arg1[4]));
  Box<Integer> x17 = new Box<Integer>((int)0);
  Box<Integer> x18 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x17, x18, x8, (arg1[3]));
  Box<Integer> x19 = new Box<Integer>((int)0);
  Box<Integer> x20 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x19, x20, x8, (arg1[2]));
  Box<Integer> x21 = new Box<Integer>((int)0);
  Box<Integer> x22 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x21, x22, x8, (arg1[1]));
  Box<Integer> x23 = new Box<Integer>((int)0);
  Box<Integer> x24 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x23, x24, x8, (arg1[0]));
  Box<Integer> x25 = new Box<Integer>((int)0);
  Box<Integer> x26 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x25, x26, 0x0, (x24).get(), (x21).get());
  Box<Integer> x27 = new Box<Integer>((int)0);
  Box<Integer> x28 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x27, x28, (x26).get(), (x22).get(), (x19).get());
  Box<Integer> x29 = new Box<Integer>((int)0);
  Box<Integer> x30 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x29, x30, (x28).get(), (x20).get(), (x17).get());
  Box<Integer> x31 = new Box<Integer>((int)0);
  Box<Integer> x32 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x31, x32, (x30).get(), (x18).get(), (x15).get());
  Box<Integer> x33 = new Box<Integer>((int)0);
  Box<Integer> x34 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x33, x34, (x32).get(), (x16).get(), (x13).get());
  Box<Integer> x35 = new Box<Integer>((int)0);
  Box<Integer> x36 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x35, x36, (x34).get(), (x14).get(), (x11).get());
  Box<Integer> x37 = new Box<Integer>((int)0);
  Box<Integer> x38 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x37, x38, (x36).get(), (x12).get(), (x9).get());
  int x39 = ((x38).get() + (x10).get());
  Box<Integer> x40 = new Box<Integer>((int)0);
  Box<Integer> x41 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x40, x41, (x23).get(), 0xd2253531);
  Box<Integer> x42 = new Box<Integer>((int)0);
  Box<Integer> x43 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x42, x43, (x40).get(), 0xffffffff);
  Box<Integer> x44 = new Box<Integer>((int)0);
  Box<Integer> x45 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x44, x45, (x40).get(), 0xffffffff);
  Box<Integer> x46 = new Box<Integer>((int)0);
  Box<Integer> x47 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x46, x47, (x40).get(), 0xffffffff);
  Box<Integer> x48 = new Box<Integer>((int)0);
  Box<Integer> x49 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x48, x49, (x40).get(), 0xffffffff);
  Box<Integer> x50 = new Box<Integer>((int)0);
  Box<Integer> x51 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x50, x51, (x40).get(), 0xffffffff);
  Box<Integer> x52 = new Box<Integer>((int)0);
  Box<Integer> x53 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x52, x53, (x40).get(), 0xffffffff);
  Box<Integer> x54 = new Box<Integer>((int)0);
  Box<Integer> x55 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x54, x55, (x40).get(), 0xfffffffe);
  Box<Integer> x56 = new Box<Integer>((int)0);
  Box<Integer> x57 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x56, x57, (x40).get(), 0xfffffc2f);
  Box<Integer> x58 = new Box<Integer>((int)0);
  Box<Integer> x59 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x58, x59, 0x0, (x57).get(), (x54).get());
  Box<Integer> x60 = new Box<Integer>((int)0);
  Box<Integer> x61 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x60, x61, (x59).get(), (x55).get(), (x52).get());
  Box<Integer> x62 = new Box<Integer>((int)0);
  Box<Integer> x63 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x62, x63, (x61).get(), (x53).get(), (x50).get());
  Box<Integer> x64 = new Box<Integer>((int)0);
  Box<Integer> x65 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x64, x65, (x63).get(), (x51).get(), (x48).get());
  Box<Integer> x66 = new Box<Integer>((int)0);
  Box<Integer> x67 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x66, x67, (x65).get(), (x49).get(), (x46).get());
  Box<Integer> x68 = new Box<Integer>((int)0);
  Box<Integer> x69 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x68, x69, (x67).get(), (x47).get(), (x44).get());
  Box<Integer> x70 = new Box<Integer>((int)0);
  Box<Integer> x71 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x70, x71, (x69).get(), (x45).get(), (x42).get());
  int x72 = ((x71).get() + (x43).get());
  Box<Integer> x73 = new Box<Integer>((int)0);
  Box<Integer> x74 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x73, x74, 0x0, (x23).get(), (x56).get());
  Box<Integer> x75 = new Box<Integer>((int)0);
  Box<Integer> x76 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x75, x76, (x74).get(), (x25).get(), (x58).get());
  Box<Integer> x77 = new Box<Integer>((int)0);
  Box<Integer> x78 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x77, x78, (x76).get(), (x27).get(), (x60).get());
  Box<Integer> x79 = new Box<Integer>((int)0);
  Box<Integer> x80 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x79, x80, (x78).get(), (x29).get(), (x62).get());
  Box<Integer> x81 = new Box<Integer>((int)0);
  Box<Integer> x82 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x81, x82, (x80).get(), (x31).get(), (x64).get());
  Box<Integer> x83 = new Box<Integer>((int)0);
  Box<Integer> x84 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x83, x84, (x82).get(), (x33).get(), (x66).get());
  Box<Integer> x85 = new Box<Integer>((int)0);
  Box<Integer> x86 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x85, x86, (x84).get(), (x35).get(), (x68).get());
  Box<Integer> x87 = new Box<Integer>((int)0);
  Box<Integer> x88 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x87, x88, (x86).get(), (x37).get(), (x70).get());
  Box<Integer> x89 = new Box<Integer>((int)0);
  Box<Integer> x90 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x89, x90, (x88).get(), x39, x72);
  Box<Integer> x91 = new Box<Integer>((int)0);
  Box<Integer> x92 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x91, x92, x1, (arg1[7]));
  Box<Integer> x93 = new Box<Integer>((int)0);
  Box<Integer> x94 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x93, x94, x1, (arg1[6]));
  Box<Integer> x95 = new Box<Integer>((int)0);
  Box<Integer> x96 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x95, x96, x1, (arg1[5]));
  Box<Integer> x97 = new Box<Integer>((int)0);
  Box<Integer> x98 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x97, x98, x1, (arg1[4]));
  Box<Integer> x99 = new Box<Integer>((int)0);
  Box<Integer> x100 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x99, x100, x1, (arg1[3]));
  Box<Integer> x101 = new Box<Integer>((int)0);
  Box<Integer> x102 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x101, x102, x1, (arg1[2]));
  Box<Integer> x103 = new Box<Integer>((int)0);
  Box<Integer> x104 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x103, x104, x1, (arg1[1]));
  Box<Integer> x105 = new Box<Integer>((int)0);
  Box<Integer> x106 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x105, x106, x1, (arg1[0]));
  Box<Integer> x107 = new Box<Integer>((int)0);
  Box<Integer> x108 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x107, x108, 0x0, (x106).get(), (x103).get());
  Box<Integer> x109 = new Box<Integer>((int)0);
  Box<Integer> x110 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x109, x110, (x108).get(), (x104).get(), (x101).get());
  Box<Integer> x111 = new Box<Integer>((int)0);
  Box<Integer> x112 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x111, x112, (x110).get(), (x102).get(), (x99).get());
  Box<Integer> x113 = new Box<Integer>((int)0);
  Box<Integer> x114 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x113, x114, (x112).get(), (x100).get(), (x97).get());
  Box<Integer> x115 = new Box<Integer>((int)0);
  Box<Integer> x116 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x115, x116, (x114).get(), (x98).get(), (x95).get());
  Box<Integer> x117 = new Box<Integer>((int)0);
  Box<Integer> x118 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x117, x118, (x116).get(), (x96).get(), (x93).get());
  Box<Integer> x119 = new Box<Integer>((int)0);
  Box<Integer> x120 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x119, x120, (x118).get(), (x94).get(), (x91).get());
  int x121 = ((x120).get() + (x92).get());
  Box<Integer> x122 = new Box<Integer>((int)0);
  Box<Integer> x123 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x122, x123, 0x0, (x75).get(), (x105).get());
  Box<Integer> x124 = new Box<Integer>((int)0);
  Box<Integer> x125 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x124, x125, (x123).get(), (x77).get(), (x107).get());
  Box<Integer> x126 = new Box<Integer>((int)0);
  Box<Integer> x127 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x126, x127, (x125).get(), (x79).get(), (x109).get());
  Box<Integer> x128 = new Box<Integer>((int)0);
  Box<Integer> x129 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x128, x129, (x127).get(), (x81).get(), (x111).get());
  Box<Integer> x130 = new Box<Integer>((int)0);
  Box<Integer> x131 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x130, x131, (x129).get(), (x83).get(), (x113).get());
  Box<Integer> x132 = new Box<Integer>((int)0);
  Box<Integer> x133 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x132, x133, (x131).get(), (x85).get(), (x115).get());
  Box<Integer> x134 = new Box<Integer>((int)0);
  Box<Integer> x135 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x134, x135, (x133).get(), (x87).get(), (x117).get());
  Box<Integer> x136 = new Box<Integer>((int)0);
  Box<Integer> x137 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x136, x137, (x135).get(), (x89).get(), (x119).get());
  Box<Integer> x138 = new Box<Integer>((int)0);
  Box<Integer> x139 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x138, x139, (x137).get(), (x90).get(), x121);
  Box<Integer> x140 = new Box<Integer>((int)0);
  Box<Integer> x141 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x140, x141, (x122).get(), 0xd2253531);
  Box<Integer> x142 = new Box<Integer>((int)0);
  Box<Integer> x143 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x142, x143, (x140).get(), 0xffffffff);
  Box<Integer> x144 = new Box<Integer>((int)0);
  Box<Integer> x145 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x144, x145, (x140).get(), 0xffffffff);
  Box<Integer> x146 = new Box<Integer>((int)0);
  Box<Integer> x147 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x146, x147, (x140).get(), 0xffffffff);
  Box<Integer> x148 = new Box<Integer>((int)0);
  Box<Integer> x149 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x148, x149, (x140).get(), 0xffffffff);
  Box<Integer> x150 = new Box<Integer>((int)0);
  Box<Integer> x151 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x150, x151, (x140).get(), 0xffffffff);
  Box<Integer> x152 = new Box<Integer>((int)0);
  Box<Integer> x153 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x152, x153, (x140).get(), 0xffffffff);
  Box<Integer> x154 = new Box<Integer>((int)0);
  Box<Integer> x155 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x154, x155, (x140).get(), 0xfffffffe);
  Box<Integer> x156 = new Box<Integer>((int)0);
  Box<Integer> x157 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x156, x157, (x140).get(), 0xfffffc2f);
  Box<Integer> x158 = new Box<Integer>((int)0);
  Box<Integer> x159 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x158, x159, 0x0, (x157).get(), (x154).get());
  Box<Integer> x160 = new Box<Integer>((int)0);
  Box<Integer> x161 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x160, x161, (x159).get(), (x155).get(), (x152).get());
  Box<Integer> x162 = new Box<Integer>((int)0);
  Box<Integer> x163 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x162, x163, (x161).get(), (x153).get(), (x150).get());
  Box<Integer> x164 = new Box<Integer>((int)0);
  Box<Integer> x165 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x164, x165, (x163).get(), (x151).get(), (x148).get());
  Box<Integer> x166 = new Box<Integer>((int)0);
  Box<Integer> x167 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x166, x167, (x165).get(), (x149).get(), (x146).get());
  Box<Integer> x168 = new Box<Integer>((int)0);
  Box<Integer> x169 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x168, x169, (x167).get(), (x147).get(), (x144).get());
  Box<Integer> x170 = new Box<Integer>((int)0);
  Box<Integer> x171 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x170, x171, (x169).get(), (x145).get(), (x142).get());
  int x172 = ((x171).get() + (x143).get());
  Box<Integer> x173 = new Box<Integer>((int)0);
  Box<Integer> x174 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x173, x174, 0x0, (x122).get(), (x156).get());
  Box<Integer> x175 = new Box<Integer>((int)0);
  Box<Integer> x176 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x175, x176, (x174).get(), (x124).get(), (x158).get());
  Box<Integer> x177 = new Box<Integer>((int)0);
  Box<Integer> x178 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x177, x178, (x176).get(), (x126).get(), (x160).get());
  Box<Integer> x179 = new Box<Integer>((int)0);
  Box<Integer> x180 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x179, x180, (x178).get(), (x128).get(), (x162).get());
  Box<Integer> x181 = new Box<Integer>((int)0);
  Box<Integer> x182 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x181, x182, (x180).get(), (x130).get(), (x164).get());
  Box<Integer> x183 = new Box<Integer>((int)0);
  Box<Integer> x184 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x183, x184, (x182).get(), (x132).get(), (x166).get());
  Box<Integer> x185 = new Box<Integer>((int)0);
  Box<Integer> x186 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x185, x186, (x184).get(), (x134).get(), (x168).get());
  Box<Integer> x187 = new Box<Integer>((int)0);
  Box<Integer> x188 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x187, x188, (x186).get(), (x136).get(), (x170).get());
  Box<Integer> x189 = new Box<Integer>((int)0);
  Box<Integer> x190 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x189, x190, (x188).get(), (x138).get(), x172);
  int x191 = ((x190).get() + (x139).get());
  Box<Integer> x192 = new Box<Integer>((int)0);
  Box<Integer> x193 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x192, x193, x2, (arg1[7]));
  Box<Integer> x194 = new Box<Integer>((int)0);
  Box<Integer> x195 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x194, x195, x2, (arg1[6]));
  Box<Integer> x196 = new Box<Integer>((int)0);
  Box<Integer> x197 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x196, x197, x2, (arg1[5]));
  Box<Integer> x198 = new Box<Integer>((int)0);
  Box<Integer> x199 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x198, x199, x2, (arg1[4]));
  Box<Integer> x200 = new Box<Integer>((int)0);
  Box<Integer> x201 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x200, x201, x2, (arg1[3]));
  Box<Integer> x202 = new Box<Integer>((int)0);
  Box<Integer> x203 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x202, x203, x2, (arg1[2]));
  Box<Integer> x204 = new Box<Integer>((int)0);
  Box<Integer> x205 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x204, x205, x2, (arg1[1]));
  Box<Integer> x206 = new Box<Integer>((int)0);
  Box<Integer> x207 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x206, x207, x2, (arg1[0]));
  Box<Integer> x208 = new Box<Integer>((int)0);
  Box<Integer> x209 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x208, x209, 0x0, (x207).get(), (x204).get());
  Box<Integer> x210 = new Box<Integer>((int)0);
  Box<Integer> x211 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x210, x211, (x209).get(), (x205).get(), (x202).get());
  Box<Integer> x212 = new Box<Integer>((int)0);
  Box<Integer> x213 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x212, x213, (x211).get(), (x203).get(), (x200).get());
  Box<Integer> x214 = new Box<Integer>((int)0);
  Box<Integer> x215 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x214, x215, (x213).get(), (x201).get(), (x198).get());
  Box<Integer> x216 = new Box<Integer>((int)0);
  Box<Integer> x217 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x216, x217, (x215).get(), (x199).get(), (x196).get());
  Box<Integer> x218 = new Box<Integer>((int)0);
  Box<Integer> x219 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x218, x219, (x217).get(), (x197).get(), (x194).get());
  Box<Integer> x220 = new Box<Integer>((int)0);
  Box<Integer> x221 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x220, x221, (x219).get(), (x195).get(), (x192).get());
  int x222 = ((x221).get() + (x193).get());
  Box<Integer> x223 = new Box<Integer>((int)0);
  Box<Integer> x224 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x223, x224, 0x0, (x175).get(), (x206).get());
  Box<Integer> x225 = new Box<Integer>((int)0);
  Box<Integer> x226 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x225, x226, (x224).get(), (x177).get(), (x208).get());
  Box<Integer> x227 = new Box<Integer>((int)0);
  Box<Integer> x228 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x227, x228, (x226).get(), (x179).get(), (x210).get());
  Box<Integer> x229 = new Box<Integer>((int)0);
  Box<Integer> x230 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x229, x230, (x228).get(), (x181).get(), (x212).get());
  Box<Integer> x231 = new Box<Integer>((int)0);
  Box<Integer> x232 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x231, x232, (x230).get(), (x183).get(), (x214).get());
  Box<Integer> x233 = new Box<Integer>((int)0);
  Box<Integer> x234 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x233, x234, (x232).get(), (x185).get(), (x216).get());
  Box<Integer> x235 = new Box<Integer>((int)0);
  Box<Integer> x236 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x235, x236, (x234).get(), (x187).get(), (x218).get());
  Box<Integer> x237 = new Box<Integer>((int)0);
  Box<Integer> x238 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x237, x238, (x236).get(), (x189).get(), (x220).get());
  Box<Integer> x239 = new Box<Integer>((int)0);
  Box<Integer> x240 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x239, x240, (x238).get(), x191, x222);
  Box<Integer> x241 = new Box<Integer>((int)0);
  Box<Integer> x242 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x241, x242, (x223).get(), 0xd2253531);
  Box<Integer> x243 = new Box<Integer>((int)0);
  Box<Integer> x244 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x243, x244, (x241).get(), 0xffffffff);
  Box<Integer> x245 = new Box<Integer>((int)0);
  Box<Integer> x246 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x245, x246, (x241).get(), 0xffffffff);
  Box<Integer> x247 = new Box<Integer>((int)0);
  Box<Integer> x248 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x247, x248, (x241).get(), 0xffffffff);
  Box<Integer> x249 = new Box<Integer>((int)0);
  Box<Integer> x250 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x249, x250, (x241).get(), 0xffffffff);
  Box<Integer> x251 = new Box<Integer>((int)0);
  Box<Integer> x252 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x251, x252, (x241).get(), 0xffffffff);
  Box<Integer> x253 = new Box<Integer>((int)0);
  Box<Integer> x254 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x253, x254, (x241).get(), 0xffffffff);
  Box<Integer> x255 = new Box<Integer>((int)0);
  Box<Integer> x256 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x255, x256, (x241).get(), 0xfffffffe);
  Box<Integer> x257 = new Box<Integer>((int)0);
  Box<Integer> x258 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x257, x258, (x241).get(), 0xfffffc2f);
  Box<Integer> x259 = new Box<Integer>((int)0);
  Box<Integer> x260 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x259, x260, 0x0, (x258).get(), (x255).get());
  Box<Integer> x261 = new Box<Integer>((int)0);
  Box<Integer> x262 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x261, x262, (x260).get(), (x256).get(), (x253).get());
  Box<Integer> x263 = new Box<Integer>((int)0);
  Box<Integer> x264 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x263, x264, (x262).get(), (x254).get(), (x251).get());
  Box<Integer> x265 = new Box<Integer>((int)0);
  Box<Integer> x266 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x265, x266, (x264).get(), (x252).get(), (x249).get());
  Box<Integer> x267 = new Box<Integer>((int)0);
  Box<Integer> x268 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x267, x268, (x266).get(), (x250).get(), (x247).get());
  Box<Integer> x269 = new Box<Integer>((int)0);
  Box<Integer> x270 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x269, x270, (x268).get(), (x248).get(), (x245).get());
  Box<Integer> x271 = new Box<Integer>((int)0);
  Box<Integer> x272 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x271, x272, (x270).get(), (x246).get(), (x243).get());
  int x273 = ((x272).get() + (x244).get());
  Box<Integer> x274 = new Box<Integer>((int)0);
  Box<Integer> x275 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x274, x275, 0x0, (x223).get(), (x257).get());
  Box<Integer> x276 = new Box<Integer>((int)0);
  Box<Integer> x277 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x276, x277, (x275).get(), (x225).get(), (x259).get());
  Box<Integer> x278 = new Box<Integer>((int)0);
  Box<Integer> x279 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x278, x279, (x277).get(), (x227).get(), (x261).get());
  Box<Integer> x280 = new Box<Integer>((int)0);
  Box<Integer> x281 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x280, x281, (x279).get(), (x229).get(), (x263).get());
  Box<Integer> x282 = new Box<Integer>((int)0);
  Box<Integer> x283 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x282, x283, (x281).get(), (x231).get(), (x265).get());
  Box<Integer> x284 = new Box<Integer>((int)0);
  Box<Integer> x285 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x284, x285, (x283).get(), (x233).get(), (x267).get());
  Box<Integer> x286 = new Box<Integer>((int)0);
  Box<Integer> x287 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x286, x287, (x285).get(), (x235).get(), (x269).get());
  Box<Integer> x288 = new Box<Integer>((int)0);
  Box<Integer> x289 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x288, x289, (x287).get(), (x237).get(), (x271).get());
  Box<Integer> x290 = new Box<Integer>((int)0);
  Box<Integer> x291 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x290, x291, (x289).get(), (x239).get(), x273);
  int x292 = ((x291).get() + (x240).get());
  Box<Integer> x293 = new Box<Integer>((int)0);
  Box<Integer> x294 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x293, x294, x3, (arg1[7]));
  Box<Integer> x295 = new Box<Integer>((int)0);
  Box<Integer> x296 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x295, x296, x3, (arg1[6]));
  Box<Integer> x297 = new Box<Integer>((int)0);
  Box<Integer> x298 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x297, x298, x3, (arg1[5]));
  Box<Integer> x299 = new Box<Integer>((int)0);
  Box<Integer> x300 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x299, x300, x3, (arg1[4]));
  Box<Integer> x301 = new Box<Integer>((int)0);
  Box<Integer> x302 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x301, x302, x3, (arg1[3]));
  Box<Integer> x303 = new Box<Integer>((int)0);
  Box<Integer> x304 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x303, x304, x3, (arg1[2]));
  Box<Integer> x305 = new Box<Integer>((int)0);
  Box<Integer> x306 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x305, x306, x3, (arg1[1]));
  Box<Integer> x307 = new Box<Integer>((int)0);
  Box<Integer> x308 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x307, x308, x3, (arg1[0]));
  Box<Integer> x309 = new Box<Integer>((int)0);
  Box<Integer> x310 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x309, x310, 0x0, (x308).get(), (x305).get());
  Box<Integer> x311 = new Box<Integer>((int)0);
  Box<Integer> x312 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x311, x312, (x310).get(), (x306).get(), (x303).get());
  Box<Integer> x313 = new Box<Integer>((int)0);
  Box<Integer> x314 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x313, x314, (x312).get(), (x304).get(), (x301).get());
  Box<Integer> x315 = new Box<Integer>((int)0);
  Box<Integer> x316 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x315, x316, (x314).get(), (x302).get(), (x299).get());
  Box<Integer> x317 = new Box<Integer>((int)0);
  Box<Integer> x318 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x317, x318, (x316).get(), (x300).get(), (x297).get());
  Box<Integer> x319 = new Box<Integer>((int)0);
  Box<Integer> x320 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x319, x320, (x318).get(), (x298).get(), (x295).get());
  Box<Integer> x321 = new Box<Integer>((int)0);
  Box<Integer> x322 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x321, x322, (x320).get(), (x296).get(), (x293).get());
  int x323 = ((x322).get() + (x294).get());
  Box<Integer> x324 = new Box<Integer>((int)0);
  Box<Integer> x325 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x324, x325, 0x0, (x276).get(), (x307).get());
  Box<Integer> x326 = new Box<Integer>((int)0);
  Box<Integer> x327 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x326, x327, (x325).get(), (x278).get(), (x309).get());
  Box<Integer> x328 = new Box<Integer>((int)0);
  Box<Integer> x329 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x328, x329, (x327).get(), (x280).get(), (x311).get());
  Box<Integer> x330 = new Box<Integer>((int)0);
  Box<Integer> x331 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x330, x331, (x329).get(), (x282).get(), (x313).get());
  Box<Integer> x332 = new Box<Integer>((int)0);
  Box<Integer> x333 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x332, x333, (x331).get(), (x284).get(), (x315).get());
  Box<Integer> x334 = new Box<Integer>((int)0);
  Box<Integer> x335 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x334, x335, (x333).get(), (x286).get(), (x317).get());
  Box<Integer> x336 = new Box<Integer>((int)0);
  Box<Integer> x337 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x336, x337, (x335).get(), (x288).get(), (x319).get());
  Box<Integer> x338 = new Box<Integer>((int)0);
  Box<Integer> x339 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x338, x339, (x337).get(), (x290).get(), (x321).get());
  Box<Integer> x340 = new Box<Integer>((int)0);
  Box<Integer> x341 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x340, x341, (x339).get(), x292, x323);
  Box<Integer> x342 = new Box<Integer>((int)0);
  Box<Integer> x343 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x342, x343, (x324).get(), 0xd2253531);
  Box<Integer> x344 = new Box<Integer>((int)0);
  Box<Integer> x345 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x344, x345, (x342).get(), 0xffffffff);
  Box<Integer> x346 = new Box<Integer>((int)0);
  Box<Integer> x347 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x346, x347, (x342).get(), 0xffffffff);
  Box<Integer> x348 = new Box<Integer>((int)0);
  Box<Integer> x349 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x348, x349, (x342).get(), 0xffffffff);
  Box<Integer> x350 = new Box<Integer>((int)0);
  Box<Integer> x351 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x350, x351, (x342).get(), 0xffffffff);
  Box<Integer> x352 = new Box<Integer>((int)0);
  Box<Integer> x353 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x352, x353, (x342).get(), 0xffffffff);
  Box<Integer> x354 = new Box<Integer>((int)0);
  Box<Integer> x355 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x354, x355, (x342).get(), 0xffffffff);
  Box<Integer> x356 = new Box<Integer>((int)0);
  Box<Integer> x357 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x356, x357, (x342).get(), 0xfffffffe);
  Box<Integer> x358 = new Box<Integer>((int)0);
  Box<Integer> x359 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x358, x359, (x342).get(), 0xfffffc2f);
  Box<Integer> x360 = new Box<Integer>((int)0);
  Box<Integer> x361 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x360, x361, 0x0, (x359).get(), (x356).get());
  Box<Integer> x362 = new Box<Integer>((int)0);
  Box<Integer> x363 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x362, x363, (x361).get(), (x357).get(), (x354).get());
  Box<Integer> x364 = new Box<Integer>((int)0);
  Box<Integer> x365 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x364, x365, (x363).get(), (x355).get(), (x352).get());
  Box<Integer> x366 = new Box<Integer>((int)0);
  Box<Integer> x367 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x366, x367, (x365).get(), (x353).get(), (x350).get());
  Box<Integer> x368 = new Box<Integer>((int)0);
  Box<Integer> x369 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x368, x369, (x367).get(), (x351).get(), (x348).get());
  Box<Integer> x370 = new Box<Integer>((int)0);
  Box<Integer> x371 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x370, x371, (x369).get(), (x349).get(), (x346).get());
  Box<Integer> x372 = new Box<Integer>((int)0);
  Box<Integer> x373 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x372, x373, (x371).get(), (x347).get(), (x344).get());
  int x374 = ((x373).get() + (x345).get());
  Box<Integer> x375 = new Box<Integer>((int)0);
  Box<Integer> x376 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x375, x376, 0x0, (x324).get(), (x358).get());
  Box<Integer> x377 = new Box<Integer>((int)0);
  Box<Integer> x378 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x377, x378, (x376).get(), (x326).get(), (x360).get());
  Box<Integer> x379 = new Box<Integer>((int)0);
  Box<Integer> x380 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x379, x380, (x378).get(), (x328).get(), (x362).get());
  Box<Integer> x381 = new Box<Integer>((int)0);
  Box<Integer> x382 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x381, x382, (x380).get(), (x330).get(), (x364).get());
  Box<Integer> x383 = new Box<Integer>((int)0);
  Box<Integer> x384 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x383, x384, (x382).get(), (x332).get(), (x366).get());
  Box<Integer> x385 = new Box<Integer>((int)0);
  Box<Integer> x386 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x385, x386, (x384).get(), (x334).get(), (x368).get());
  Box<Integer> x387 = new Box<Integer>((int)0);
  Box<Integer> x388 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x387, x388, (x386).get(), (x336).get(), (x370).get());
  Box<Integer> x389 = new Box<Integer>((int)0);
  Box<Integer> x390 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x389, x390, (x388).get(), (x338).get(), (x372).get());
  Box<Integer> x391 = new Box<Integer>((int)0);
  Box<Integer> x392 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x391, x392, (x390).get(), (x340).get(), x374);
  int x393 = ((x392).get() + (x341).get());
  Box<Integer> x394 = new Box<Integer>((int)0);
  Box<Integer> x395 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x394, x395, x4, (arg1[7]));
  Box<Integer> x396 = new Box<Integer>((int)0);
  Box<Integer> x397 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x396, x397, x4, (arg1[6]));
  Box<Integer> x398 = new Box<Integer>((int)0);
  Box<Integer> x399 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x398, x399, x4, (arg1[5]));
  Box<Integer> x400 = new Box<Integer>((int)0);
  Box<Integer> x401 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x400, x401, x4, (arg1[4]));
  Box<Integer> x402 = new Box<Integer>((int)0);
  Box<Integer> x403 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x402, x403, x4, (arg1[3]));
  Box<Integer> x404 = new Box<Integer>((int)0);
  Box<Integer> x405 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x404, x405, x4, (arg1[2]));
  Box<Integer> x406 = new Box<Integer>((int)0);
  Box<Integer> x407 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x406, x407, x4, (arg1[1]));
  Box<Integer> x408 = new Box<Integer>((int)0);
  Box<Integer> x409 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x408, x409, x4, (arg1[0]));
  Box<Integer> x410 = new Box<Integer>((int)0);
  Box<Integer> x411 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x410, x411, 0x0, (x409).get(), (x406).get());
  Box<Integer> x412 = new Box<Integer>((int)0);
  Box<Integer> x413 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x412, x413, (x411).get(), (x407).get(), (x404).get());
  Box<Integer> x414 = new Box<Integer>((int)0);
  Box<Integer> x415 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x414, x415, (x413).get(), (x405).get(), (x402).get());
  Box<Integer> x416 = new Box<Integer>((int)0);
  Box<Integer> x417 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x416, x417, (x415).get(), (x403).get(), (x400).get());
  Box<Integer> x418 = new Box<Integer>((int)0);
  Box<Integer> x419 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x418, x419, (x417).get(), (x401).get(), (x398).get());
  Box<Integer> x420 = new Box<Integer>((int)0);
  Box<Integer> x421 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x420, x421, (x419).get(), (x399).get(), (x396).get());
  Box<Integer> x422 = new Box<Integer>((int)0);
  Box<Integer> x423 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x422, x423, (x421).get(), (x397).get(), (x394).get());
  int x424 = ((x423).get() + (x395).get());
  Box<Integer> x425 = new Box<Integer>((int)0);
  Box<Integer> x426 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x425, x426, 0x0, (x377).get(), (x408).get());
  Box<Integer> x427 = new Box<Integer>((int)0);
  Box<Integer> x428 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x427, x428, (x426).get(), (x379).get(), (x410).get());
  Box<Integer> x429 = new Box<Integer>((int)0);
  Box<Integer> x430 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x429, x430, (x428).get(), (x381).get(), (x412).get());
  Box<Integer> x431 = new Box<Integer>((int)0);
  Box<Integer> x432 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x431, x432, (x430).get(), (x383).get(), (x414).get());
  Box<Integer> x433 = new Box<Integer>((int)0);
  Box<Integer> x434 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x433, x434, (x432).get(), (x385).get(), (x416).get());
  Box<Integer> x435 = new Box<Integer>((int)0);
  Box<Integer> x436 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x435, x436, (x434).get(), (x387).get(), (x418).get());
  Box<Integer> x437 = new Box<Integer>((int)0);
  Box<Integer> x438 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x437, x438, (x436).get(), (x389).get(), (x420).get());
  Box<Integer> x439 = new Box<Integer>((int)0);
  Box<Integer> x440 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x439, x440, (x438).get(), (x391).get(), (x422).get());
  Box<Integer> x441 = new Box<Integer>((int)0);
  Box<Integer> x442 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x441, x442, (x440).get(), x393, x424);
  Box<Integer> x443 = new Box<Integer>((int)0);
  Box<Integer> x444 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x443, x444, (x425).get(), 0xd2253531);
  Box<Integer> x445 = new Box<Integer>((int)0);
  Box<Integer> x446 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x445, x446, (x443).get(), 0xffffffff);
  Box<Integer> x447 = new Box<Integer>((int)0);
  Box<Integer> x448 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x447, x448, (x443).get(), 0xffffffff);
  Box<Integer> x449 = new Box<Integer>((int)0);
  Box<Integer> x450 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x449, x450, (x443).get(), 0xffffffff);
  Box<Integer> x451 = new Box<Integer>((int)0);
  Box<Integer> x452 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x451, x452, (x443).get(), 0xffffffff);
  Box<Integer> x453 = new Box<Integer>((int)0);
  Box<Integer> x454 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x453, x454, (x443).get(), 0xffffffff);
  Box<Integer> x455 = new Box<Integer>((int)0);
  Box<Integer> x456 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x455, x456, (x443).get(), 0xffffffff);
  Box<Integer> x457 = new Box<Integer>((int)0);
  Box<Integer> x458 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x457, x458, (x443).get(), 0xfffffffe);
  Box<Integer> x459 = new Box<Integer>((int)0);
  Box<Integer> x460 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x459, x460, (x443).get(), 0xfffffc2f);
  Box<Integer> x461 = new Box<Integer>((int)0);
  Box<Integer> x462 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x461, x462, 0x0, (x460).get(), (x457).get());
  Box<Integer> x463 = new Box<Integer>((int)0);
  Box<Integer> x464 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x463, x464, (x462).get(), (x458).get(), (x455).get());
  Box<Integer> x465 = new Box<Integer>((int)0);
  Box<Integer> x466 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x465, x466, (x464).get(), (x456).get(), (x453).get());
  Box<Integer> x467 = new Box<Integer>((int)0);
  Box<Integer> x468 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x467, x468, (x466).get(), (x454).get(), (x451).get());
  Box<Integer> x469 = new Box<Integer>((int)0);
  Box<Integer> x470 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x469, x470, (x468).get(), (x452).get(), (x449).get());
  Box<Integer> x471 = new Box<Integer>((int)0);
  Box<Integer> x472 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x471, x472, (x470).get(), (x450).get(), (x447).get());
  Box<Integer> x473 = new Box<Integer>((int)0);
  Box<Integer> x474 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x473, x474, (x472).get(), (x448).get(), (x445).get());
  int x475 = ((x474).get() + (x446).get());
  Box<Integer> x476 = new Box<Integer>((int)0);
  Box<Integer> x477 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x476, x477, 0x0, (x425).get(), (x459).get());
  Box<Integer> x478 = new Box<Integer>((int)0);
  Box<Integer> x479 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x478, x479, (x477).get(), (x427).get(), (x461).get());
  Box<Integer> x480 = new Box<Integer>((int)0);
  Box<Integer> x481 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x480, x481, (x479).get(), (x429).get(), (x463).get());
  Box<Integer> x482 = new Box<Integer>((int)0);
  Box<Integer> x483 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x482, x483, (x481).get(), (x431).get(), (x465).get());
  Box<Integer> x484 = new Box<Integer>((int)0);
  Box<Integer> x485 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x484, x485, (x483).get(), (x433).get(), (x467).get());
  Box<Integer> x486 = new Box<Integer>((int)0);
  Box<Integer> x487 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x486, x487, (x485).get(), (x435).get(), (x469).get());
  Box<Integer> x488 = new Box<Integer>((int)0);
  Box<Integer> x489 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x488, x489, (x487).get(), (x437).get(), (x471).get());
  Box<Integer> x490 = new Box<Integer>((int)0);
  Box<Integer> x491 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x490, x491, (x489).get(), (x439).get(), (x473).get());
  Box<Integer> x492 = new Box<Integer>((int)0);
  Box<Integer> x493 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x492, x493, (x491).get(), (x441).get(), x475);
  int x494 = ((x493).get() + (x442).get());
  Box<Integer> x495 = new Box<Integer>((int)0);
  Box<Integer> x496 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x495, x496, x5, (arg1[7]));
  Box<Integer> x497 = new Box<Integer>((int)0);
  Box<Integer> x498 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x497, x498, x5, (arg1[6]));
  Box<Integer> x499 = new Box<Integer>((int)0);
  Box<Integer> x500 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x499, x500, x5, (arg1[5]));
  Box<Integer> x501 = new Box<Integer>((int)0);
  Box<Integer> x502 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x501, x502, x5, (arg1[4]));
  Box<Integer> x503 = new Box<Integer>((int)0);
  Box<Integer> x504 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x503, x504, x5, (arg1[3]));
  Box<Integer> x505 = new Box<Integer>((int)0);
  Box<Integer> x506 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x505, x506, x5, (arg1[2]));
  Box<Integer> x507 = new Box<Integer>((int)0);
  Box<Integer> x508 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x507, x508, x5, (arg1[1]));
  Box<Integer> x509 = new Box<Integer>((int)0);
  Box<Integer> x510 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x509, x510, x5, (arg1[0]));
  Box<Integer> x511 = new Box<Integer>((int)0);
  Box<Integer> x512 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x511, x512, 0x0, (x510).get(), (x507).get());
  Box<Integer> x513 = new Box<Integer>((int)0);
  Box<Integer> x514 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x513, x514, (x512).get(), (x508).get(), (x505).get());
  Box<Integer> x515 = new Box<Integer>((int)0);
  Box<Integer> x516 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x515, x516, (x514).get(), (x506).get(), (x503).get());
  Box<Integer> x517 = new Box<Integer>((int)0);
  Box<Integer> x518 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x517, x518, (x516).get(), (x504).get(), (x501).get());
  Box<Integer> x519 = new Box<Integer>((int)0);
  Box<Integer> x520 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x519, x520, (x518).get(), (x502).get(), (x499).get());
  Box<Integer> x521 = new Box<Integer>((int)0);
  Box<Integer> x522 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x521, x522, (x520).get(), (x500).get(), (x497).get());
  Box<Integer> x523 = new Box<Integer>((int)0);
  Box<Integer> x524 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x523, x524, (x522).get(), (x498).get(), (x495).get());
  int x525 = ((x524).get() + (x496).get());
  Box<Integer> x526 = new Box<Integer>((int)0);
  Box<Integer> x527 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x526, x527, 0x0, (x478).get(), (x509).get());
  Box<Integer> x528 = new Box<Integer>((int)0);
  Box<Integer> x529 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x528, x529, (x527).get(), (x480).get(), (x511).get());
  Box<Integer> x530 = new Box<Integer>((int)0);
  Box<Integer> x531 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x530, x531, (x529).get(), (x482).get(), (x513).get());
  Box<Integer> x532 = new Box<Integer>((int)0);
  Box<Integer> x533 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x532, x533, (x531).get(), (x484).get(), (x515).get());
  Box<Integer> x534 = new Box<Integer>((int)0);
  Box<Integer> x535 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x534, x535, (x533).get(), (x486).get(), (x517).get());
  Box<Integer> x536 = new Box<Integer>((int)0);
  Box<Integer> x537 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x536, x537, (x535).get(), (x488).get(), (x519).get());
  Box<Integer> x538 = new Box<Integer>((int)0);
  Box<Integer> x539 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x538, x539, (x537).get(), (x490).get(), (x521).get());
  Box<Integer> x540 = new Box<Integer>((int)0);
  Box<Integer> x541 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x540, x541, (x539).get(), (x492).get(), (x523).get());
  Box<Integer> x542 = new Box<Integer>((int)0);
  Box<Integer> x543 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x542, x543, (x541).get(), x494, x525);
  Box<Integer> x544 = new Box<Integer>((int)0);
  Box<Integer> x545 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x544, x545, (x526).get(), 0xd2253531);
  Box<Integer> x546 = new Box<Integer>((int)0);
  Box<Integer> x547 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x546, x547, (x544).get(), 0xffffffff);
  Box<Integer> x548 = new Box<Integer>((int)0);
  Box<Integer> x549 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x548, x549, (x544).get(), 0xffffffff);
  Box<Integer> x550 = new Box<Integer>((int)0);
  Box<Integer> x551 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x550, x551, (x544).get(), 0xffffffff);
  Box<Integer> x552 = new Box<Integer>((int)0);
  Box<Integer> x553 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x552, x553, (x544).get(), 0xffffffff);
  Box<Integer> x554 = new Box<Integer>((int)0);
  Box<Integer> x555 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x554, x555, (x544).get(), 0xffffffff);
  Box<Integer> x556 = new Box<Integer>((int)0);
  Box<Integer> x557 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x556, x557, (x544).get(), 0xffffffff);
  Box<Integer> x558 = new Box<Integer>((int)0);
  Box<Integer> x559 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x558, x559, (x544).get(), 0xfffffffe);
  Box<Integer> x560 = new Box<Integer>((int)0);
  Box<Integer> x561 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x560, x561, (x544).get(), 0xfffffc2f);
  Box<Integer> x562 = new Box<Integer>((int)0);
  Box<Integer> x563 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x562, x563, 0x0, (x561).get(), (x558).get());
  Box<Integer> x564 = new Box<Integer>((int)0);
  Box<Integer> x565 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x564, x565, (x563).get(), (x559).get(), (x556).get());
  Box<Integer> x566 = new Box<Integer>((int)0);
  Box<Integer> x567 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x566, x567, (x565).get(), (x557).get(), (x554).get());
  Box<Integer> x568 = new Box<Integer>((int)0);
  Box<Integer> x569 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x568, x569, (x567).get(), (x555).get(), (x552).get());
  Box<Integer> x570 = new Box<Integer>((int)0);
  Box<Integer> x571 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x570, x571, (x569).get(), (x553).get(), (x550).get());
  Box<Integer> x572 = new Box<Integer>((int)0);
  Box<Integer> x573 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x572, x573, (x571).get(), (x551).get(), (x548).get());
  Box<Integer> x574 = new Box<Integer>((int)0);
  Box<Integer> x575 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x574, x575, (x573).get(), (x549).get(), (x546).get());
  int x576 = ((x575).get() + (x547).get());
  Box<Integer> x577 = new Box<Integer>((int)0);
  Box<Integer> x578 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x577, x578, 0x0, (x526).get(), (x560).get());
  Box<Integer> x579 = new Box<Integer>((int)0);
  Box<Integer> x580 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x579, x580, (x578).get(), (x528).get(), (x562).get());
  Box<Integer> x581 = new Box<Integer>((int)0);
  Box<Integer> x582 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x581, x582, (x580).get(), (x530).get(), (x564).get());
  Box<Integer> x583 = new Box<Integer>((int)0);
  Box<Integer> x584 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x583, x584, (x582).get(), (x532).get(), (x566).get());
  Box<Integer> x585 = new Box<Integer>((int)0);
  Box<Integer> x586 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x585, x586, (x584).get(), (x534).get(), (x568).get());
  Box<Integer> x587 = new Box<Integer>((int)0);
  Box<Integer> x588 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x587, x588, (x586).get(), (x536).get(), (x570).get());
  Box<Integer> x589 = new Box<Integer>((int)0);
  Box<Integer> x590 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x589, x590, (x588).get(), (x538).get(), (x572).get());
  Box<Integer> x591 = new Box<Integer>((int)0);
  Box<Integer> x592 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x591, x592, (x590).get(), (x540).get(), (x574).get());
  Box<Integer> x593 = new Box<Integer>((int)0);
  Box<Integer> x594 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x593, x594, (x592).get(), (x542).get(), x576);
  int x595 = ((x594).get() + (x543).get());
  Box<Integer> x596 = new Box<Integer>((int)0);
  Box<Integer> x597 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x596, x597, x6, (arg1[7]));
  Box<Integer> x598 = new Box<Integer>((int)0);
  Box<Integer> x599 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x598, x599, x6, (arg1[6]));
  Box<Integer> x600 = new Box<Integer>((int)0);
  Box<Integer> x601 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x600, x601, x6, (arg1[5]));
  Box<Integer> x602 = new Box<Integer>((int)0);
  Box<Integer> x603 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x602, x603, x6, (arg1[4]));
  Box<Integer> x604 = new Box<Integer>((int)0);
  Box<Integer> x605 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x604, x605, x6, (arg1[3]));
  Box<Integer> x606 = new Box<Integer>((int)0);
  Box<Integer> x607 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x606, x607, x6, (arg1[2]));
  Box<Integer> x608 = new Box<Integer>((int)0);
  Box<Integer> x609 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x608, x609, x6, (arg1[1]));
  Box<Integer> x610 = new Box<Integer>((int)0);
  Box<Integer> x611 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x610, x611, x6, (arg1[0]));
  Box<Integer> x612 = new Box<Integer>((int)0);
  Box<Integer> x613 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x612, x613, 0x0, (x611).get(), (x608).get());
  Box<Integer> x614 = new Box<Integer>((int)0);
  Box<Integer> x615 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x614, x615, (x613).get(), (x609).get(), (x606).get());
  Box<Integer> x616 = new Box<Integer>((int)0);
  Box<Integer> x617 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x616, x617, (x615).get(), (x607).get(), (x604).get());
  Box<Integer> x618 = new Box<Integer>((int)0);
  Box<Integer> x619 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x618, x619, (x617).get(), (x605).get(), (x602).get());
  Box<Integer> x620 = new Box<Integer>((int)0);
  Box<Integer> x621 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x620, x621, (x619).get(), (x603).get(), (x600).get());
  Box<Integer> x622 = new Box<Integer>((int)0);
  Box<Integer> x623 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x622, x623, (x621).get(), (x601).get(), (x598).get());
  Box<Integer> x624 = new Box<Integer>((int)0);
  Box<Integer> x625 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x624, x625, (x623).get(), (x599).get(), (x596).get());
  int x626 = ((x625).get() + (x597).get());
  Box<Integer> x627 = new Box<Integer>((int)0);
  Box<Integer> x628 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x627, x628, 0x0, (x579).get(), (x610).get());
  Box<Integer> x629 = new Box<Integer>((int)0);
  Box<Integer> x630 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x629, x630, (x628).get(), (x581).get(), (x612).get());
  Box<Integer> x631 = new Box<Integer>((int)0);
  Box<Integer> x632 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x631, x632, (x630).get(), (x583).get(), (x614).get());
  Box<Integer> x633 = new Box<Integer>((int)0);
  Box<Integer> x634 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x633, x634, (x632).get(), (x585).get(), (x616).get());
  Box<Integer> x635 = new Box<Integer>((int)0);
  Box<Integer> x636 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x635, x636, (x634).get(), (x587).get(), (x618).get());
  Box<Integer> x637 = new Box<Integer>((int)0);
  Box<Integer> x638 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x637, x638, (x636).get(), (x589).get(), (x620).get());
  Box<Integer> x639 = new Box<Integer>((int)0);
  Box<Integer> x640 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x639, x640, (x638).get(), (x591).get(), (x622).get());
  Box<Integer> x641 = new Box<Integer>((int)0);
  Box<Integer> x642 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x641, x642, (x640).get(), (x593).get(), (x624).get());
  Box<Integer> x643 = new Box<Integer>((int)0);
  Box<Integer> x644 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x643, x644, (x642).get(), x595, x626);
  Box<Integer> x645 = new Box<Integer>((int)0);
  Box<Integer> x646 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x645, x646, (x627).get(), 0xd2253531);
  Box<Integer> x647 = new Box<Integer>((int)0);
  Box<Integer> x648 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x647, x648, (x645).get(), 0xffffffff);
  Box<Integer> x649 = new Box<Integer>((int)0);
  Box<Integer> x650 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x649, x650, (x645).get(), 0xffffffff);
  Box<Integer> x651 = new Box<Integer>((int)0);
  Box<Integer> x652 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x651, x652, (x645).get(), 0xffffffff);
  Box<Integer> x653 = new Box<Integer>((int)0);
  Box<Integer> x654 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x653, x654, (x645).get(), 0xffffffff);
  Box<Integer> x655 = new Box<Integer>((int)0);
  Box<Integer> x656 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x655, x656, (x645).get(), 0xffffffff);
  Box<Integer> x657 = new Box<Integer>((int)0);
  Box<Integer> x658 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x657, x658, (x645).get(), 0xffffffff);
  Box<Integer> x659 = new Box<Integer>((int)0);
  Box<Integer> x660 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x659, x660, (x645).get(), 0xfffffffe);
  Box<Integer> x661 = new Box<Integer>((int)0);
  Box<Integer> x662 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x661, x662, (x645).get(), 0xfffffc2f);
  Box<Integer> x663 = new Box<Integer>((int)0);
  Box<Integer> x664 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x663, x664, 0x0, (x662).get(), (x659).get());
  Box<Integer> x665 = new Box<Integer>((int)0);
  Box<Integer> x666 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x665, x666, (x664).get(), (x660).get(), (x657).get());
  Box<Integer> x667 = new Box<Integer>((int)0);
  Box<Integer> x668 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x667, x668, (x666).get(), (x658).get(), (x655).get());
  Box<Integer> x669 = new Box<Integer>((int)0);
  Box<Integer> x670 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x669, x670, (x668).get(), (x656).get(), (x653).get());
  Box<Integer> x671 = new Box<Integer>((int)0);
  Box<Integer> x672 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x671, x672, (x670).get(), (x654).get(), (x651).get());
  Box<Integer> x673 = new Box<Integer>((int)0);
  Box<Integer> x674 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x673, x674, (x672).get(), (x652).get(), (x649).get());
  Box<Integer> x675 = new Box<Integer>((int)0);
  Box<Integer> x676 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x675, x676, (x674).get(), (x650).get(), (x647).get());
  int x677 = ((x676).get() + (x648).get());
  Box<Integer> x678 = new Box<Integer>((int)0);
  Box<Integer> x679 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x678, x679, 0x0, (x627).get(), (x661).get());
  Box<Integer> x680 = new Box<Integer>((int)0);
  Box<Integer> x681 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x680, x681, (x679).get(), (x629).get(), (x663).get());
  Box<Integer> x682 = new Box<Integer>((int)0);
  Box<Integer> x683 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x682, x683, (x681).get(), (x631).get(), (x665).get());
  Box<Integer> x684 = new Box<Integer>((int)0);
  Box<Integer> x685 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x684, x685, (x683).get(), (x633).get(), (x667).get());
  Box<Integer> x686 = new Box<Integer>((int)0);
  Box<Integer> x687 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x686, x687, (x685).get(), (x635).get(), (x669).get());
  Box<Integer> x688 = new Box<Integer>((int)0);
  Box<Integer> x689 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x688, x689, (x687).get(), (x637).get(), (x671).get());
  Box<Integer> x690 = new Box<Integer>((int)0);
  Box<Integer> x691 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x690, x691, (x689).get(), (x639).get(), (x673).get());
  Box<Integer> x692 = new Box<Integer>((int)0);
  Box<Integer> x693 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x692, x693, (x691).get(), (x641).get(), (x675).get());
  Box<Integer> x694 = new Box<Integer>((int)0);
  Box<Integer> x695 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x694, x695, (x693).get(), (x643).get(), x677);
  int x696 = ((x695).get() + (x644).get());
  Box<Integer> x697 = new Box<Integer>((int)0);
  Box<Integer> x698 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x697, x698, x7, (arg1[7]));
  Box<Integer> x699 = new Box<Integer>((int)0);
  Box<Integer> x700 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x699, x700, x7, (arg1[6]));
  Box<Integer> x701 = new Box<Integer>((int)0);
  Box<Integer> x702 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x701, x702, x7, (arg1[5]));
  Box<Integer> x703 = new Box<Integer>((int)0);
  Box<Integer> x704 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x703, x704, x7, (arg1[4]));
  Box<Integer> x705 = new Box<Integer>((int)0);
  Box<Integer> x706 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x705, x706, x7, (arg1[3]));
  Box<Integer> x707 = new Box<Integer>((int)0);
  Box<Integer> x708 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x707, x708, x7, (arg1[2]));
  Box<Integer> x709 = new Box<Integer>((int)0);
  Box<Integer> x710 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x709, x710, x7, (arg1[1]));
  Box<Integer> x711 = new Box<Integer>((int)0);
  Box<Integer> x712 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x711, x712, x7, (arg1[0]));
  Box<Integer> x713 = new Box<Integer>((int)0);
  Box<Integer> x714 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x713, x714, 0x0, (x712).get(), (x709).get());
  Box<Integer> x715 = new Box<Integer>((int)0);
  Box<Integer> x716 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x715, x716, (x714).get(), (x710).get(), (x707).get());
  Box<Integer> x717 = new Box<Integer>((int)0);
  Box<Integer> x718 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x717, x718, (x716).get(), (x708).get(), (x705).get());
  Box<Integer> x719 = new Box<Integer>((int)0);
  Box<Integer> x720 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x719, x720, (x718).get(), (x706).get(), (x703).get());
  Box<Integer> x721 = new Box<Integer>((int)0);
  Box<Integer> x722 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x721, x722, (x720).get(), (x704).get(), (x701).get());
  Box<Integer> x723 = new Box<Integer>((int)0);
  Box<Integer> x724 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x723, x724, (x722).get(), (x702).get(), (x699).get());
  Box<Integer> x725 = new Box<Integer>((int)0);
  Box<Integer> x726 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x725, x726, (x724).get(), (x700).get(), (x697).get());
  int x727 = ((x726).get() + (x698).get());
  Box<Integer> x728 = new Box<Integer>((int)0);
  Box<Integer> x729 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x728, x729, 0x0, (x680).get(), (x711).get());
  Box<Integer> x730 = new Box<Integer>((int)0);
  Box<Integer> x731 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x730, x731, (x729).get(), (x682).get(), (x713).get());
  Box<Integer> x732 = new Box<Integer>((int)0);
  Box<Integer> x733 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x732, x733, (x731).get(), (x684).get(), (x715).get());
  Box<Integer> x734 = new Box<Integer>((int)0);
  Box<Integer> x735 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x734, x735, (x733).get(), (x686).get(), (x717).get());
  Box<Integer> x736 = new Box<Integer>((int)0);
  Box<Integer> x737 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x736, x737, (x735).get(), (x688).get(), (x719).get());
  Box<Integer> x738 = new Box<Integer>((int)0);
  Box<Integer> x739 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x738, x739, (x737).get(), (x690).get(), (x721).get());
  Box<Integer> x740 = new Box<Integer>((int)0);
  Box<Integer> x741 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x740, x741, (x739).get(), (x692).get(), (x723).get());
  Box<Integer> x742 = new Box<Integer>((int)0);
  Box<Integer> x743 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x742, x743, (x741).get(), (x694).get(), (x725).get());
  Box<Integer> x744 = new Box<Integer>((int)0);
  Box<Integer> x745 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x744, x745, (x743).get(), x696, x727);
  Box<Integer> x746 = new Box<Integer>((int)0);
  Box<Integer> x747 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x746, x747, (x728).get(), 0xd2253531);
  Box<Integer> x748 = new Box<Integer>((int)0);
  Box<Integer> x749 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x748, x749, (x746).get(), 0xffffffff);
  Box<Integer> x750 = new Box<Integer>((int)0);
  Box<Integer> x751 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x750, x751, (x746).get(), 0xffffffff);
  Box<Integer> x752 = new Box<Integer>((int)0);
  Box<Integer> x753 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x752, x753, (x746).get(), 0xffffffff);
  Box<Integer> x754 = new Box<Integer>((int)0);
  Box<Integer> x755 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x754, x755, (x746).get(), 0xffffffff);
  Box<Integer> x756 = new Box<Integer>((int)0);
  Box<Integer> x757 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x756, x757, (x746).get(), 0xffffffff);
  Box<Integer> x758 = new Box<Integer>((int)0);
  Box<Integer> x759 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x758, x759, (x746).get(), 0xffffffff);
  Box<Integer> x760 = new Box<Integer>((int)0);
  Box<Integer> x761 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x760, x761, (x746).get(), 0xfffffffe);
  Box<Integer> x762 = new Box<Integer>((int)0);
  Box<Integer> x763 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x762, x763, (x746).get(), 0xfffffc2f);
  Box<Integer> x764 = new Box<Integer>((int)0);
  Box<Integer> x765 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x764, x765, 0x0, (x763).get(), (x760).get());
  Box<Integer> x766 = new Box<Integer>((int)0);
  Box<Integer> x767 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x766, x767, (x765).get(), (x761).get(), (x758).get());
  Box<Integer> x768 = new Box<Integer>((int)0);
  Box<Integer> x769 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x768, x769, (x767).get(), (x759).get(), (x756).get());
  Box<Integer> x770 = new Box<Integer>((int)0);
  Box<Integer> x771 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x770, x771, (x769).get(), (x757).get(), (x754).get());
  Box<Integer> x772 = new Box<Integer>((int)0);
  Box<Integer> x773 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x772, x773, (x771).get(), (x755).get(), (x752).get());
  Box<Integer> x774 = new Box<Integer>((int)0);
  Box<Integer> x775 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x774, x775, (x773).get(), (x753).get(), (x750).get());
  Box<Integer> x776 = new Box<Integer>((int)0);
  Box<Integer> x777 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x776, x777, (x775).get(), (x751).get(), (x748).get());
  int x778 = ((x777).get() + (x749).get());
  Box<Integer> x779 = new Box<Integer>((int)0);
  Box<Integer> x780 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x779, x780, 0x0, (x728).get(), (x762).get());
  Box<Integer> x781 = new Box<Integer>((int)0);
  Box<Integer> x782 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x781, x782, (x780).get(), (x730).get(), (x764).get());
  Box<Integer> x783 = new Box<Integer>((int)0);
  Box<Integer> x784 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x783, x784, (x782).get(), (x732).get(), (x766).get());
  Box<Integer> x785 = new Box<Integer>((int)0);
  Box<Integer> x786 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x785, x786, (x784).get(), (x734).get(), (x768).get());
  Box<Integer> x787 = new Box<Integer>((int)0);
  Box<Integer> x788 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x787, x788, (x786).get(), (x736).get(), (x770).get());
  Box<Integer> x789 = new Box<Integer>((int)0);
  Box<Integer> x790 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x789, x790, (x788).get(), (x738).get(), (x772).get());
  Box<Integer> x791 = new Box<Integer>((int)0);
  Box<Integer> x792 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x791, x792, (x790).get(), (x740).get(), (x774).get());
  Box<Integer> x793 = new Box<Integer>((int)0);
  Box<Integer> x794 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x793, x794, (x792).get(), (x742).get(), (x776).get());
  Box<Integer> x795 = new Box<Integer>((int)0);
  Box<Integer> x796 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x795, x796, (x794).get(), (x744).get(), x778);
  int x797 = ((x796).get() + (x745).get());
  Box<Integer> x798 = new Box<Integer>((int)0);
  Box<Integer> x799 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x798, x799, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x781).get(), 0xfffffc2f);
  Box<Integer> x800 = new Box<Integer>((int)0);
  Box<Integer> x801 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x800, x801, (x799).get(), (x783).get(), 0xfffffffe);
  Box<Integer> x802 = new Box<Integer>((int)0);
  Box<Integer> x803 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x802, x803, (x801).get(), (x785).get(), 0xffffffff);
  Box<Integer> x804 = new Box<Integer>((int)0);
  Box<Integer> x805 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x804, x805, (x803).get(), (x787).get(), 0xffffffff);
  Box<Integer> x806 = new Box<Integer>((int)0);
  Box<Integer> x807 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x806, x807, (x805).get(), (x789).get(), 0xffffffff);
  Box<Integer> x808 = new Box<Integer>((int)0);
  Box<Integer> x809 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x808, x809, (x807).get(), (x791).get(), 0xffffffff);
  Box<Integer> x810 = new Box<Integer>((int)0);
  Box<Integer> x811 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x810, x811, (x809).get(), (x793).get(), 0xffffffff);
  Box<Integer> x812 = new Box<Integer>((int)0);
  Box<Integer> x813 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x812, x813, (x811).get(), (x795).get(), 0xffffffff);
  Box<Integer> x814 = new Box<Integer>((int)0);
  Box<Integer> x815 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x814, x815, (x813).get(), x797, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x816 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x816, (x815).get(), (x798).get(), (x781).get());
  Box<Integer> x817 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x817, (x815).get(), (x800).get(), (x783).get());
  Box<Integer> x818 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x818, (x815).get(), (x802).get(), (x785).get());
  Box<Integer> x819 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x819, (x815).get(), (x804).get(), (x787).get());
  Box<Integer> x820 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x820, (x815).get(), (x806).get(), (x789).get());
  Box<Integer> x821 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x821, (x815).get(), (x808).get(), (x791).get());
  Box<Integer> x822 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x822, (x815).get(), (x810).get(), (x793).get());
  Box<Integer> x823 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x823, (x815).get(), (x812).get(), (x795).get());
  out1[0] = (x816).get();
  out1[1] = (x817).get();
  out1[2] = (x818).get();
  out1[3] = (x819).get();
  out1[4] = (x820).get();
  out1[5] = (x821).get();
  out1[6] = (x822).get();
  out1[7] = (x823).get();
}

/**
 * The function fiat_Secp256K1_add adds two field elements in the Montgomery domain. <p>
 * <p>
 * Preconditions: <p>
 *   0 ≤ eval arg1 &lt; m <p>
 *   0 ≤ eval arg2 &lt; m <p>
 * Postconditions: <p>
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m <p>
 *   0 ≤ eval out1 &lt; m <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 *   arg2: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_add(int[] out1, final int[] arg1, final int[] arg2) {
  Box<Integer> x1 = new Box<Integer>((int)0);
  Box<Integer> x2 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x1, x2, 0x0, (arg1[0]), (arg2[0]));
  Box<Integer> x3 = new Box<Integer>((int)0);
  Box<Integer> x4 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x3, x4, (x2).get(), (arg1[1]), (arg2[1]));
  Box<Integer> x5 = new Box<Integer>((int)0);
  Box<Integer> x6 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x5, x6, (x4).get(), (arg1[2]), (arg2[2]));
  Box<Integer> x7 = new Box<Integer>((int)0);
  Box<Integer> x8 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x7, x8, (x6).get(), (arg1[3]), (arg2[3]));
  Box<Integer> x9 = new Box<Integer>((int)0);
  Box<Integer> x10 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x9, x10, (x8).get(), (arg1[4]), (arg2[4]));
  Box<Integer> x11 = new Box<Integer>((int)0);
  Box<Integer> x12 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x11, x12, (x10).get(), (arg1[5]), (arg2[5]));
  Box<Integer> x13 = new Box<Integer>((int)0);
  Box<Integer> x14 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x13, x14, (x12).get(), (arg1[6]), (arg2[6]));
  Box<Integer> x15 = new Box<Integer>((int)0);
  Box<Integer> x16 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x15, x16, (x14).get(), (arg1[7]), (arg2[7]));
  Box<Integer> x17 = new Box<Integer>((int)0);
  Box<Integer> x18 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x17, x18, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x1).get(), 0xfffffc2f);
  Box<Integer> x19 = new Box<Integer>((int)0);
  Box<Integer> x20 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x19, x20, (x18).get(), (x3).get(), 0xfffffffe);
  Box<Integer> x21 = new Box<Integer>((int)0);
  Box<Integer> x22 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x21, x22, (x20).get(), (x5).get(), 0xffffffff);
  Box<Integer> x23 = new Box<Integer>((int)0);
  Box<Integer> x24 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x23, x24, (x22).get(), (x7).get(), 0xffffffff);
  Box<Integer> x25 = new Box<Integer>((int)0);
  Box<Integer> x26 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x25, x26, (x24).get(), (x9).get(), 0xffffffff);
  Box<Integer> x27 = new Box<Integer>((int)0);
  Box<Integer> x28 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x27, x28, (x26).get(), (x11).get(), 0xffffffff);
  Box<Integer> x29 = new Box<Integer>((int)0);
  Box<Integer> x30 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x29, x30, (x28).get(), (x13).get(), 0xffffffff);
  Box<Integer> x31 = new Box<Integer>((int)0);
  Box<Integer> x32 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x31, x32, (x30).get(), (x15).get(), 0xffffffff);
  Box<Integer> x33 = new Box<Integer>((int)0);
  Box<Integer> x34 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x33, x34, (x32).get(), (x16).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x35 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x35, (x34).get(), (x17).get(), (x1).get());
  Box<Integer> x36 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x36, (x34).get(), (x19).get(), (x3).get());
  Box<Integer> x37 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x37, (x34).get(), (x21).get(), (x5).get());
  Box<Integer> x38 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x38, (x34).get(), (x23).get(), (x7).get());
  Box<Integer> x39 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x39, (x34).get(), (x25).get(), (x9).get());
  Box<Integer> x40 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x40, (x34).get(), (x27).get(), (x11).get());
  Box<Integer> x41 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x41, (x34).get(), (x29).get(), (x13).get());
  Box<Integer> x42 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x42, (x34).get(), (x31).get(), (x15).get());
  out1[0] = (x35).get();
  out1[1] = (x36).get();
  out1[2] = (x37).get();
  out1[3] = (x38).get();
  out1[4] = (x39).get();
  out1[5] = (x40).get();
  out1[6] = (x41).get();
  out1[7] = (x42).get();
}

/**
 * The function fiat_Secp256K1_sub subtracts two field elements in the Montgomery domain. <p>
 * <p>
 * Preconditions: <p>
 *   0 ≤ eval arg1 &lt; m <p>
 *   0 ≤ eval arg2 &lt; m <p>
 * Postconditions: <p>
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m <p>
 *   0 ≤ eval out1 &lt; m <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 *   arg2: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_sub(int[] out1, final int[] arg1, final int[] arg2) {
  Box<Integer> x1 = new Box<Integer>((int)0);
  Box<Integer> x2 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x1, x2, 0x0, (arg1[0]), (arg2[0]));
  Box<Integer> x3 = new Box<Integer>((int)0);
  Box<Integer> x4 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x3, x4, (x2).get(), (arg1[1]), (arg2[1]));
  Box<Integer> x5 = new Box<Integer>((int)0);
  Box<Integer> x6 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x5, x6, (x4).get(), (arg1[2]), (arg2[2]));
  Box<Integer> x7 = new Box<Integer>((int)0);
  Box<Integer> x8 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x7, x8, (x6).get(), (arg1[3]), (arg2[3]));
  Box<Integer> x9 = new Box<Integer>((int)0);
  Box<Integer> x10 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x9, x10, (x8).get(), (arg1[4]), (arg2[4]));
  Box<Integer> x11 = new Box<Integer>((int)0);
  Box<Integer> x12 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x11, x12, (x10).get(), (arg1[5]), (arg2[5]));
  Box<Integer> x13 = new Box<Integer>((int)0);
  Box<Integer> x14 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x13, x14, (x12).get(), (arg1[6]), (arg2[6]));
  Box<Integer> x15 = new Box<Integer>((int)0);
  Box<Integer> x16 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x15, x16, (x14).get(), (arg1[7]), (arg2[7]));
  Box<Integer> x17 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x17, (x16).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), 0xffffffff);
  Box<Integer> x18 = new Box<Integer>((int)0);
  Box<Integer> x19 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x18, x19, 0x0, (x1).get(), ((x17).get() & 0xfffffc2f));
  Box<Integer> x20 = new Box<Integer>((int)0);
  Box<Integer> x21 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x20, x21, (x19).get(), (x3).get(), ((x17).get() & 0xfffffffe));
  Box<Integer> x22 = new Box<Integer>((int)0);
  Box<Integer> x23 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x22, x23, (x21).get(), (x5).get(), (x17).get());
  Box<Integer> x24 = new Box<Integer>((int)0);
  Box<Integer> x25 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x24, x25, (x23).get(), (x7).get(), (x17).get());
  Box<Integer> x26 = new Box<Integer>((int)0);
  Box<Integer> x27 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x26, x27, (x25).get(), (x9).get(), (x17).get());
  Box<Integer> x28 = new Box<Integer>((int)0);
  Box<Integer> x29 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x28, x29, (x27).get(), (x11).get(), (x17).get());
  Box<Integer> x30 = new Box<Integer>((int)0);
  Box<Integer> x31 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x30, x31, (x29).get(), (x13).get(), (x17).get());
  Box<Integer> x32 = new Box<Integer>((int)0);
  Box<Integer> x33 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x32, x33, (x31).get(), (x15).get(), (x17).get());
  out1[0] = (x18).get();
  out1[1] = (x20).get();
  out1[2] = (x22).get();
  out1[3] = (x24).get();
  out1[4] = (x26).get();
  out1[5] = (x28).get();
  out1[6] = (x30).get();
  out1[7] = (x32).get();
}

/**
 * The function fiat_Secp256K1_opp negates a field element in the Montgomery domain. <p>
 * <p>
 * Preconditions: <p>
 *   0 ≤ eval arg1 &lt; m <p>
 * Postconditions: <p>
 *   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m <p>
 *   0 ≤ eval out1 &lt; m <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_opp(int[] out1, final int[] arg1) {
  Box<Integer> x1 = new Box<Integer>((int)0);
  Box<Integer> x2 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x1, x2, 0x0, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (arg1[0]));
  Box<Integer> x3 = new Box<Integer>((int)0);
  Box<Integer> x4 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x3, x4, (x2).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (arg1[1]));
  Box<Integer> x5 = new Box<Integer>((int)0);
  Box<Integer> x6 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x5, x6, (x4).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (arg1[2]));
  Box<Integer> x7 = new Box<Integer>((int)0);
  Box<Integer> x8 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x7, x8, (x6).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (arg1[3]));
  Box<Integer> x9 = new Box<Integer>((int)0);
  Box<Integer> x10 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x9, x10, (x8).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (arg1[4]));
  Box<Integer> x11 = new Box<Integer>((int)0);
  Box<Integer> x12 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x11, x12, (x10).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (arg1[5]));
  Box<Integer> x13 = new Box<Integer>((int)0);
  Box<Integer> x14 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x13, x14, (x12).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (arg1[6]));
  Box<Integer> x15 = new Box<Integer>((int)0);
  Box<Integer> x16 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x15, x16, (x14).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (arg1[7]));
  Box<Integer> x17 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x17, (x16).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), 0xffffffff);
  Box<Integer> x18 = new Box<Integer>((int)0);
  Box<Integer> x19 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x18, x19, 0x0, (x1).get(), ((x17).get() & 0xfffffc2f));
  Box<Integer> x20 = new Box<Integer>((int)0);
  Box<Integer> x21 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x20, x21, (x19).get(), (x3).get(), ((x17).get() & 0xfffffffe));
  Box<Integer> x22 = new Box<Integer>((int)0);
  Box<Integer> x23 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x22, x23, (x21).get(), (x5).get(), (x17).get());
  Box<Integer> x24 = new Box<Integer>((int)0);
  Box<Integer> x25 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x24, x25, (x23).get(), (x7).get(), (x17).get());
  Box<Integer> x26 = new Box<Integer>((int)0);
  Box<Integer> x27 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x26, x27, (x25).get(), (x9).get(), (x17).get());
  Box<Integer> x28 = new Box<Integer>((int)0);
  Box<Integer> x29 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x28, x29, (x27).get(), (x11).get(), (x17).get());
  Box<Integer> x30 = new Box<Integer>((int)0);
  Box<Integer> x31 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x30, x31, (x29).get(), (x13).get(), (x17).get());
  Box<Integer> x32 = new Box<Integer>((int)0);
  Box<Integer> x33 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x32, x33, (x31).get(), (x15).get(), (x17).get());
  out1[0] = (x18).get();
  out1[1] = (x20).get();
  out1[2] = (x22).get();
  out1[3] = (x24).get();
  out1[4] = (x26).get();
  out1[5] = (x28).get();
  out1[6] = (x30).get();
  out1[7] = (x32).get();
}

/**
 * The function fiat_Secp256K1_from_montgomery translates a field element out of the Montgomery domain. <p>
 * <p>
 * Preconditions: <p>
 *   0 ≤ eval arg1 &lt; m <p>
 * Postconditions: <p>
 *   eval out1 mod m = (eval arg1 * ((2^32)⁻¹ mod m)^8) mod m <p>
 *   0 ≤ eval out1 &lt; m <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_from_montgomery(int[] out1, final int[] arg1) {
  int x1 = (arg1[0]);
  Box<Integer> x2 = new Box<Integer>((int)0);
  Box<Integer> x3 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x2, x3, x1, 0xd2253531);
  Box<Integer> x4 = new Box<Integer>((int)0);
  Box<Integer> x5 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x4, x5, (x2).get(), 0xffffffff);
  Box<Integer> x6 = new Box<Integer>((int)0);
  Box<Integer> x7 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x6, x7, (x2).get(), 0xffffffff);
  Box<Integer> x8 = new Box<Integer>((int)0);
  Box<Integer> x9 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x8, x9, (x2).get(), 0xffffffff);
  Box<Integer> x10 = new Box<Integer>((int)0);
  Box<Integer> x11 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x10, x11, (x2).get(), 0xffffffff);
  Box<Integer> x12 = new Box<Integer>((int)0);
  Box<Integer> x13 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x12, x13, (x2).get(), 0xffffffff);
  Box<Integer> x14 = new Box<Integer>((int)0);
  Box<Integer> x15 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x14, x15, (x2).get(), 0xffffffff);
  Box<Integer> x16 = new Box<Integer>((int)0);
  Box<Integer> x17 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x16, x17, (x2).get(), 0xfffffffe);
  Box<Integer> x18 = new Box<Integer>((int)0);
  Box<Integer> x19 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x18, x19, (x2).get(), 0xfffffc2f);
  Box<Integer> x20 = new Box<Integer>((int)0);
  Box<Integer> x21 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x20, x21, 0x0, (x19).get(), (x16).get());
  Box<Integer> x22 = new Box<Integer>((int)0);
  Box<Integer> x23 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x22, x23, (x21).get(), (x17).get(), (x14).get());
  Box<Integer> x24 = new Box<Integer>((int)0);
  Box<Integer> x25 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x24, x25, (x23).get(), (x15).get(), (x12).get());
  Box<Integer> x26 = new Box<Integer>((int)0);
  Box<Integer> x27 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x26, x27, (x25).get(), (x13).get(), (x10).get());
  Box<Integer> x28 = new Box<Integer>((int)0);
  Box<Integer> x29 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x28, x29, (x27).get(), (x11).get(), (x8).get());
  Box<Integer> x30 = new Box<Integer>((int)0);
  Box<Integer> x31 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x30, x31, (x29).get(), (x9).get(), (x6).get());
  Box<Integer> x32 = new Box<Integer>((int)0);
  Box<Integer> x33 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x32, x33, (x31).get(), (x7).get(), (x4).get());
  Box<Integer> x34 = new Box<Integer>((int)0);
  Box<Integer> x35 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x34, x35, 0x0, x1, (x18).get());
  Box<Integer> x36 = new Box<Integer>((int)0);
  Box<Integer> x37 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x36, x37, (x35).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x20).get());
  Box<Integer> x38 = new Box<Integer>((int)0);
  Box<Integer> x39 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x38, x39, (x37).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x22).get());
  Box<Integer> x40 = new Box<Integer>((int)0);
  Box<Integer> x41 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x40, x41, (x39).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x24).get());
  Box<Integer> x42 = new Box<Integer>((int)0);
  Box<Integer> x43 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x42, x43, (x41).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x26).get());
  Box<Integer> x44 = new Box<Integer>((int)0);
  Box<Integer> x45 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x44, x45, (x43).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x28).get());
  Box<Integer> x46 = new Box<Integer>((int)0);
  Box<Integer> x47 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x46, x47, (x45).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x30).get());
  Box<Integer> x48 = new Box<Integer>((int)0);
  Box<Integer> x49 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x48, x49, (x47).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x32).get());
  Box<Integer> x50 = new Box<Integer>((int)0);
  Box<Integer> x51 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x50, x51, (x49).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), ((x33).get() + (x5).get()));
  Box<Integer> x52 = new Box<Integer>((int)0);
  Box<Integer> x53 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x52, x53, 0x0, (x36).get(), (arg1[1]));
  Box<Integer> x54 = new Box<Integer>((int)0);
  Box<Integer> x55 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x54, x55, (x53).get(), (x38).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x56 = new Box<Integer>((int)0);
  Box<Integer> x57 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x56, x57, (x55).get(), (x40).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x58 = new Box<Integer>((int)0);
  Box<Integer> x59 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x58, x59, (x57).get(), (x42).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x60 = new Box<Integer>((int)0);
  Box<Integer> x61 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x60, x61, (x59).get(), (x44).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x62 = new Box<Integer>((int)0);
  Box<Integer> x63 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x62, x63, (x61).get(), (x46).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x64 = new Box<Integer>((int)0);
  Box<Integer> x65 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x64, x65, (x63).get(), (x48).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x66 = new Box<Integer>((int)0);
  Box<Integer> x67 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x66, x67, (x65).get(), (x50).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x68 = new Box<Integer>((int)0);
  Box<Integer> x69 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x68, x69, (x52).get(), 0xd2253531);
  Box<Integer> x70 = new Box<Integer>((int)0);
  Box<Integer> x71 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x70, x71, (x68).get(), 0xffffffff);
  Box<Integer> x72 = new Box<Integer>((int)0);
  Box<Integer> x73 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x72, x73, (x68).get(), 0xffffffff);
  Box<Integer> x74 = new Box<Integer>((int)0);
  Box<Integer> x75 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x74, x75, (x68).get(), 0xffffffff);
  Box<Integer> x76 = new Box<Integer>((int)0);
  Box<Integer> x77 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x76, x77, (x68).get(), 0xffffffff);
  Box<Integer> x78 = new Box<Integer>((int)0);
  Box<Integer> x79 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x78, x79, (x68).get(), 0xffffffff);
  Box<Integer> x80 = new Box<Integer>((int)0);
  Box<Integer> x81 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x80, x81, (x68).get(), 0xffffffff);
  Box<Integer> x82 = new Box<Integer>((int)0);
  Box<Integer> x83 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x82, x83, (x68).get(), 0xfffffffe);
  Box<Integer> x84 = new Box<Integer>((int)0);
  Box<Integer> x85 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x84, x85, (x68).get(), 0xfffffc2f);
  Box<Integer> x86 = new Box<Integer>((int)0);
  Box<Integer> x87 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x86, x87, 0x0, (x85).get(), (x82).get());
  Box<Integer> x88 = new Box<Integer>((int)0);
  Box<Integer> x89 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x88, x89, (x87).get(), (x83).get(), (x80).get());
  Box<Integer> x90 = new Box<Integer>((int)0);
  Box<Integer> x91 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x90, x91, (x89).get(), (x81).get(), (x78).get());
  Box<Integer> x92 = new Box<Integer>((int)0);
  Box<Integer> x93 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x92, x93, (x91).get(), (x79).get(), (x76).get());
  Box<Integer> x94 = new Box<Integer>((int)0);
  Box<Integer> x95 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x94, x95, (x93).get(), (x77).get(), (x74).get());
  Box<Integer> x96 = new Box<Integer>((int)0);
  Box<Integer> x97 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x96, x97, (x95).get(), (x75).get(), (x72).get());
  Box<Integer> x98 = new Box<Integer>((int)0);
  Box<Integer> x99 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x98, x99, (x97).get(), (x73).get(), (x70).get());
  Box<Integer> x100 = new Box<Integer>((int)0);
  Box<Integer> x101 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x100, x101, 0x0, (x52).get(), (x84).get());
  Box<Integer> x102 = new Box<Integer>((int)0);
  Box<Integer> x103 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x102, x103, (x101).get(), (x54).get(), (x86).get());
  Box<Integer> x104 = new Box<Integer>((int)0);
  Box<Integer> x105 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x104, x105, (x103).get(), (x56).get(), (x88).get());
  Box<Integer> x106 = new Box<Integer>((int)0);
  Box<Integer> x107 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x106, x107, (x105).get(), (x58).get(), (x90).get());
  Box<Integer> x108 = new Box<Integer>((int)0);
  Box<Integer> x109 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x108, x109, (x107).get(), (x60).get(), (x92).get());
  Box<Integer> x110 = new Box<Integer>((int)0);
  Box<Integer> x111 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x110, x111, (x109).get(), (x62).get(), (x94).get());
  Box<Integer> x112 = new Box<Integer>((int)0);
  Box<Integer> x113 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x112, x113, (x111).get(), (x64).get(), (x96).get());
  Box<Integer> x114 = new Box<Integer>((int)0);
  Box<Integer> x115 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x114, x115, (x113).get(), (x66).get(), (x98).get());
  Box<Integer> x116 = new Box<Integer>((int)0);
  Box<Integer> x117 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x116, x117, (x115).get(), ((x67).get() + (x51).get()), ((x99).get() + (x71).get()));
  Box<Integer> x118 = new Box<Integer>((int)0);
  Box<Integer> x119 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x118, x119, 0x0, (x102).get(), (arg1[2]));
  Box<Integer> x120 = new Box<Integer>((int)0);
  Box<Integer> x121 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x120, x121, (x119).get(), (x104).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x122 = new Box<Integer>((int)0);
  Box<Integer> x123 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x122, x123, (x121).get(), (x106).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x124 = new Box<Integer>((int)0);
  Box<Integer> x125 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x124, x125, (x123).get(), (x108).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x126 = new Box<Integer>((int)0);
  Box<Integer> x127 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x126, x127, (x125).get(), (x110).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x128 = new Box<Integer>((int)0);
  Box<Integer> x129 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x128, x129, (x127).get(), (x112).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x130 = new Box<Integer>((int)0);
  Box<Integer> x131 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x130, x131, (x129).get(), (x114).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x132 = new Box<Integer>((int)0);
  Box<Integer> x133 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x132, x133, (x131).get(), (x116).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x134 = new Box<Integer>((int)0);
  Box<Integer> x135 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x134, x135, (x118).get(), 0xd2253531);
  Box<Integer> x136 = new Box<Integer>((int)0);
  Box<Integer> x137 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x136, x137, (x134).get(), 0xffffffff);
  Box<Integer> x138 = new Box<Integer>((int)0);
  Box<Integer> x139 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x138, x139, (x134).get(), 0xffffffff);
  Box<Integer> x140 = new Box<Integer>((int)0);
  Box<Integer> x141 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x140, x141, (x134).get(), 0xffffffff);
  Box<Integer> x142 = new Box<Integer>((int)0);
  Box<Integer> x143 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x142, x143, (x134).get(), 0xffffffff);
  Box<Integer> x144 = new Box<Integer>((int)0);
  Box<Integer> x145 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x144, x145, (x134).get(), 0xffffffff);
  Box<Integer> x146 = new Box<Integer>((int)0);
  Box<Integer> x147 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x146, x147, (x134).get(), 0xffffffff);
  Box<Integer> x148 = new Box<Integer>((int)0);
  Box<Integer> x149 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x148, x149, (x134).get(), 0xfffffffe);
  Box<Integer> x150 = new Box<Integer>((int)0);
  Box<Integer> x151 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x150, x151, (x134).get(), 0xfffffc2f);
  Box<Integer> x152 = new Box<Integer>((int)0);
  Box<Integer> x153 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x152, x153, 0x0, (x151).get(), (x148).get());
  Box<Integer> x154 = new Box<Integer>((int)0);
  Box<Integer> x155 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x154, x155, (x153).get(), (x149).get(), (x146).get());
  Box<Integer> x156 = new Box<Integer>((int)0);
  Box<Integer> x157 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x156, x157, (x155).get(), (x147).get(), (x144).get());
  Box<Integer> x158 = new Box<Integer>((int)0);
  Box<Integer> x159 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x158, x159, (x157).get(), (x145).get(), (x142).get());
  Box<Integer> x160 = new Box<Integer>((int)0);
  Box<Integer> x161 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x160, x161, (x159).get(), (x143).get(), (x140).get());
  Box<Integer> x162 = new Box<Integer>((int)0);
  Box<Integer> x163 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x162, x163, (x161).get(), (x141).get(), (x138).get());
  Box<Integer> x164 = new Box<Integer>((int)0);
  Box<Integer> x165 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x164, x165, (x163).get(), (x139).get(), (x136).get());
  Box<Integer> x166 = new Box<Integer>((int)0);
  Box<Integer> x167 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x166, x167, 0x0, (x118).get(), (x150).get());
  Box<Integer> x168 = new Box<Integer>((int)0);
  Box<Integer> x169 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x168, x169, (x167).get(), (x120).get(), (x152).get());
  Box<Integer> x170 = new Box<Integer>((int)0);
  Box<Integer> x171 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x170, x171, (x169).get(), (x122).get(), (x154).get());
  Box<Integer> x172 = new Box<Integer>((int)0);
  Box<Integer> x173 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x172, x173, (x171).get(), (x124).get(), (x156).get());
  Box<Integer> x174 = new Box<Integer>((int)0);
  Box<Integer> x175 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x174, x175, (x173).get(), (x126).get(), (x158).get());
  Box<Integer> x176 = new Box<Integer>((int)0);
  Box<Integer> x177 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x176, x177, (x175).get(), (x128).get(), (x160).get());
  Box<Integer> x178 = new Box<Integer>((int)0);
  Box<Integer> x179 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x178, x179, (x177).get(), (x130).get(), (x162).get());
  Box<Integer> x180 = new Box<Integer>((int)0);
  Box<Integer> x181 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x180, x181, (x179).get(), (x132).get(), (x164).get());
  Box<Integer> x182 = new Box<Integer>((int)0);
  Box<Integer> x183 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x182, x183, (x181).get(), ((x133).get() + (x117).get()), ((x165).get() + (x137).get()));
  Box<Integer> x184 = new Box<Integer>((int)0);
  Box<Integer> x185 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x184, x185, 0x0, (x168).get(), (arg1[3]));
  Box<Integer> x186 = new Box<Integer>((int)0);
  Box<Integer> x187 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x186, x187, (x185).get(), (x170).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x188 = new Box<Integer>((int)0);
  Box<Integer> x189 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x188, x189, (x187).get(), (x172).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x190 = new Box<Integer>((int)0);
  Box<Integer> x191 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x190, x191, (x189).get(), (x174).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x192 = new Box<Integer>((int)0);
  Box<Integer> x193 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x192, x193, (x191).get(), (x176).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x194 = new Box<Integer>((int)0);
  Box<Integer> x195 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x194, x195, (x193).get(), (x178).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x196 = new Box<Integer>((int)0);
  Box<Integer> x197 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x196, x197, (x195).get(), (x180).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x198 = new Box<Integer>((int)0);
  Box<Integer> x199 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x198, x199, (x197).get(), (x182).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x200 = new Box<Integer>((int)0);
  Box<Integer> x201 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x200, x201, (x184).get(), 0xd2253531);
  Box<Integer> x202 = new Box<Integer>((int)0);
  Box<Integer> x203 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x202, x203, (x200).get(), 0xffffffff);
  Box<Integer> x204 = new Box<Integer>((int)0);
  Box<Integer> x205 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x204, x205, (x200).get(), 0xffffffff);
  Box<Integer> x206 = new Box<Integer>((int)0);
  Box<Integer> x207 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x206, x207, (x200).get(), 0xffffffff);
  Box<Integer> x208 = new Box<Integer>((int)0);
  Box<Integer> x209 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x208, x209, (x200).get(), 0xffffffff);
  Box<Integer> x210 = new Box<Integer>((int)0);
  Box<Integer> x211 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x210, x211, (x200).get(), 0xffffffff);
  Box<Integer> x212 = new Box<Integer>((int)0);
  Box<Integer> x213 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x212, x213, (x200).get(), 0xffffffff);
  Box<Integer> x214 = new Box<Integer>((int)0);
  Box<Integer> x215 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x214, x215, (x200).get(), 0xfffffffe);
  Box<Integer> x216 = new Box<Integer>((int)0);
  Box<Integer> x217 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x216, x217, (x200).get(), 0xfffffc2f);
  Box<Integer> x218 = new Box<Integer>((int)0);
  Box<Integer> x219 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x218, x219, 0x0, (x217).get(), (x214).get());
  Box<Integer> x220 = new Box<Integer>((int)0);
  Box<Integer> x221 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x220, x221, (x219).get(), (x215).get(), (x212).get());
  Box<Integer> x222 = new Box<Integer>((int)0);
  Box<Integer> x223 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x222, x223, (x221).get(), (x213).get(), (x210).get());
  Box<Integer> x224 = new Box<Integer>((int)0);
  Box<Integer> x225 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x224, x225, (x223).get(), (x211).get(), (x208).get());
  Box<Integer> x226 = new Box<Integer>((int)0);
  Box<Integer> x227 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x226, x227, (x225).get(), (x209).get(), (x206).get());
  Box<Integer> x228 = new Box<Integer>((int)0);
  Box<Integer> x229 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x228, x229, (x227).get(), (x207).get(), (x204).get());
  Box<Integer> x230 = new Box<Integer>((int)0);
  Box<Integer> x231 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x230, x231, (x229).get(), (x205).get(), (x202).get());
  Box<Integer> x232 = new Box<Integer>((int)0);
  Box<Integer> x233 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x232, x233, 0x0, (x184).get(), (x216).get());
  Box<Integer> x234 = new Box<Integer>((int)0);
  Box<Integer> x235 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x234, x235, (x233).get(), (x186).get(), (x218).get());
  Box<Integer> x236 = new Box<Integer>((int)0);
  Box<Integer> x237 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x236, x237, (x235).get(), (x188).get(), (x220).get());
  Box<Integer> x238 = new Box<Integer>((int)0);
  Box<Integer> x239 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x238, x239, (x237).get(), (x190).get(), (x222).get());
  Box<Integer> x240 = new Box<Integer>((int)0);
  Box<Integer> x241 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x240, x241, (x239).get(), (x192).get(), (x224).get());
  Box<Integer> x242 = new Box<Integer>((int)0);
  Box<Integer> x243 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x242, x243, (x241).get(), (x194).get(), (x226).get());
  Box<Integer> x244 = new Box<Integer>((int)0);
  Box<Integer> x245 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x244, x245, (x243).get(), (x196).get(), (x228).get());
  Box<Integer> x246 = new Box<Integer>((int)0);
  Box<Integer> x247 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x246, x247, (x245).get(), (x198).get(), (x230).get());
  Box<Integer> x248 = new Box<Integer>((int)0);
  Box<Integer> x249 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x248, x249, (x247).get(), ((x199).get() + (x183).get()), ((x231).get() + (x203).get()));
  Box<Integer> x250 = new Box<Integer>((int)0);
  Box<Integer> x251 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x250, x251, 0x0, (x234).get(), (arg1[4]));
  Box<Integer> x252 = new Box<Integer>((int)0);
  Box<Integer> x253 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x252, x253, (x251).get(), (x236).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x254 = new Box<Integer>((int)0);
  Box<Integer> x255 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x254, x255, (x253).get(), (x238).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x256 = new Box<Integer>((int)0);
  Box<Integer> x257 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x256, x257, (x255).get(), (x240).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x258 = new Box<Integer>((int)0);
  Box<Integer> x259 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x258, x259, (x257).get(), (x242).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x260 = new Box<Integer>((int)0);
  Box<Integer> x261 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x260, x261, (x259).get(), (x244).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x262 = new Box<Integer>((int)0);
  Box<Integer> x263 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x262, x263, (x261).get(), (x246).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x264 = new Box<Integer>((int)0);
  Box<Integer> x265 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x264, x265, (x263).get(), (x248).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x266 = new Box<Integer>((int)0);
  Box<Integer> x267 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x266, x267, (x250).get(), 0xd2253531);
  Box<Integer> x268 = new Box<Integer>((int)0);
  Box<Integer> x269 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x268, x269, (x266).get(), 0xffffffff);
  Box<Integer> x270 = new Box<Integer>((int)0);
  Box<Integer> x271 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x270, x271, (x266).get(), 0xffffffff);
  Box<Integer> x272 = new Box<Integer>((int)0);
  Box<Integer> x273 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x272, x273, (x266).get(), 0xffffffff);
  Box<Integer> x274 = new Box<Integer>((int)0);
  Box<Integer> x275 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x274, x275, (x266).get(), 0xffffffff);
  Box<Integer> x276 = new Box<Integer>((int)0);
  Box<Integer> x277 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x276, x277, (x266).get(), 0xffffffff);
  Box<Integer> x278 = new Box<Integer>((int)0);
  Box<Integer> x279 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x278, x279, (x266).get(), 0xffffffff);
  Box<Integer> x280 = new Box<Integer>((int)0);
  Box<Integer> x281 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x280, x281, (x266).get(), 0xfffffffe);
  Box<Integer> x282 = new Box<Integer>((int)0);
  Box<Integer> x283 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x282, x283, (x266).get(), 0xfffffc2f);
  Box<Integer> x284 = new Box<Integer>((int)0);
  Box<Integer> x285 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x284, x285, 0x0, (x283).get(), (x280).get());
  Box<Integer> x286 = new Box<Integer>((int)0);
  Box<Integer> x287 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x286, x287, (x285).get(), (x281).get(), (x278).get());
  Box<Integer> x288 = new Box<Integer>((int)0);
  Box<Integer> x289 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x288, x289, (x287).get(), (x279).get(), (x276).get());
  Box<Integer> x290 = new Box<Integer>((int)0);
  Box<Integer> x291 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x290, x291, (x289).get(), (x277).get(), (x274).get());
  Box<Integer> x292 = new Box<Integer>((int)0);
  Box<Integer> x293 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x292, x293, (x291).get(), (x275).get(), (x272).get());
  Box<Integer> x294 = new Box<Integer>((int)0);
  Box<Integer> x295 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x294, x295, (x293).get(), (x273).get(), (x270).get());
  Box<Integer> x296 = new Box<Integer>((int)0);
  Box<Integer> x297 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x296, x297, (x295).get(), (x271).get(), (x268).get());
  Box<Integer> x298 = new Box<Integer>((int)0);
  Box<Integer> x299 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x298, x299, 0x0, (x250).get(), (x282).get());
  Box<Integer> x300 = new Box<Integer>((int)0);
  Box<Integer> x301 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x300, x301, (x299).get(), (x252).get(), (x284).get());
  Box<Integer> x302 = new Box<Integer>((int)0);
  Box<Integer> x303 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x302, x303, (x301).get(), (x254).get(), (x286).get());
  Box<Integer> x304 = new Box<Integer>((int)0);
  Box<Integer> x305 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x304, x305, (x303).get(), (x256).get(), (x288).get());
  Box<Integer> x306 = new Box<Integer>((int)0);
  Box<Integer> x307 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x306, x307, (x305).get(), (x258).get(), (x290).get());
  Box<Integer> x308 = new Box<Integer>((int)0);
  Box<Integer> x309 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x308, x309, (x307).get(), (x260).get(), (x292).get());
  Box<Integer> x310 = new Box<Integer>((int)0);
  Box<Integer> x311 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x310, x311, (x309).get(), (x262).get(), (x294).get());
  Box<Integer> x312 = new Box<Integer>((int)0);
  Box<Integer> x313 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x312, x313, (x311).get(), (x264).get(), (x296).get());
  Box<Integer> x314 = new Box<Integer>((int)0);
  Box<Integer> x315 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x314, x315, (x313).get(), ((x265).get() + (x249).get()), ((x297).get() + (x269).get()));
  Box<Integer> x316 = new Box<Integer>((int)0);
  Box<Integer> x317 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x316, x317, 0x0, (x300).get(), (arg1[5]));
  Box<Integer> x318 = new Box<Integer>((int)0);
  Box<Integer> x319 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x318, x319, (x317).get(), (x302).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x320 = new Box<Integer>((int)0);
  Box<Integer> x321 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x320, x321, (x319).get(), (x304).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x322 = new Box<Integer>((int)0);
  Box<Integer> x323 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x322, x323, (x321).get(), (x306).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x324 = new Box<Integer>((int)0);
  Box<Integer> x325 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x324, x325, (x323).get(), (x308).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x326 = new Box<Integer>((int)0);
  Box<Integer> x327 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x326, x327, (x325).get(), (x310).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x328 = new Box<Integer>((int)0);
  Box<Integer> x329 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x328, x329, (x327).get(), (x312).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x330 = new Box<Integer>((int)0);
  Box<Integer> x331 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x330, x331, (x329).get(), (x314).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x332 = new Box<Integer>((int)0);
  Box<Integer> x333 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x332, x333, (x316).get(), 0xd2253531);
  Box<Integer> x334 = new Box<Integer>((int)0);
  Box<Integer> x335 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x334, x335, (x332).get(), 0xffffffff);
  Box<Integer> x336 = new Box<Integer>((int)0);
  Box<Integer> x337 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x336, x337, (x332).get(), 0xffffffff);
  Box<Integer> x338 = new Box<Integer>((int)0);
  Box<Integer> x339 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x338, x339, (x332).get(), 0xffffffff);
  Box<Integer> x340 = new Box<Integer>((int)0);
  Box<Integer> x341 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x340, x341, (x332).get(), 0xffffffff);
  Box<Integer> x342 = new Box<Integer>((int)0);
  Box<Integer> x343 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x342, x343, (x332).get(), 0xffffffff);
  Box<Integer> x344 = new Box<Integer>((int)0);
  Box<Integer> x345 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x344, x345, (x332).get(), 0xffffffff);
  Box<Integer> x346 = new Box<Integer>((int)0);
  Box<Integer> x347 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x346, x347, (x332).get(), 0xfffffffe);
  Box<Integer> x348 = new Box<Integer>((int)0);
  Box<Integer> x349 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x348, x349, (x332).get(), 0xfffffc2f);
  Box<Integer> x350 = new Box<Integer>((int)0);
  Box<Integer> x351 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x350, x351, 0x0, (x349).get(), (x346).get());
  Box<Integer> x352 = new Box<Integer>((int)0);
  Box<Integer> x353 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x352, x353, (x351).get(), (x347).get(), (x344).get());
  Box<Integer> x354 = new Box<Integer>((int)0);
  Box<Integer> x355 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x354, x355, (x353).get(), (x345).get(), (x342).get());
  Box<Integer> x356 = new Box<Integer>((int)0);
  Box<Integer> x357 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x356, x357, (x355).get(), (x343).get(), (x340).get());
  Box<Integer> x358 = new Box<Integer>((int)0);
  Box<Integer> x359 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x358, x359, (x357).get(), (x341).get(), (x338).get());
  Box<Integer> x360 = new Box<Integer>((int)0);
  Box<Integer> x361 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x360, x361, (x359).get(), (x339).get(), (x336).get());
  Box<Integer> x362 = new Box<Integer>((int)0);
  Box<Integer> x363 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x362, x363, (x361).get(), (x337).get(), (x334).get());
  Box<Integer> x364 = new Box<Integer>((int)0);
  Box<Integer> x365 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x364, x365, 0x0, (x316).get(), (x348).get());
  Box<Integer> x366 = new Box<Integer>((int)0);
  Box<Integer> x367 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x366, x367, (x365).get(), (x318).get(), (x350).get());
  Box<Integer> x368 = new Box<Integer>((int)0);
  Box<Integer> x369 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x368, x369, (x367).get(), (x320).get(), (x352).get());
  Box<Integer> x370 = new Box<Integer>((int)0);
  Box<Integer> x371 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x370, x371, (x369).get(), (x322).get(), (x354).get());
  Box<Integer> x372 = new Box<Integer>((int)0);
  Box<Integer> x373 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x372, x373, (x371).get(), (x324).get(), (x356).get());
  Box<Integer> x374 = new Box<Integer>((int)0);
  Box<Integer> x375 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x374, x375, (x373).get(), (x326).get(), (x358).get());
  Box<Integer> x376 = new Box<Integer>((int)0);
  Box<Integer> x377 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x376, x377, (x375).get(), (x328).get(), (x360).get());
  Box<Integer> x378 = new Box<Integer>((int)0);
  Box<Integer> x379 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x378, x379, (x377).get(), (x330).get(), (x362).get());
  Box<Integer> x380 = new Box<Integer>((int)0);
  Box<Integer> x381 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x380, x381, (x379).get(), ((x331).get() + (x315).get()), ((x363).get() + (x335).get()));
  Box<Integer> x382 = new Box<Integer>((int)0);
  Box<Integer> x383 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x382, x383, 0x0, (x366).get(), (arg1[6]));
  Box<Integer> x384 = new Box<Integer>((int)0);
  Box<Integer> x385 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x384, x385, (x383).get(), (x368).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x386 = new Box<Integer>((int)0);
  Box<Integer> x387 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x386, x387, (x385).get(), (x370).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x388 = new Box<Integer>((int)0);
  Box<Integer> x389 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x388, x389, (x387).get(), (x372).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x390 = new Box<Integer>((int)0);
  Box<Integer> x391 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x390, x391, (x389).get(), (x374).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x392 = new Box<Integer>((int)0);
  Box<Integer> x393 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x392, x393, (x391).get(), (x376).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x394 = new Box<Integer>((int)0);
  Box<Integer> x395 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x394, x395, (x393).get(), (x378).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x396 = new Box<Integer>((int)0);
  Box<Integer> x397 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x396, x397, (x395).get(), (x380).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x398 = new Box<Integer>((int)0);
  Box<Integer> x399 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x398, x399, (x382).get(), 0xd2253531);
  Box<Integer> x400 = new Box<Integer>((int)0);
  Box<Integer> x401 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x400, x401, (x398).get(), 0xffffffff);
  Box<Integer> x402 = new Box<Integer>((int)0);
  Box<Integer> x403 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x402, x403, (x398).get(), 0xffffffff);
  Box<Integer> x404 = new Box<Integer>((int)0);
  Box<Integer> x405 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x404, x405, (x398).get(), 0xffffffff);
  Box<Integer> x406 = new Box<Integer>((int)0);
  Box<Integer> x407 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x406, x407, (x398).get(), 0xffffffff);
  Box<Integer> x408 = new Box<Integer>((int)0);
  Box<Integer> x409 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x408, x409, (x398).get(), 0xffffffff);
  Box<Integer> x410 = new Box<Integer>((int)0);
  Box<Integer> x411 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x410, x411, (x398).get(), 0xffffffff);
  Box<Integer> x412 = new Box<Integer>((int)0);
  Box<Integer> x413 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x412, x413, (x398).get(), 0xfffffffe);
  Box<Integer> x414 = new Box<Integer>((int)0);
  Box<Integer> x415 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x414, x415, (x398).get(), 0xfffffc2f);
  Box<Integer> x416 = new Box<Integer>((int)0);
  Box<Integer> x417 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x416, x417, 0x0, (x415).get(), (x412).get());
  Box<Integer> x418 = new Box<Integer>((int)0);
  Box<Integer> x419 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x418, x419, (x417).get(), (x413).get(), (x410).get());
  Box<Integer> x420 = new Box<Integer>((int)0);
  Box<Integer> x421 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x420, x421, (x419).get(), (x411).get(), (x408).get());
  Box<Integer> x422 = new Box<Integer>((int)0);
  Box<Integer> x423 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x422, x423, (x421).get(), (x409).get(), (x406).get());
  Box<Integer> x424 = new Box<Integer>((int)0);
  Box<Integer> x425 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x424, x425, (x423).get(), (x407).get(), (x404).get());
  Box<Integer> x426 = new Box<Integer>((int)0);
  Box<Integer> x427 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x426, x427, (x425).get(), (x405).get(), (x402).get());
  Box<Integer> x428 = new Box<Integer>((int)0);
  Box<Integer> x429 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x428, x429, (x427).get(), (x403).get(), (x400).get());
  Box<Integer> x430 = new Box<Integer>((int)0);
  Box<Integer> x431 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x430, x431, 0x0, (x382).get(), (x414).get());
  Box<Integer> x432 = new Box<Integer>((int)0);
  Box<Integer> x433 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x432, x433, (x431).get(), (x384).get(), (x416).get());
  Box<Integer> x434 = new Box<Integer>((int)0);
  Box<Integer> x435 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x434, x435, (x433).get(), (x386).get(), (x418).get());
  Box<Integer> x436 = new Box<Integer>((int)0);
  Box<Integer> x437 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x436, x437, (x435).get(), (x388).get(), (x420).get());
  Box<Integer> x438 = new Box<Integer>((int)0);
  Box<Integer> x439 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x438, x439, (x437).get(), (x390).get(), (x422).get());
  Box<Integer> x440 = new Box<Integer>((int)0);
  Box<Integer> x441 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x440, x441, (x439).get(), (x392).get(), (x424).get());
  Box<Integer> x442 = new Box<Integer>((int)0);
  Box<Integer> x443 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x442, x443, (x441).get(), (x394).get(), (x426).get());
  Box<Integer> x444 = new Box<Integer>((int)0);
  Box<Integer> x445 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x444, x445, (x443).get(), (x396).get(), (x428).get());
  Box<Integer> x446 = new Box<Integer>((int)0);
  Box<Integer> x447 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x446, x447, (x445).get(), ((x397).get() + (x381).get()), ((x429).get() + (x401).get()));
  Box<Integer> x448 = new Box<Integer>((int)0);
  Box<Integer> x449 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x448, x449, 0x0, (x432).get(), (arg1[7]));
  Box<Integer> x450 = new Box<Integer>((int)0);
  Box<Integer> x451 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x450, x451, (x449).get(), (x434).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x452 = new Box<Integer>((int)0);
  Box<Integer> x453 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x452, x453, (x451).get(), (x436).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x454 = new Box<Integer>((int)0);
  Box<Integer> x455 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x454, x455, (x453).get(), (x438).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x456 = new Box<Integer>((int)0);
  Box<Integer> x457 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x456, x457, (x455).get(), (x440).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x458 = new Box<Integer>((int)0);
  Box<Integer> x459 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x458, x459, (x457).get(), (x442).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x460 = new Box<Integer>((int)0);
  Box<Integer> x461 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x460, x461, (x459).get(), (x444).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x462 = new Box<Integer>((int)0);
  Box<Integer> x463 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x462, x463, (x461).get(), (x446).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x464 = new Box<Integer>((int)0);
  Box<Integer> x465 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x464, x465, (x448).get(), 0xd2253531);
  Box<Integer> x466 = new Box<Integer>((int)0);
  Box<Integer> x467 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x466, x467, (x464).get(), 0xffffffff);
  Box<Integer> x468 = new Box<Integer>((int)0);
  Box<Integer> x469 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x468, x469, (x464).get(), 0xffffffff);
  Box<Integer> x470 = new Box<Integer>((int)0);
  Box<Integer> x471 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x470, x471, (x464).get(), 0xffffffff);
  Box<Integer> x472 = new Box<Integer>((int)0);
  Box<Integer> x473 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x472, x473, (x464).get(), 0xffffffff);
  Box<Integer> x474 = new Box<Integer>((int)0);
  Box<Integer> x475 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x474, x475, (x464).get(), 0xffffffff);
  Box<Integer> x476 = new Box<Integer>((int)0);
  Box<Integer> x477 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x476, x477, (x464).get(), 0xffffffff);
  Box<Integer> x478 = new Box<Integer>((int)0);
  Box<Integer> x479 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x478, x479, (x464).get(), 0xfffffffe);
  Box<Integer> x480 = new Box<Integer>((int)0);
  Box<Integer> x481 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x480, x481, (x464).get(), 0xfffffc2f);
  Box<Integer> x482 = new Box<Integer>((int)0);
  Box<Integer> x483 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x482, x483, 0x0, (x481).get(), (x478).get());
  Box<Integer> x484 = new Box<Integer>((int)0);
  Box<Integer> x485 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x484, x485, (x483).get(), (x479).get(), (x476).get());
  Box<Integer> x486 = new Box<Integer>((int)0);
  Box<Integer> x487 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x486, x487, (x485).get(), (x477).get(), (x474).get());
  Box<Integer> x488 = new Box<Integer>((int)0);
  Box<Integer> x489 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x488, x489, (x487).get(), (x475).get(), (x472).get());
  Box<Integer> x490 = new Box<Integer>((int)0);
  Box<Integer> x491 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x490, x491, (x489).get(), (x473).get(), (x470).get());
  Box<Integer> x492 = new Box<Integer>((int)0);
  Box<Integer> x493 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x492, x493, (x491).get(), (x471).get(), (x468).get());
  Box<Integer> x494 = new Box<Integer>((int)0);
  Box<Integer> x495 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x494, x495, (x493).get(), (x469).get(), (x466).get());
  Box<Integer> x496 = new Box<Integer>((int)0);
  Box<Integer> x497 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x496, x497, 0x0, (x448).get(), (x480).get());
  Box<Integer> x498 = new Box<Integer>((int)0);
  Box<Integer> x499 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x498, x499, (x497).get(), (x450).get(), (x482).get());
  Box<Integer> x500 = new Box<Integer>((int)0);
  Box<Integer> x501 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x500, x501, (x499).get(), (x452).get(), (x484).get());
  Box<Integer> x502 = new Box<Integer>((int)0);
  Box<Integer> x503 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x502, x503, (x501).get(), (x454).get(), (x486).get());
  Box<Integer> x504 = new Box<Integer>((int)0);
  Box<Integer> x505 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x504, x505, (x503).get(), (x456).get(), (x488).get());
  Box<Integer> x506 = new Box<Integer>((int)0);
  Box<Integer> x507 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x506, x507, (x505).get(), (x458).get(), (x490).get());
  Box<Integer> x508 = new Box<Integer>((int)0);
  Box<Integer> x509 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x508, x509, (x507).get(), (x460).get(), (x492).get());
  Box<Integer> x510 = new Box<Integer>((int)0);
  Box<Integer> x511 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x510, x511, (x509).get(), (x462).get(), (x494).get());
  Box<Integer> x512 = new Box<Integer>((int)0);
  Box<Integer> x513 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x512, x513, (x511).get(), ((x463).get() + (x447).get()), ((x495).get() + (x467).get()));
  Box<Integer> x514 = new Box<Integer>((int)0);
  Box<Integer> x515 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x514, x515, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x498).get(), 0xfffffc2f);
  Box<Integer> x516 = new Box<Integer>((int)0);
  Box<Integer> x517 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x516, x517, (x515).get(), (x500).get(), 0xfffffffe);
  Box<Integer> x518 = new Box<Integer>((int)0);
  Box<Integer> x519 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x518, x519, (x517).get(), (x502).get(), 0xffffffff);
  Box<Integer> x520 = new Box<Integer>((int)0);
  Box<Integer> x521 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x520, x521, (x519).get(), (x504).get(), 0xffffffff);
  Box<Integer> x522 = new Box<Integer>((int)0);
  Box<Integer> x523 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x522, x523, (x521).get(), (x506).get(), 0xffffffff);
  Box<Integer> x524 = new Box<Integer>((int)0);
  Box<Integer> x525 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x524, x525, (x523).get(), (x508).get(), 0xffffffff);
  Box<Integer> x526 = new Box<Integer>((int)0);
  Box<Integer> x527 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x526, x527, (x525).get(), (x510).get(), 0xffffffff);
  Box<Integer> x528 = new Box<Integer>((int)0);
  Box<Integer> x529 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x528, x529, (x527).get(), (x512).get(), 0xffffffff);
  Box<Integer> x530 = new Box<Integer>((int)0);
  Box<Integer> x531 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x530, x531, (x529).get(), (x513).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x532 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x532, (x531).get(), (x514).get(), (x498).get());
  Box<Integer> x533 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x533, (x531).get(), (x516).get(), (x500).get());
  Box<Integer> x534 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x534, (x531).get(), (x518).get(), (x502).get());
  Box<Integer> x535 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x535, (x531).get(), (x520).get(), (x504).get());
  Box<Integer> x536 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x536, (x531).get(), (x522).get(), (x506).get());
  Box<Integer> x537 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x537, (x531).get(), (x524).get(), (x508).get());
  Box<Integer> x538 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x538, (x531).get(), (x526).get(), (x510).get());
  Box<Integer> x539 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x539, (x531).get(), (x528).get(), (x512).get());
  out1[0] = (x532).get();
  out1[1] = (x533).get();
  out1[2] = (x534).get();
  out1[3] = (x535).get();
  out1[4] = (x536).get();
  out1[5] = (x537).get();
  out1[6] = (x538).get();
  out1[7] = (x539).get();
}

/**
 * The function fiat_Secp256K1_to_montgomery translates a field element into the Montgomery domain. <p>
 * <p>
 * Preconditions: <p>
 *   0 ≤ eval arg1 &lt; m <p>
 * Postconditions: <p>
 *   eval (from_montgomery out1) mod m = eval arg1 mod m <p>
 *   0 ≤ eval out1 &lt; m <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_to_montgomery(int[] out1, final int[] arg1) {
  int x1 = (arg1[1]);
  int x2 = (arg1[2]);
  int x3 = (arg1[3]);
  int x4 = (arg1[4]);
  int x5 = (arg1[5]);
  int x6 = (arg1[6]);
  int x7 = (arg1[7]);
  int x8 = (arg1[0]);
  Box<Integer> x9 = new Box<Integer>((int)0);
  Box<Integer> x10 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x9, x10, x8, 0x7a2);
  Box<Integer> x11 = new Box<Integer>((int)0);
  Box<Integer> x12 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x11, x12, x8, 0xe90a1);
  Box<Integer> x13 = new Box<Integer>((int)0);
  Box<Integer> x14 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x13, x14, 0x0, (x12).get(), (x9).get());
  Box<Integer> x15 = new Box<Integer>((int)0);
  Box<Integer> x16 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x15, x16, (x14).get(), (x10).get(), x8);
  Box<Integer> x17 = new Box<Integer>((int)0);
  Box<Integer> x18 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x17, x18, (x11).get(), 0xd2253531);
  Box<Integer> x19 = new Box<Integer>((int)0);
  Box<Integer> x20 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x19, x20, (x17).get(), 0xffffffff);
  Box<Integer> x21 = new Box<Integer>((int)0);
  Box<Integer> x22 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x21, x22, (x17).get(), 0xffffffff);
  Box<Integer> x23 = new Box<Integer>((int)0);
  Box<Integer> x24 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x23, x24, (x17).get(), 0xffffffff);
  Box<Integer> x25 = new Box<Integer>((int)0);
  Box<Integer> x26 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x25, x26, (x17).get(), 0xffffffff);
  Box<Integer> x27 = new Box<Integer>((int)0);
  Box<Integer> x28 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x27, x28, (x17).get(), 0xffffffff);
  Box<Integer> x29 = new Box<Integer>((int)0);
  Box<Integer> x30 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x29, x30, (x17).get(), 0xffffffff);
  Box<Integer> x31 = new Box<Integer>((int)0);
  Box<Integer> x32 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x31, x32, (x17).get(), 0xfffffffe);
  Box<Integer> x33 = new Box<Integer>((int)0);
  Box<Integer> x34 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x33, x34, (x17).get(), 0xfffffc2f);
  Box<Integer> x35 = new Box<Integer>((int)0);
  Box<Integer> x36 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x35, x36, 0x0, (x34).get(), (x31).get());
  Box<Integer> x37 = new Box<Integer>((int)0);
  Box<Integer> x38 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x37, x38, (x36).get(), (x32).get(), (x29).get());
  Box<Integer> x39 = new Box<Integer>((int)0);
  Box<Integer> x40 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x39, x40, (x38).get(), (x30).get(), (x27).get());
  Box<Integer> x41 = new Box<Integer>((int)0);
  Box<Integer> x42 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x41, x42, (x40).get(), (x28).get(), (x25).get());
  Box<Integer> x43 = new Box<Integer>((int)0);
  Box<Integer> x44 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x43, x44, (x42).get(), (x26).get(), (x23).get());
  Box<Integer> x45 = new Box<Integer>((int)0);
  Box<Integer> x46 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x45, x46, (x44).get(), (x24).get(), (x21).get());
  Box<Integer> x47 = new Box<Integer>((int)0);
  Box<Integer> x48 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x47, x48, (x46).get(), (x22).get(), (x19).get());
  Box<Integer> x49 = new Box<Integer>((int)0);
  Box<Integer> x50 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x49, x50, 0x0, (x11).get(), (x33).get());
  Box<Integer> x51 = new Box<Integer>((int)0);
  Box<Integer> x52 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x51, x52, (x50).get(), (x13).get(), (x35).get());
  Box<Integer> x53 = new Box<Integer>((int)0);
  Box<Integer> x54 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x53, x54, (x52).get(), (x15).get(), (x37).get());
  Box<Integer> x55 = new Box<Integer>((int)0);
  Box<Integer> x56 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x55, x56, (x54).get(), (x16).get(), (x39).get());
  Box<Integer> x57 = new Box<Integer>((int)0);
  Box<Integer> x58 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x57, x58, (x56).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x41).get());
  Box<Integer> x59 = new Box<Integer>((int)0);
  Box<Integer> x60 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x59, x60, (x58).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x43).get());
  Box<Integer> x61 = new Box<Integer>((int)0);
  Box<Integer> x62 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x61, x62, (x60).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x45).get());
  Box<Integer> x63 = new Box<Integer>((int)0);
  Box<Integer> x64 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x63, x64, (x62).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x47).get());
  Box<Integer> x65 = new Box<Integer>((int)0);
  Box<Integer> x66 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x65, x66, (x64).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), ((x48).get() + (x20).get()));
  Box<Integer> x67 = new Box<Integer>((int)0);
  Box<Integer> x68 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x67, x68, x1, 0x7a2);
  Box<Integer> x69 = new Box<Integer>((int)0);
  Box<Integer> x70 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x69, x70, x1, 0xe90a1);
  Box<Integer> x71 = new Box<Integer>((int)0);
  Box<Integer> x72 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x71, x72, 0x0, (x70).get(), (x67).get());
  Box<Integer> x73 = new Box<Integer>((int)0);
  Box<Integer> x74 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x73, x74, (x72).get(), (x68).get(), x1);
  Box<Integer> x75 = new Box<Integer>((int)0);
  Box<Integer> x76 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x75, x76, 0x0, (x51).get(), (x69).get());
  Box<Integer> x77 = new Box<Integer>((int)0);
  Box<Integer> x78 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x77, x78, (x76).get(), (x53).get(), (x71).get());
  Box<Integer> x79 = new Box<Integer>((int)0);
  Box<Integer> x80 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x79, x80, (x78).get(), (x55).get(), (x73).get());
  Box<Integer> x81 = new Box<Integer>((int)0);
  Box<Integer> x82 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x81, x82, (x80).get(), (x57).get(), (x74).get());
  Box<Integer> x83 = new Box<Integer>((int)0);
  Box<Integer> x84 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x83, x84, (x82).get(), (x59).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x85 = new Box<Integer>((int)0);
  Box<Integer> x86 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x85, x86, (x84).get(), (x61).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x87 = new Box<Integer>((int)0);
  Box<Integer> x88 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x87, x88, (x86).get(), (x63).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x89 = new Box<Integer>((int)0);
  Box<Integer> x90 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x89, x90, (x88).get(), (x65).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x91 = new Box<Integer>((int)0);
  Box<Integer> x92 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x91, x92, (x75).get(), 0xd2253531);
  Box<Integer> x93 = new Box<Integer>((int)0);
  Box<Integer> x94 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x93, x94, (x91).get(), 0xffffffff);
  Box<Integer> x95 = new Box<Integer>((int)0);
  Box<Integer> x96 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x95, x96, (x91).get(), 0xffffffff);
  Box<Integer> x97 = new Box<Integer>((int)0);
  Box<Integer> x98 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x97, x98, (x91).get(), 0xffffffff);
  Box<Integer> x99 = new Box<Integer>((int)0);
  Box<Integer> x100 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x99, x100, (x91).get(), 0xffffffff);
  Box<Integer> x101 = new Box<Integer>((int)0);
  Box<Integer> x102 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x101, x102, (x91).get(), 0xffffffff);
  Box<Integer> x103 = new Box<Integer>((int)0);
  Box<Integer> x104 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x103, x104, (x91).get(), 0xffffffff);
  Box<Integer> x105 = new Box<Integer>((int)0);
  Box<Integer> x106 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x105, x106, (x91).get(), 0xfffffffe);
  Box<Integer> x107 = new Box<Integer>((int)0);
  Box<Integer> x108 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x107, x108, (x91).get(), 0xfffffc2f);
  Box<Integer> x109 = new Box<Integer>((int)0);
  Box<Integer> x110 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x109, x110, 0x0, (x108).get(), (x105).get());
  Box<Integer> x111 = new Box<Integer>((int)0);
  Box<Integer> x112 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x111, x112, (x110).get(), (x106).get(), (x103).get());
  Box<Integer> x113 = new Box<Integer>((int)0);
  Box<Integer> x114 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x113, x114, (x112).get(), (x104).get(), (x101).get());
  Box<Integer> x115 = new Box<Integer>((int)0);
  Box<Integer> x116 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x115, x116, (x114).get(), (x102).get(), (x99).get());
  Box<Integer> x117 = new Box<Integer>((int)0);
  Box<Integer> x118 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x117, x118, (x116).get(), (x100).get(), (x97).get());
  Box<Integer> x119 = new Box<Integer>((int)0);
  Box<Integer> x120 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x119, x120, (x118).get(), (x98).get(), (x95).get());
  Box<Integer> x121 = new Box<Integer>((int)0);
  Box<Integer> x122 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x121, x122, (x120).get(), (x96).get(), (x93).get());
  Box<Integer> x123 = new Box<Integer>((int)0);
  Box<Integer> x124 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x123, x124, 0x0, (x75).get(), (x107).get());
  Box<Integer> x125 = new Box<Integer>((int)0);
  Box<Integer> x126 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x125, x126, (x124).get(), (x77).get(), (x109).get());
  Box<Integer> x127 = new Box<Integer>((int)0);
  Box<Integer> x128 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x127, x128, (x126).get(), (x79).get(), (x111).get());
  Box<Integer> x129 = new Box<Integer>((int)0);
  Box<Integer> x130 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x129, x130, (x128).get(), (x81).get(), (x113).get());
  Box<Integer> x131 = new Box<Integer>((int)0);
  Box<Integer> x132 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x131, x132, (x130).get(), (x83).get(), (x115).get());
  Box<Integer> x133 = new Box<Integer>((int)0);
  Box<Integer> x134 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x133, x134, (x132).get(), (x85).get(), (x117).get());
  Box<Integer> x135 = new Box<Integer>((int)0);
  Box<Integer> x136 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x135, x136, (x134).get(), (x87).get(), (x119).get());
  Box<Integer> x137 = new Box<Integer>((int)0);
  Box<Integer> x138 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x137, x138, (x136).get(), (x89).get(), (x121).get());
  Box<Integer> x139 = new Box<Integer>((int)0);
  Box<Integer> x140 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x139, x140, (x138).get(), ((x90).get() + (x66).get()), ((x122).get() + (x94).get()));
  Box<Integer> x141 = new Box<Integer>((int)0);
  Box<Integer> x142 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x141, x142, x2, 0x7a2);
  Box<Integer> x143 = new Box<Integer>((int)0);
  Box<Integer> x144 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x143, x144, x2, 0xe90a1);
  Box<Integer> x145 = new Box<Integer>((int)0);
  Box<Integer> x146 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x145, x146, 0x0, (x144).get(), (x141).get());
  Box<Integer> x147 = new Box<Integer>((int)0);
  Box<Integer> x148 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x147, x148, (x146).get(), (x142).get(), x2);
  Box<Integer> x149 = new Box<Integer>((int)0);
  Box<Integer> x150 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x149, x150, 0x0, (x125).get(), (x143).get());
  Box<Integer> x151 = new Box<Integer>((int)0);
  Box<Integer> x152 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x151, x152, (x150).get(), (x127).get(), (x145).get());
  Box<Integer> x153 = new Box<Integer>((int)0);
  Box<Integer> x154 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x153, x154, (x152).get(), (x129).get(), (x147).get());
  Box<Integer> x155 = new Box<Integer>((int)0);
  Box<Integer> x156 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x155, x156, (x154).get(), (x131).get(), (x148).get());
  Box<Integer> x157 = new Box<Integer>((int)0);
  Box<Integer> x158 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x157, x158, (x156).get(), (x133).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x159 = new Box<Integer>((int)0);
  Box<Integer> x160 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x159, x160, (x158).get(), (x135).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x161 = new Box<Integer>((int)0);
  Box<Integer> x162 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x161, x162, (x160).get(), (x137).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x163 = new Box<Integer>((int)0);
  Box<Integer> x164 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x163, x164, (x162).get(), (x139).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x165 = new Box<Integer>((int)0);
  Box<Integer> x166 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x165, x166, (x149).get(), 0xd2253531);
  Box<Integer> x167 = new Box<Integer>((int)0);
  Box<Integer> x168 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x167, x168, (x165).get(), 0xffffffff);
  Box<Integer> x169 = new Box<Integer>((int)0);
  Box<Integer> x170 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x169, x170, (x165).get(), 0xffffffff);
  Box<Integer> x171 = new Box<Integer>((int)0);
  Box<Integer> x172 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x171, x172, (x165).get(), 0xffffffff);
  Box<Integer> x173 = new Box<Integer>((int)0);
  Box<Integer> x174 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x173, x174, (x165).get(), 0xffffffff);
  Box<Integer> x175 = new Box<Integer>((int)0);
  Box<Integer> x176 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x175, x176, (x165).get(), 0xffffffff);
  Box<Integer> x177 = new Box<Integer>((int)0);
  Box<Integer> x178 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x177, x178, (x165).get(), 0xffffffff);
  Box<Integer> x179 = new Box<Integer>((int)0);
  Box<Integer> x180 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x179, x180, (x165).get(), 0xfffffffe);
  Box<Integer> x181 = new Box<Integer>((int)0);
  Box<Integer> x182 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x181, x182, (x165).get(), 0xfffffc2f);
  Box<Integer> x183 = new Box<Integer>((int)0);
  Box<Integer> x184 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x183, x184, 0x0, (x182).get(), (x179).get());
  Box<Integer> x185 = new Box<Integer>((int)0);
  Box<Integer> x186 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x185, x186, (x184).get(), (x180).get(), (x177).get());
  Box<Integer> x187 = new Box<Integer>((int)0);
  Box<Integer> x188 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x187, x188, (x186).get(), (x178).get(), (x175).get());
  Box<Integer> x189 = new Box<Integer>((int)0);
  Box<Integer> x190 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x189, x190, (x188).get(), (x176).get(), (x173).get());
  Box<Integer> x191 = new Box<Integer>((int)0);
  Box<Integer> x192 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x191, x192, (x190).get(), (x174).get(), (x171).get());
  Box<Integer> x193 = new Box<Integer>((int)0);
  Box<Integer> x194 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x193, x194, (x192).get(), (x172).get(), (x169).get());
  Box<Integer> x195 = new Box<Integer>((int)0);
  Box<Integer> x196 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x195, x196, (x194).get(), (x170).get(), (x167).get());
  Box<Integer> x197 = new Box<Integer>((int)0);
  Box<Integer> x198 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x197, x198, 0x0, (x149).get(), (x181).get());
  Box<Integer> x199 = new Box<Integer>((int)0);
  Box<Integer> x200 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x199, x200, (x198).get(), (x151).get(), (x183).get());
  Box<Integer> x201 = new Box<Integer>((int)0);
  Box<Integer> x202 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x201, x202, (x200).get(), (x153).get(), (x185).get());
  Box<Integer> x203 = new Box<Integer>((int)0);
  Box<Integer> x204 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x203, x204, (x202).get(), (x155).get(), (x187).get());
  Box<Integer> x205 = new Box<Integer>((int)0);
  Box<Integer> x206 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x205, x206, (x204).get(), (x157).get(), (x189).get());
  Box<Integer> x207 = new Box<Integer>((int)0);
  Box<Integer> x208 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x207, x208, (x206).get(), (x159).get(), (x191).get());
  Box<Integer> x209 = new Box<Integer>((int)0);
  Box<Integer> x210 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x209, x210, (x208).get(), (x161).get(), (x193).get());
  Box<Integer> x211 = new Box<Integer>((int)0);
  Box<Integer> x212 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x211, x212, (x210).get(), (x163).get(), (x195).get());
  Box<Integer> x213 = new Box<Integer>((int)0);
  Box<Integer> x214 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x213, x214, (x212).get(), ((x164).get() + (x140).get()), ((x196).get() + (x168).get()));
  Box<Integer> x215 = new Box<Integer>((int)0);
  Box<Integer> x216 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x215, x216, x3, 0x7a2);
  Box<Integer> x217 = new Box<Integer>((int)0);
  Box<Integer> x218 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x217, x218, x3, 0xe90a1);
  Box<Integer> x219 = new Box<Integer>((int)0);
  Box<Integer> x220 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x219, x220, 0x0, (x218).get(), (x215).get());
  Box<Integer> x221 = new Box<Integer>((int)0);
  Box<Integer> x222 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x221, x222, (x220).get(), (x216).get(), x3);
  Box<Integer> x223 = new Box<Integer>((int)0);
  Box<Integer> x224 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x223, x224, 0x0, (x199).get(), (x217).get());
  Box<Integer> x225 = new Box<Integer>((int)0);
  Box<Integer> x226 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x225, x226, (x224).get(), (x201).get(), (x219).get());
  Box<Integer> x227 = new Box<Integer>((int)0);
  Box<Integer> x228 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x227, x228, (x226).get(), (x203).get(), (x221).get());
  Box<Integer> x229 = new Box<Integer>((int)0);
  Box<Integer> x230 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x229, x230, (x228).get(), (x205).get(), (x222).get());
  Box<Integer> x231 = new Box<Integer>((int)0);
  Box<Integer> x232 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x231, x232, (x230).get(), (x207).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x233 = new Box<Integer>((int)0);
  Box<Integer> x234 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x233, x234, (x232).get(), (x209).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x235 = new Box<Integer>((int)0);
  Box<Integer> x236 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x235, x236, (x234).get(), (x211).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x237 = new Box<Integer>((int)0);
  Box<Integer> x238 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x237, x238, (x236).get(), (x213).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x239 = new Box<Integer>((int)0);
  Box<Integer> x240 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x239, x240, (x223).get(), 0xd2253531);
  Box<Integer> x241 = new Box<Integer>((int)0);
  Box<Integer> x242 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x241, x242, (x239).get(), 0xffffffff);
  Box<Integer> x243 = new Box<Integer>((int)0);
  Box<Integer> x244 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x243, x244, (x239).get(), 0xffffffff);
  Box<Integer> x245 = new Box<Integer>((int)0);
  Box<Integer> x246 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x245, x246, (x239).get(), 0xffffffff);
  Box<Integer> x247 = new Box<Integer>((int)0);
  Box<Integer> x248 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x247, x248, (x239).get(), 0xffffffff);
  Box<Integer> x249 = new Box<Integer>((int)0);
  Box<Integer> x250 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x249, x250, (x239).get(), 0xffffffff);
  Box<Integer> x251 = new Box<Integer>((int)0);
  Box<Integer> x252 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x251, x252, (x239).get(), 0xffffffff);
  Box<Integer> x253 = new Box<Integer>((int)0);
  Box<Integer> x254 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x253, x254, (x239).get(), 0xfffffffe);
  Box<Integer> x255 = new Box<Integer>((int)0);
  Box<Integer> x256 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x255, x256, (x239).get(), 0xfffffc2f);
  Box<Integer> x257 = new Box<Integer>((int)0);
  Box<Integer> x258 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x257, x258, 0x0, (x256).get(), (x253).get());
  Box<Integer> x259 = new Box<Integer>((int)0);
  Box<Integer> x260 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x259, x260, (x258).get(), (x254).get(), (x251).get());
  Box<Integer> x261 = new Box<Integer>((int)0);
  Box<Integer> x262 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x261, x262, (x260).get(), (x252).get(), (x249).get());
  Box<Integer> x263 = new Box<Integer>((int)0);
  Box<Integer> x264 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x263, x264, (x262).get(), (x250).get(), (x247).get());
  Box<Integer> x265 = new Box<Integer>((int)0);
  Box<Integer> x266 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x265, x266, (x264).get(), (x248).get(), (x245).get());
  Box<Integer> x267 = new Box<Integer>((int)0);
  Box<Integer> x268 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x267, x268, (x266).get(), (x246).get(), (x243).get());
  Box<Integer> x269 = new Box<Integer>((int)0);
  Box<Integer> x270 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x269, x270, (x268).get(), (x244).get(), (x241).get());
  Box<Integer> x271 = new Box<Integer>((int)0);
  Box<Integer> x272 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x271, x272, 0x0, (x223).get(), (x255).get());
  Box<Integer> x273 = new Box<Integer>((int)0);
  Box<Integer> x274 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x273, x274, (x272).get(), (x225).get(), (x257).get());
  Box<Integer> x275 = new Box<Integer>((int)0);
  Box<Integer> x276 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x275, x276, (x274).get(), (x227).get(), (x259).get());
  Box<Integer> x277 = new Box<Integer>((int)0);
  Box<Integer> x278 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x277, x278, (x276).get(), (x229).get(), (x261).get());
  Box<Integer> x279 = new Box<Integer>((int)0);
  Box<Integer> x280 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x279, x280, (x278).get(), (x231).get(), (x263).get());
  Box<Integer> x281 = new Box<Integer>((int)0);
  Box<Integer> x282 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x281, x282, (x280).get(), (x233).get(), (x265).get());
  Box<Integer> x283 = new Box<Integer>((int)0);
  Box<Integer> x284 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x283, x284, (x282).get(), (x235).get(), (x267).get());
  Box<Integer> x285 = new Box<Integer>((int)0);
  Box<Integer> x286 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x285, x286, (x284).get(), (x237).get(), (x269).get());
  Box<Integer> x287 = new Box<Integer>((int)0);
  Box<Integer> x288 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x287, x288, (x286).get(), ((x238).get() + (x214).get()), ((x270).get() + (x242).get()));
  Box<Integer> x289 = new Box<Integer>((int)0);
  Box<Integer> x290 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x289, x290, x4, 0x7a2);
  Box<Integer> x291 = new Box<Integer>((int)0);
  Box<Integer> x292 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x291, x292, x4, 0xe90a1);
  Box<Integer> x293 = new Box<Integer>((int)0);
  Box<Integer> x294 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x293, x294, 0x0, (x292).get(), (x289).get());
  Box<Integer> x295 = new Box<Integer>((int)0);
  Box<Integer> x296 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x295, x296, (x294).get(), (x290).get(), x4);
  Box<Integer> x297 = new Box<Integer>((int)0);
  Box<Integer> x298 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x297, x298, 0x0, (x273).get(), (x291).get());
  Box<Integer> x299 = new Box<Integer>((int)0);
  Box<Integer> x300 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x299, x300, (x298).get(), (x275).get(), (x293).get());
  Box<Integer> x301 = new Box<Integer>((int)0);
  Box<Integer> x302 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x301, x302, (x300).get(), (x277).get(), (x295).get());
  Box<Integer> x303 = new Box<Integer>((int)0);
  Box<Integer> x304 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x303, x304, (x302).get(), (x279).get(), (x296).get());
  Box<Integer> x305 = new Box<Integer>((int)0);
  Box<Integer> x306 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x305, x306, (x304).get(), (x281).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x307 = new Box<Integer>((int)0);
  Box<Integer> x308 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x307, x308, (x306).get(), (x283).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x309 = new Box<Integer>((int)0);
  Box<Integer> x310 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x309, x310, (x308).get(), (x285).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x311 = new Box<Integer>((int)0);
  Box<Integer> x312 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x311, x312, (x310).get(), (x287).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x313 = new Box<Integer>((int)0);
  Box<Integer> x314 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x313, x314, (x297).get(), 0xd2253531);
  Box<Integer> x315 = new Box<Integer>((int)0);
  Box<Integer> x316 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x315, x316, (x313).get(), 0xffffffff);
  Box<Integer> x317 = new Box<Integer>((int)0);
  Box<Integer> x318 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x317, x318, (x313).get(), 0xffffffff);
  Box<Integer> x319 = new Box<Integer>((int)0);
  Box<Integer> x320 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x319, x320, (x313).get(), 0xffffffff);
  Box<Integer> x321 = new Box<Integer>((int)0);
  Box<Integer> x322 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x321, x322, (x313).get(), 0xffffffff);
  Box<Integer> x323 = new Box<Integer>((int)0);
  Box<Integer> x324 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x323, x324, (x313).get(), 0xffffffff);
  Box<Integer> x325 = new Box<Integer>((int)0);
  Box<Integer> x326 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x325, x326, (x313).get(), 0xffffffff);
  Box<Integer> x327 = new Box<Integer>((int)0);
  Box<Integer> x328 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x327, x328, (x313).get(), 0xfffffffe);
  Box<Integer> x329 = new Box<Integer>((int)0);
  Box<Integer> x330 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x329, x330, (x313).get(), 0xfffffc2f);
  Box<Integer> x331 = new Box<Integer>((int)0);
  Box<Integer> x332 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x331, x332, 0x0, (x330).get(), (x327).get());
  Box<Integer> x333 = new Box<Integer>((int)0);
  Box<Integer> x334 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x333, x334, (x332).get(), (x328).get(), (x325).get());
  Box<Integer> x335 = new Box<Integer>((int)0);
  Box<Integer> x336 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x335, x336, (x334).get(), (x326).get(), (x323).get());
  Box<Integer> x337 = new Box<Integer>((int)0);
  Box<Integer> x338 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x337, x338, (x336).get(), (x324).get(), (x321).get());
  Box<Integer> x339 = new Box<Integer>((int)0);
  Box<Integer> x340 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x339, x340, (x338).get(), (x322).get(), (x319).get());
  Box<Integer> x341 = new Box<Integer>((int)0);
  Box<Integer> x342 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x341, x342, (x340).get(), (x320).get(), (x317).get());
  Box<Integer> x343 = new Box<Integer>((int)0);
  Box<Integer> x344 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x343, x344, (x342).get(), (x318).get(), (x315).get());
  Box<Integer> x345 = new Box<Integer>((int)0);
  Box<Integer> x346 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x345, x346, 0x0, (x297).get(), (x329).get());
  Box<Integer> x347 = new Box<Integer>((int)0);
  Box<Integer> x348 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x347, x348, (x346).get(), (x299).get(), (x331).get());
  Box<Integer> x349 = new Box<Integer>((int)0);
  Box<Integer> x350 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x349, x350, (x348).get(), (x301).get(), (x333).get());
  Box<Integer> x351 = new Box<Integer>((int)0);
  Box<Integer> x352 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x351, x352, (x350).get(), (x303).get(), (x335).get());
  Box<Integer> x353 = new Box<Integer>((int)0);
  Box<Integer> x354 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x353, x354, (x352).get(), (x305).get(), (x337).get());
  Box<Integer> x355 = new Box<Integer>((int)0);
  Box<Integer> x356 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x355, x356, (x354).get(), (x307).get(), (x339).get());
  Box<Integer> x357 = new Box<Integer>((int)0);
  Box<Integer> x358 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x357, x358, (x356).get(), (x309).get(), (x341).get());
  Box<Integer> x359 = new Box<Integer>((int)0);
  Box<Integer> x360 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x359, x360, (x358).get(), (x311).get(), (x343).get());
  Box<Integer> x361 = new Box<Integer>((int)0);
  Box<Integer> x362 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x361, x362, (x360).get(), ((x312).get() + (x288).get()), ((x344).get() + (x316).get()));
  Box<Integer> x363 = new Box<Integer>((int)0);
  Box<Integer> x364 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x363, x364, x5, 0x7a2);
  Box<Integer> x365 = new Box<Integer>((int)0);
  Box<Integer> x366 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x365, x366, x5, 0xe90a1);
  Box<Integer> x367 = new Box<Integer>((int)0);
  Box<Integer> x368 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x367, x368, 0x0, (x366).get(), (x363).get());
  Box<Integer> x369 = new Box<Integer>((int)0);
  Box<Integer> x370 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x369, x370, (x368).get(), (x364).get(), x5);
  Box<Integer> x371 = new Box<Integer>((int)0);
  Box<Integer> x372 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x371, x372, 0x0, (x347).get(), (x365).get());
  Box<Integer> x373 = new Box<Integer>((int)0);
  Box<Integer> x374 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x373, x374, (x372).get(), (x349).get(), (x367).get());
  Box<Integer> x375 = new Box<Integer>((int)0);
  Box<Integer> x376 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x375, x376, (x374).get(), (x351).get(), (x369).get());
  Box<Integer> x377 = new Box<Integer>((int)0);
  Box<Integer> x378 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x377, x378, (x376).get(), (x353).get(), (x370).get());
  Box<Integer> x379 = new Box<Integer>((int)0);
  Box<Integer> x380 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x379, x380, (x378).get(), (x355).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x381 = new Box<Integer>((int)0);
  Box<Integer> x382 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x381, x382, (x380).get(), (x357).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x383 = new Box<Integer>((int)0);
  Box<Integer> x384 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x383, x384, (x382).get(), (x359).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x385 = new Box<Integer>((int)0);
  Box<Integer> x386 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x385, x386, (x384).get(), (x361).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x387 = new Box<Integer>((int)0);
  Box<Integer> x388 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x387, x388, (x371).get(), 0xd2253531);
  Box<Integer> x389 = new Box<Integer>((int)0);
  Box<Integer> x390 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x389, x390, (x387).get(), 0xffffffff);
  Box<Integer> x391 = new Box<Integer>((int)0);
  Box<Integer> x392 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x391, x392, (x387).get(), 0xffffffff);
  Box<Integer> x393 = new Box<Integer>((int)0);
  Box<Integer> x394 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x393, x394, (x387).get(), 0xffffffff);
  Box<Integer> x395 = new Box<Integer>((int)0);
  Box<Integer> x396 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x395, x396, (x387).get(), 0xffffffff);
  Box<Integer> x397 = new Box<Integer>((int)0);
  Box<Integer> x398 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x397, x398, (x387).get(), 0xffffffff);
  Box<Integer> x399 = new Box<Integer>((int)0);
  Box<Integer> x400 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x399, x400, (x387).get(), 0xffffffff);
  Box<Integer> x401 = new Box<Integer>((int)0);
  Box<Integer> x402 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x401, x402, (x387).get(), 0xfffffffe);
  Box<Integer> x403 = new Box<Integer>((int)0);
  Box<Integer> x404 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x403, x404, (x387).get(), 0xfffffc2f);
  Box<Integer> x405 = new Box<Integer>((int)0);
  Box<Integer> x406 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x405, x406, 0x0, (x404).get(), (x401).get());
  Box<Integer> x407 = new Box<Integer>((int)0);
  Box<Integer> x408 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x407, x408, (x406).get(), (x402).get(), (x399).get());
  Box<Integer> x409 = new Box<Integer>((int)0);
  Box<Integer> x410 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x409, x410, (x408).get(), (x400).get(), (x397).get());
  Box<Integer> x411 = new Box<Integer>((int)0);
  Box<Integer> x412 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x411, x412, (x410).get(), (x398).get(), (x395).get());
  Box<Integer> x413 = new Box<Integer>((int)0);
  Box<Integer> x414 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x413, x414, (x412).get(), (x396).get(), (x393).get());
  Box<Integer> x415 = new Box<Integer>((int)0);
  Box<Integer> x416 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x415, x416, (x414).get(), (x394).get(), (x391).get());
  Box<Integer> x417 = new Box<Integer>((int)0);
  Box<Integer> x418 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x417, x418, (x416).get(), (x392).get(), (x389).get());
  Box<Integer> x419 = new Box<Integer>((int)0);
  Box<Integer> x420 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x419, x420, 0x0, (x371).get(), (x403).get());
  Box<Integer> x421 = new Box<Integer>((int)0);
  Box<Integer> x422 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x421, x422, (x420).get(), (x373).get(), (x405).get());
  Box<Integer> x423 = new Box<Integer>((int)0);
  Box<Integer> x424 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x423, x424, (x422).get(), (x375).get(), (x407).get());
  Box<Integer> x425 = new Box<Integer>((int)0);
  Box<Integer> x426 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x425, x426, (x424).get(), (x377).get(), (x409).get());
  Box<Integer> x427 = new Box<Integer>((int)0);
  Box<Integer> x428 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x427, x428, (x426).get(), (x379).get(), (x411).get());
  Box<Integer> x429 = new Box<Integer>((int)0);
  Box<Integer> x430 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x429, x430, (x428).get(), (x381).get(), (x413).get());
  Box<Integer> x431 = new Box<Integer>((int)0);
  Box<Integer> x432 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x431, x432, (x430).get(), (x383).get(), (x415).get());
  Box<Integer> x433 = new Box<Integer>((int)0);
  Box<Integer> x434 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x433, x434, (x432).get(), (x385).get(), (x417).get());
  Box<Integer> x435 = new Box<Integer>((int)0);
  Box<Integer> x436 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x435, x436, (x434).get(), ((x386).get() + (x362).get()), ((x418).get() + (x390).get()));
  Box<Integer> x437 = new Box<Integer>((int)0);
  Box<Integer> x438 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x437, x438, x6, 0x7a2);
  Box<Integer> x439 = new Box<Integer>((int)0);
  Box<Integer> x440 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x439, x440, x6, 0xe90a1);
  Box<Integer> x441 = new Box<Integer>((int)0);
  Box<Integer> x442 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x441, x442, 0x0, (x440).get(), (x437).get());
  Box<Integer> x443 = new Box<Integer>((int)0);
  Box<Integer> x444 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x443, x444, (x442).get(), (x438).get(), x6);
  Box<Integer> x445 = new Box<Integer>((int)0);
  Box<Integer> x446 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x445, x446, 0x0, (x421).get(), (x439).get());
  Box<Integer> x447 = new Box<Integer>((int)0);
  Box<Integer> x448 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x447, x448, (x446).get(), (x423).get(), (x441).get());
  Box<Integer> x449 = new Box<Integer>((int)0);
  Box<Integer> x450 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x449, x450, (x448).get(), (x425).get(), (x443).get());
  Box<Integer> x451 = new Box<Integer>((int)0);
  Box<Integer> x452 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x451, x452, (x450).get(), (x427).get(), (x444).get());
  Box<Integer> x453 = new Box<Integer>((int)0);
  Box<Integer> x454 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x453, x454, (x452).get(), (x429).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x455 = new Box<Integer>((int)0);
  Box<Integer> x456 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x455, x456, (x454).get(), (x431).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x457 = new Box<Integer>((int)0);
  Box<Integer> x458 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x457, x458, (x456).get(), (x433).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x459 = new Box<Integer>((int)0);
  Box<Integer> x460 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x459, x460, (x458).get(), (x435).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x461 = new Box<Integer>((int)0);
  Box<Integer> x462 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x461, x462, (x445).get(), 0xd2253531);
  Box<Integer> x463 = new Box<Integer>((int)0);
  Box<Integer> x464 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x463, x464, (x461).get(), 0xffffffff);
  Box<Integer> x465 = new Box<Integer>((int)0);
  Box<Integer> x466 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x465, x466, (x461).get(), 0xffffffff);
  Box<Integer> x467 = new Box<Integer>((int)0);
  Box<Integer> x468 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x467, x468, (x461).get(), 0xffffffff);
  Box<Integer> x469 = new Box<Integer>((int)0);
  Box<Integer> x470 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x469, x470, (x461).get(), 0xffffffff);
  Box<Integer> x471 = new Box<Integer>((int)0);
  Box<Integer> x472 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x471, x472, (x461).get(), 0xffffffff);
  Box<Integer> x473 = new Box<Integer>((int)0);
  Box<Integer> x474 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x473, x474, (x461).get(), 0xffffffff);
  Box<Integer> x475 = new Box<Integer>((int)0);
  Box<Integer> x476 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x475, x476, (x461).get(), 0xfffffffe);
  Box<Integer> x477 = new Box<Integer>((int)0);
  Box<Integer> x478 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x477, x478, (x461).get(), 0xfffffc2f);
  Box<Integer> x479 = new Box<Integer>((int)0);
  Box<Integer> x480 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x479, x480, 0x0, (x478).get(), (x475).get());
  Box<Integer> x481 = new Box<Integer>((int)0);
  Box<Integer> x482 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x481, x482, (x480).get(), (x476).get(), (x473).get());
  Box<Integer> x483 = new Box<Integer>((int)0);
  Box<Integer> x484 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x483, x484, (x482).get(), (x474).get(), (x471).get());
  Box<Integer> x485 = new Box<Integer>((int)0);
  Box<Integer> x486 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x485, x486, (x484).get(), (x472).get(), (x469).get());
  Box<Integer> x487 = new Box<Integer>((int)0);
  Box<Integer> x488 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x487, x488, (x486).get(), (x470).get(), (x467).get());
  Box<Integer> x489 = new Box<Integer>((int)0);
  Box<Integer> x490 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x489, x490, (x488).get(), (x468).get(), (x465).get());
  Box<Integer> x491 = new Box<Integer>((int)0);
  Box<Integer> x492 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x491, x492, (x490).get(), (x466).get(), (x463).get());
  Box<Integer> x493 = new Box<Integer>((int)0);
  Box<Integer> x494 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x493, x494, 0x0, (x445).get(), (x477).get());
  Box<Integer> x495 = new Box<Integer>((int)0);
  Box<Integer> x496 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x495, x496, (x494).get(), (x447).get(), (x479).get());
  Box<Integer> x497 = new Box<Integer>((int)0);
  Box<Integer> x498 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x497, x498, (x496).get(), (x449).get(), (x481).get());
  Box<Integer> x499 = new Box<Integer>((int)0);
  Box<Integer> x500 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x499, x500, (x498).get(), (x451).get(), (x483).get());
  Box<Integer> x501 = new Box<Integer>((int)0);
  Box<Integer> x502 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x501, x502, (x500).get(), (x453).get(), (x485).get());
  Box<Integer> x503 = new Box<Integer>((int)0);
  Box<Integer> x504 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x503, x504, (x502).get(), (x455).get(), (x487).get());
  Box<Integer> x505 = new Box<Integer>((int)0);
  Box<Integer> x506 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x505, x506, (x504).get(), (x457).get(), (x489).get());
  Box<Integer> x507 = new Box<Integer>((int)0);
  Box<Integer> x508 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x507, x508, (x506).get(), (x459).get(), (x491).get());
  Box<Integer> x509 = new Box<Integer>((int)0);
  Box<Integer> x510 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x509, x510, (x508).get(), ((x460).get() + (x436).get()), ((x492).get() + (x464).get()));
  Box<Integer> x511 = new Box<Integer>((int)0);
  Box<Integer> x512 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x511, x512, x7, 0x7a2);
  Box<Integer> x513 = new Box<Integer>((int)0);
  Box<Integer> x514 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x513, x514, x7, 0xe90a1);
  Box<Integer> x515 = new Box<Integer>((int)0);
  Box<Integer> x516 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x515, x516, 0x0, (x514).get(), (x511).get());
  Box<Integer> x517 = new Box<Integer>((int)0);
  Box<Integer> x518 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x517, x518, (x516).get(), (x512).get(), x7);
  Box<Integer> x519 = new Box<Integer>((int)0);
  Box<Integer> x520 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x519, x520, 0x0, (x495).get(), (x513).get());
  Box<Integer> x521 = new Box<Integer>((int)0);
  Box<Integer> x522 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x521, x522, (x520).get(), (x497).get(), (x515).get());
  Box<Integer> x523 = new Box<Integer>((int)0);
  Box<Integer> x524 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x523, x524, (x522).get(), (x499).get(), (x517).get());
  Box<Integer> x525 = new Box<Integer>((int)0);
  Box<Integer> x526 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x525, x526, (x524).get(), (x501).get(), (x518).get());
  Box<Integer> x527 = new Box<Integer>((int)0);
  Box<Integer> x528 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x527, x528, (x526).get(), (x503).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x529 = new Box<Integer>((int)0);
  Box<Integer> x530 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x529, x530, (x528).get(), (x505).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x531 = new Box<Integer>((int)0);
  Box<Integer> x532 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x531, x532, (x530).get(), (x507).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x533 = new Box<Integer>((int)0);
  Box<Integer> x534 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x533, x534, (x532).get(), (x509).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x535 = new Box<Integer>((int)0);
  Box<Integer> x536 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x535, x536, (x519).get(), 0xd2253531);
  Box<Integer> x537 = new Box<Integer>((int)0);
  Box<Integer> x538 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x537, x538, (x535).get(), 0xffffffff);
  Box<Integer> x539 = new Box<Integer>((int)0);
  Box<Integer> x540 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x539, x540, (x535).get(), 0xffffffff);
  Box<Integer> x541 = new Box<Integer>((int)0);
  Box<Integer> x542 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x541, x542, (x535).get(), 0xffffffff);
  Box<Integer> x543 = new Box<Integer>((int)0);
  Box<Integer> x544 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x543, x544, (x535).get(), 0xffffffff);
  Box<Integer> x545 = new Box<Integer>((int)0);
  Box<Integer> x546 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x545, x546, (x535).get(), 0xffffffff);
  Box<Integer> x547 = new Box<Integer>((int)0);
  Box<Integer> x548 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x547, x548, (x535).get(), 0xffffffff);
  Box<Integer> x549 = new Box<Integer>((int)0);
  Box<Integer> x550 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x549, x550, (x535).get(), 0xfffffffe);
  Box<Integer> x551 = new Box<Integer>((int)0);
  Box<Integer> x552 = new Box<Integer>((int)0);
  fiat_Secp256K1_mulx_u32(x551, x552, (x535).get(), 0xfffffc2f);
  Box<Integer> x553 = new Box<Integer>((int)0);
  Box<Integer> x554 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x553, x554, 0x0, (x552).get(), (x549).get());
  Box<Integer> x555 = new Box<Integer>((int)0);
  Box<Integer> x556 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x555, x556, (x554).get(), (x550).get(), (x547).get());
  Box<Integer> x557 = new Box<Integer>((int)0);
  Box<Integer> x558 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x557, x558, (x556).get(), (x548).get(), (x545).get());
  Box<Integer> x559 = new Box<Integer>((int)0);
  Box<Integer> x560 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x559, x560, (x558).get(), (x546).get(), (x543).get());
  Box<Integer> x561 = new Box<Integer>((int)0);
  Box<Integer> x562 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x561, x562, (x560).get(), (x544).get(), (x541).get());
  Box<Integer> x563 = new Box<Integer>((int)0);
  Box<Integer> x564 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x563, x564, (x562).get(), (x542).get(), (x539).get());
  Box<Integer> x565 = new Box<Integer>((int)0);
  Box<Integer> x566 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x565, x566, (x564).get(), (x540).get(), (x537).get());
  Box<Integer> x567 = new Box<Integer>((int)0);
  Box<Integer> x568 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x567, x568, 0x0, (x519).get(), (x551).get());
  Box<Integer> x569 = new Box<Integer>((int)0);
  Box<Integer> x570 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x569, x570, (x568).get(), (x521).get(), (x553).get());
  Box<Integer> x571 = new Box<Integer>((int)0);
  Box<Integer> x572 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x571, x572, (x570).get(), (x523).get(), (x555).get());
  Box<Integer> x573 = new Box<Integer>((int)0);
  Box<Integer> x574 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x573, x574, (x572).get(), (x525).get(), (x557).get());
  Box<Integer> x575 = new Box<Integer>((int)0);
  Box<Integer> x576 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x575, x576, (x574).get(), (x527).get(), (x559).get());
  Box<Integer> x577 = new Box<Integer>((int)0);
  Box<Integer> x578 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x577, x578, (x576).get(), (x529).get(), (x561).get());
  Box<Integer> x579 = new Box<Integer>((int)0);
  Box<Integer> x580 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x579, x580, (x578).get(), (x531).get(), (x563).get());
  Box<Integer> x581 = new Box<Integer>((int)0);
  Box<Integer> x582 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x581, x582, (x580).get(), (x533).get(), (x565).get());
  Box<Integer> x583 = new Box<Integer>((int)0);
  Box<Integer> x584 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x583, x584, (x582).get(), ((x534).get() + (x510).get()), ((x566).get() + (x538).get()));
  Box<Integer> x585 = new Box<Integer>((int)0);
  Box<Integer> x586 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x585, x586, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x569).get(), 0xfffffc2f);
  Box<Integer> x587 = new Box<Integer>((int)0);
  Box<Integer> x588 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x587, x588, (x586).get(), (x571).get(), 0xfffffffe);
  Box<Integer> x589 = new Box<Integer>((int)0);
  Box<Integer> x590 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x589, x590, (x588).get(), (x573).get(), 0xffffffff);
  Box<Integer> x591 = new Box<Integer>((int)0);
  Box<Integer> x592 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x591, x592, (x590).get(), (x575).get(), 0xffffffff);
  Box<Integer> x593 = new Box<Integer>((int)0);
  Box<Integer> x594 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x593, x594, (x592).get(), (x577).get(), 0xffffffff);
  Box<Integer> x595 = new Box<Integer>((int)0);
  Box<Integer> x596 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x595, x596, (x594).get(), (x579).get(), 0xffffffff);
  Box<Integer> x597 = new Box<Integer>((int)0);
  Box<Integer> x598 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x597, x598, (x596).get(), (x581).get(), 0xffffffff);
  Box<Integer> x599 = new Box<Integer>((int)0);
  Box<Integer> x600 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x599, x600, (x598).get(), (x583).get(), 0xffffffff);
  Box<Integer> x601 = new Box<Integer>((int)0);
  Box<Integer> x602 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x601, x602, (x600).get(), (x584).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x603 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x603, (x602).get(), (x585).get(), (x569).get());
  Box<Integer> x604 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x604, (x602).get(), (x587).get(), (x571).get());
  Box<Integer> x605 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x605, (x602).get(), (x589).get(), (x573).get());
  Box<Integer> x606 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x606, (x602).get(), (x591).get(), (x575).get());
  Box<Integer> x607 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x607, (x602).get(), (x593).get(), (x577).get());
  Box<Integer> x608 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x608, (x602).get(), (x595).get(), (x579).get());
  Box<Integer> x609 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x609, (x602).get(), (x597).get(), (x581).get());
  Box<Integer> x610 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x610, (x602).get(), (x599).get(), (x583).get());
  out1[0] = (x603).get();
  out1[1] = (x604).get();
  out1[2] = (x605).get();
  out1[3] = (x606).get();
  out1[4] = (x607).get();
  out1[5] = (x608).get();
  out1[6] = (x609).get();
  out1[7] = (x610).get();
}

/**
 * The function fiat_Secp256K1_nonzero outputs a single non-zero word if the input is non-zero and zero otherwise. <p>
 * <p>
 * Preconditions: <p>
 *   0 ≤ eval arg1 &lt; m <p>
 * Postconditions: <p>
 *   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0 <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 * Output Bounds: <p>
 *   out1: [0x0 ~&gt; 0xffffffff] <p>
 */
public static void fiat_Secp256K1_nonzero(Box<Integer> out1, final int[] arg1) {
  int x1 = ((arg1[0]) | ((arg1[1]) | ((arg1[2]) | ((arg1[3]) | ((arg1[4]) | ((arg1[5]) | ((arg1[6]) | (arg1[7]))))))));
  out1.set(x1);
}

/**
 * The function fiat_Secp256K1_selectznz is a multi-limb conditional select. <p>
 * <p>
 * Postconditions: <p>
 *   eval out1 = (if arg1 = 0 then eval arg2 else eval arg3) <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [0x0 ~&gt; 0x1] <p>
 *   arg2: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 *   arg3: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_selectznz(int[] out1, int arg1, final int[] arg2, final int[] arg3) {
  Box<Integer> x1 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x1, arg1, (arg2[0]), (arg3[0]));
  Box<Integer> x2 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x2, arg1, (arg2[1]), (arg3[1]));
  Box<Integer> x3 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x3, arg1, (arg2[2]), (arg3[2]));
  Box<Integer> x4 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x4, arg1, (arg2[3]), (arg3[3]));
  Box<Integer> x5 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x5, arg1, (arg2[4]), (arg3[4]));
  Box<Integer> x6 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x6, arg1, (arg2[5]), (arg3[5]));
  Box<Integer> x7 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x7, arg1, (arg2[6]), (arg3[6]));
  Box<Integer> x8 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x8, arg1, (arg2[7]), (arg3[7]));
  out1[0] = (x1).get();
  out1[1] = (x2).get();
  out1[2] = (x3).get();
  out1[3] = (x4).get();
  out1[4] = (x5).get();
  out1[5] = (x6).get();
  out1[6] = (x7).get();
  out1[7] = (x8).get();
}

/**
 * The function fiat_Secp256K1_to_bytes serializes a field element NOT in the Montgomery domain to bytes in little-endian order. <p>
 * <p>
 * Preconditions: <p>
 *   0 ≤ eval arg1 &lt; m <p>
 * Postconditions: <p>
 *   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..31] <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff]] <p>
 */
public static void fiat_Secp256K1_to_bytes(int[] out1, final int[] arg1) {
  int x1 = (arg1[7]);
  int x2 = (arg1[6]);
  int x3 = (arg1[5]);
  int x4 = (arg1[4]);
  int x5 = (arg1[3]);
  int x6 = (arg1[2]);
  int x7 = (arg1[1]);
  int x8 = (arg1[0]);
  int x9 = (x8 & 0xff);
  int x10 = (x8 >>> 8);
  int x11 = (x10 & 0xff);
  int x12 = (x10 >>> 8);
  int x13 = (x12 & 0xff);
  int x14 = (x12 >>> 8);
  int x15 = (x7 & 0xff);
  int x16 = (x7 >>> 8);
  int x17 = (x16 & 0xff);
  int x18 = (x16 >>> 8);
  int x19 = (x18 & 0xff);
  int x20 = (x18 >>> 8);
  int x21 = (x6 & 0xff);
  int x22 = (x6 >>> 8);
  int x23 = (x22 & 0xff);
  int x24 = (x22 >>> 8);
  int x25 = (x24 & 0xff);
  int x26 = (x24 >>> 8);
  int x27 = (x5 & 0xff);
  int x28 = (x5 >>> 8);
  int x29 = (x28 & 0xff);
  int x30 = (x28 >>> 8);
  int x31 = (x30 & 0xff);
  int x32 = (x30 >>> 8);
  int x33 = (x4 & 0xff);
  int x34 = (x4 >>> 8);
  int x35 = (x34 & 0xff);
  int x36 = (x34 >>> 8);
  int x37 = (x36 & 0xff);
  int x38 = (x36 >>> 8);
  int x39 = (x3 & 0xff);
  int x40 = (x3 >>> 8);
  int x41 = (x40 & 0xff);
  int x42 = (x40 >>> 8);
  int x43 = (x42 & 0xff);
  int x44 = (x42 >>> 8);
  int x45 = (x2 & 0xff);
  int x46 = (x2 >>> 8);
  int x47 = (x46 & 0xff);
  int x48 = (x46 >>> 8);
  int x49 = (x48 & 0xff);
  int x50 = (x48 >>> 8);
  int x51 = (x1 & 0xff);
  int x52 = (x1 >>> 8);
  int x53 = (x52 & 0xff);
  int x54 = (x52 >>> 8);
  int x55 = (x54 & 0xff);
  int x56 = (x54 >>> 8);
  out1[0] = x9;
  out1[1] = x11;
  out1[2] = x13;
  out1[3] = x14;
  out1[4] = x15;
  out1[5] = x17;
  out1[6] = x19;
  out1[7] = x20;
  out1[8] = x21;
  out1[9] = x23;
  out1[10] = x25;
  out1[11] = x26;
  out1[12] = x27;
  out1[13] = x29;
  out1[14] = x31;
  out1[15] = x32;
  out1[16] = x33;
  out1[17] = x35;
  out1[18] = x37;
  out1[19] = x38;
  out1[20] = x39;
  out1[21] = x41;
  out1[22] = x43;
  out1[23] = x44;
  out1[24] = x45;
  out1[25] = x47;
  out1[26] = x49;
  out1[27] = x50;
  out1[28] = x51;
  out1[29] = x53;
  out1[30] = x55;
  out1[31] = x56;
}

/**
 * The function fiat_Secp256K1_from_bytes deserializes a field element NOT in the Montgomery domain from bytes in little-endian order. <p>
 * <p>
 * Preconditions: <p>
 *   0 ≤ bytes_eval arg1 &lt; m <p>
 * Postconditions: <p>
 *   eval out1 mod m = bytes_eval arg1 mod m <p>
 *   0 ≤ eval out1 &lt; m <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [[0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff], [0x0 ~&gt; 0xff]] <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_from_bytes(int[] out1, final int[] arg1) {
  int x1 = ((arg1[31]) << 24);
  int x2 = ((arg1[30]) << 16);
  int x3 = ((arg1[29]) << 8);
  int x4 = (arg1[28]);
  int x5 = ((arg1[27]) << 24);
  int x6 = ((arg1[26]) << 16);
  int x7 = ((arg1[25]) << 8);
  int x8 = (arg1[24]);
  int x9 = ((arg1[23]) << 24);
  int x10 = ((arg1[22]) << 16);
  int x11 = ((arg1[21]) << 8);
  int x12 = (arg1[20]);
  int x13 = ((arg1[19]) << 24);
  int x14 = ((arg1[18]) << 16);
  int x15 = ((arg1[17]) << 8);
  int x16 = (arg1[16]);
  int x17 = ((arg1[15]) << 24);
  int x18 = ((arg1[14]) << 16);
  int x19 = ((arg1[13]) << 8);
  int x20 = (arg1[12]);
  int x21 = ((arg1[11]) << 24);
  int x22 = ((arg1[10]) << 16);
  int x23 = ((arg1[9]) << 8);
  int x24 = (arg1[8]);
  int x25 = ((arg1[7]) << 24);
  int x26 = ((arg1[6]) << 16);
  int x27 = ((arg1[5]) << 8);
  int x28 = (arg1[4]);
  int x29 = ((arg1[3]) << 24);
  int x30 = ((arg1[2]) << 16);
  int x31 = ((arg1[1]) << 8);
  int x32 = (arg1[0]);
  int x33 = (x31 + x32);
  int x34 = (x30 + x33);
  int x35 = (x29 + x34);
  int x36 = (x27 + x28);
  int x37 = (x26 + x36);
  int x38 = (x25 + x37);
  int x39 = (x23 + x24);
  int x40 = (x22 + x39);
  int x41 = (x21 + x40);
  int x42 = (x19 + x20);
  int x43 = (x18 + x42);
  int x44 = (x17 + x43);
  int x45 = (x15 + x16);
  int x46 = (x14 + x45);
  int x47 = (x13 + x46);
  int x48 = (x11 + x12);
  int x49 = (x10 + x48);
  int x50 = (x9 + x49);
  int x51 = (x7 + x8);
  int x52 = (x6 + x51);
  int x53 = (x5 + x52);
  int x54 = (x3 + x4);
  int x55 = (x2 + x54);
  int x56 = (x1 + x55);
  out1[0] = x35;
  out1[1] = x38;
  out1[2] = x41;
  out1[3] = x44;
  out1[4] = x47;
  out1[5] = x50;
  out1[6] = x53;
  out1[7] = x56;
}

/**
 * The function fiat_Secp256K1_set_one returns the field element one in the Montgomery domain. <p>
 * <p>
 * Postconditions: <p>
 *   eval (from_montgomery out1) mod m = 1 mod m <p>
 *   0 ≤ eval out1 &lt; m <p>
 * <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_set_one(int[] out1) {
  out1[0] = 0x3d1;
  out1[1] = 0x1;
  out1[2] = (int) Integer.toUnsignedLong(((Number) (0x0)).intValue());
  out1[3] = (int) Integer.toUnsignedLong(((Number) (0x0)).intValue());
  out1[4] = (int) Integer.toUnsignedLong(((Number) (0x0)).intValue());
  out1[5] = (int) Integer.toUnsignedLong(((Number) (0x0)).intValue());
  out1[6] = (int) Integer.toUnsignedLong(((Number) (0x0)).intValue());
  out1[7] = (int) Integer.toUnsignedLong(((Number) (0x0)).intValue());
}

/**
 * The function fiat_Secp256K1_msat returns the saturated representation of the prime modulus. <p>
 * <p>
 * Postconditions: <p>
 *   twos_complement_eval out1 = m <p>
 *   0 ≤ eval out1 &lt; m <p>
 * <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_msat(int[] out1) {
  out1[0] = 0xfffffc2f;
  out1[1] = 0xfffffffe;
  out1[2] = 0xffffffff;
  out1[3] = 0xffffffff;
  out1[4] = 0xffffffff;
  out1[5] = 0xffffffff;
  out1[6] = 0xffffffff;
  out1[7] = 0xffffffff;
  out1[8] = (int) Integer.toUnsignedLong(((Number) (0x0)).intValue());
}

/**
 * The function fiat_Secp256K1_divstep computes a divstep. <p>
 * <p>
 * Preconditions: <p>
 *   0 ≤ eval arg4 &lt; m <p>
 *   0 ≤ eval arg5 &lt; m <p>
 * Postconditions: <p>
 *   out1 = (if 0 &lt; arg1 ∧ (twos_complement_eval arg3) is odd then 1 - arg1 else 1 + arg1) <p>
 *   twos_complement_eval out2 = (if 0 &lt; arg1 ∧ (twos_complement_eval arg3) is odd then twos_complement_eval arg3 else twos_complement_eval arg2) <p>
 *   twos_complement_eval out3 = (if 0 &lt; arg1 ∧ (twos_complement_eval arg3) is odd then ⌊(twos_complement_eval arg3 - twos_complement_eval arg2) / 2⌋ else ⌊(twos_complement_eval arg3 + (twos_complement_eval arg3 mod 2) * twos_complement_eval arg2) / 2⌋) <p>
 *   eval (from_montgomery out4) mod m = (if 0 &lt; arg1 ∧ (twos_complement_eval arg3) is odd then (2 * eval (from_montgomery arg5)) mod m else (2 * eval (from_montgomery arg4)) mod m) <p>
 *   eval (from_montgomery out5) mod m = (if 0 &lt; arg1 ∧ (twos_complement_eval arg3) is odd then (eval (from_montgomery arg4) - eval (from_montgomery arg4)) mod m else (eval (from_montgomery arg5) + (twos_complement_eval arg3 mod 2) * eval (from_montgomery arg4)) mod m) <p>
 *   0 ≤ eval out5 &lt; m <p>
 *   0 ≤ eval out5 &lt; m <p>
 *   0 ≤ eval out2 &lt; m <p>
 *   0 ≤ eval out3 &lt; m <p>
 * <p>
 * Input Bounds: <p>
 *   arg1: [0x0 ~&gt; 0xffffffff] <p>
 *   arg2: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 *   arg3: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 *   arg4: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 *   arg5: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 * Output Bounds: <p>
 *   out1: [0x0 ~&gt; 0xffffffff] <p>
 *   out2: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 *   out3: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 *   out4: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 *   out5: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_divstep(Box<Integer> out1, int[] out2, int[] out3, int[] out4, int[] out5, int arg1, final int[] arg2, final int[] arg3, final int[] arg4, final int[] arg5) {
  Box<Integer> x1 = new Box<Integer>((int)0);
  Box<Integer> x2 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x1, x2, 0x0, (~arg1), 0x1);
  int x3 = (((x1).get() >>> 31) & ((arg3[0]) & 0x1));
  Box<Integer> x4 = new Box<Integer>((int)0);
  Box<Integer> x5 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x4, x5, 0x0, (~arg1), 0x1);
  Box<Integer> x6 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x6, x3, arg1, (x4).get());
  Box<Integer> x7 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x7, x3, (arg2[0]), (arg3[0]));
  Box<Integer> x8 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x8, x3, (arg2[1]), (arg3[1]));
  Box<Integer> x9 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x9, x3, (arg2[2]), (arg3[2]));
  Box<Integer> x10 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x10, x3, (arg2[3]), (arg3[3]));
  Box<Integer> x11 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x11, x3, (arg2[4]), (arg3[4]));
  Box<Integer> x12 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x12, x3, (arg2[5]), (arg3[5]));
  Box<Integer> x13 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x13, x3, (arg2[6]), (arg3[6]));
  Box<Integer> x14 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x14, x3, (arg2[7]), (arg3[7]));
  Box<Integer> x15 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x15, x3, (arg2[8]), (arg3[8]));
  Box<Integer> x16 = new Box<Integer>((int)0);
  Box<Integer> x17 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x16, x17, 0x0, 0x1, (~(arg2[0])));
  Box<Integer> x18 = new Box<Integer>((int)0);
  Box<Integer> x19 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x18, x19, (x17).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (~(arg2[1])));
  Box<Integer> x20 = new Box<Integer>((int)0);
  Box<Integer> x21 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x20, x21, (x19).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (~(arg2[2])));
  Box<Integer> x22 = new Box<Integer>((int)0);
  Box<Integer> x23 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x22, x23, (x21).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (~(arg2[3])));
  Box<Integer> x24 = new Box<Integer>((int)0);
  Box<Integer> x25 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x24, x25, (x23).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (~(arg2[4])));
  Box<Integer> x26 = new Box<Integer>((int)0);
  Box<Integer> x27 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x26, x27, (x25).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (~(arg2[5])));
  Box<Integer> x28 = new Box<Integer>((int)0);
  Box<Integer> x29 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x28, x29, (x27).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (~(arg2[6])));
  Box<Integer> x30 = new Box<Integer>((int)0);
  Box<Integer> x31 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x30, x31, (x29).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (~(arg2[7])));
  Box<Integer> x32 = new Box<Integer>((int)0);
  Box<Integer> x33 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x32, x33, (x31).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (~(arg2[8])));
  Box<Integer> x34 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x34, x3, (arg3[0]), (x16).get());
  Box<Integer> x35 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x35, x3, (arg3[1]), (x18).get());
  Box<Integer> x36 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x36, x3, (arg3[2]), (x20).get());
  Box<Integer> x37 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x37, x3, (arg3[3]), (x22).get());
  Box<Integer> x38 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x38, x3, (arg3[4]), (x24).get());
  Box<Integer> x39 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x39, x3, (arg3[5]), (x26).get());
  Box<Integer> x40 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x40, x3, (arg3[6]), (x28).get());
  Box<Integer> x41 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x41, x3, (arg3[7]), (x30).get());
  Box<Integer> x42 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x42, x3, (arg3[8]), (x32).get());
  Box<Integer> x43 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x43, x3, (arg4[0]), (arg5[0]));
  Box<Integer> x44 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x44, x3, (arg4[1]), (arg5[1]));
  Box<Integer> x45 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x45, x3, (arg4[2]), (arg5[2]));
  Box<Integer> x46 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x46, x3, (arg4[3]), (arg5[3]));
  Box<Integer> x47 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x47, x3, (arg4[4]), (arg5[4]));
  Box<Integer> x48 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x48, x3, (arg4[5]), (arg5[5]));
  Box<Integer> x49 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x49, x3, (arg4[6]), (arg5[6]));
  Box<Integer> x50 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x50, x3, (arg4[7]), (arg5[7]));
  Box<Integer> x51 = new Box<Integer>((int)0);
  Box<Integer> x52 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x51, x52, 0x0, (x43).get(), (x43).get());
  Box<Integer> x53 = new Box<Integer>((int)0);
  Box<Integer> x54 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x53, x54, (x52).get(), (x44).get(), (x44).get());
  Box<Integer> x55 = new Box<Integer>((int)0);
  Box<Integer> x56 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x55, x56, (x54).get(), (x45).get(), (x45).get());
  Box<Integer> x57 = new Box<Integer>((int)0);
  Box<Integer> x58 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x57, x58, (x56).get(), (x46).get(), (x46).get());
  Box<Integer> x59 = new Box<Integer>((int)0);
  Box<Integer> x60 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x59, x60, (x58).get(), (x47).get(), (x47).get());
  Box<Integer> x61 = new Box<Integer>((int)0);
  Box<Integer> x62 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x61, x62, (x60).get(), (x48).get(), (x48).get());
  Box<Integer> x63 = new Box<Integer>((int)0);
  Box<Integer> x64 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x63, x64, (x62).get(), (x49).get(), (x49).get());
  Box<Integer> x65 = new Box<Integer>((int)0);
  Box<Integer> x66 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x65, x66, (x64).get(), (x50).get(), (x50).get());
  Box<Integer> x67 = new Box<Integer>((int)0);
  Box<Integer> x68 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x67, x68, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x51).get(), 0xfffffc2f);
  Box<Integer> x69 = new Box<Integer>((int)0);
  Box<Integer> x70 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x69, x70, (x68).get(), (x53).get(), 0xfffffffe);
  Box<Integer> x71 = new Box<Integer>((int)0);
  Box<Integer> x72 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x71, x72, (x70).get(), (x55).get(), 0xffffffff);
  Box<Integer> x73 = new Box<Integer>((int)0);
  Box<Integer> x74 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x73, x74, (x72).get(), (x57).get(), 0xffffffff);
  Box<Integer> x75 = new Box<Integer>((int)0);
  Box<Integer> x76 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x75, x76, (x74).get(), (x59).get(), 0xffffffff);
  Box<Integer> x77 = new Box<Integer>((int)0);
  Box<Integer> x78 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x77, x78, (x76).get(), (x61).get(), 0xffffffff);
  Box<Integer> x79 = new Box<Integer>((int)0);
  Box<Integer> x80 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x79, x80, (x78).get(), (x63).get(), 0xffffffff);
  Box<Integer> x81 = new Box<Integer>((int)0);
  Box<Integer> x82 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x81, x82, (x80).get(), (x65).get(), 0xffffffff);
  Box<Integer> x83 = new Box<Integer>((int)0);
  Box<Integer> x84 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x83, x84, (x82).get(), (x66).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  int x85 = (arg4[7]);
  int x86 = (arg4[6]);
  int x87 = (arg4[5]);
  int x88 = (arg4[4]);
  int x89 = (arg4[3]);
  int x90 = (arg4[2]);
  int x91 = (arg4[1]);
  int x92 = (arg4[0]);
  Box<Integer> x93 = new Box<Integer>((int)0);
  Box<Integer> x94 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x93, x94, 0x0, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), x92);
  Box<Integer> x95 = new Box<Integer>((int)0);
  Box<Integer> x96 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x95, x96, (x94).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), x91);
  Box<Integer> x97 = new Box<Integer>((int)0);
  Box<Integer> x98 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x97, x98, (x96).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), x90);
  Box<Integer> x99 = new Box<Integer>((int)0);
  Box<Integer> x100 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x99, x100, (x98).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), x89);
  Box<Integer> x101 = new Box<Integer>((int)0);
  Box<Integer> x102 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x101, x102, (x100).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), x88);
  Box<Integer> x103 = new Box<Integer>((int)0);
  Box<Integer> x104 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x103, x104, (x102).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), x87);
  Box<Integer> x105 = new Box<Integer>((int)0);
  Box<Integer> x106 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x105, x106, (x104).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), x86);
  Box<Integer> x107 = new Box<Integer>((int)0);
  Box<Integer> x108 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x107, x108, (x106).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), x85);
  Box<Integer> x109 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x109, (x108).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), 0xffffffff);
  Box<Integer> x110 = new Box<Integer>((int)0);
  Box<Integer> x111 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x110, x111, 0x0, (x93).get(), ((x109).get() & 0xfffffc2f));
  Box<Integer> x112 = new Box<Integer>((int)0);
  Box<Integer> x113 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x112, x113, (x111).get(), (x95).get(), ((x109).get() & 0xfffffffe));
  Box<Integer> x114 = new Box<Integer>((int)0);
  Box<Integer> x115 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x114, x115, (x113).get(), (x97).get(), (x109).get());
  Box<Integer> x116 = new Box<Integer>((int)0);
  Box<Integer> x117 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x116, x117, (x115).get(), (x99).get(), (x109).get());
  Box<Integer> x118 = new Box<Integer>((int)0);
  Box<Integer> x119 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x118, x119, (x117).get(), (x101).get(), (x109).get());
  Box<Integer> x120 = new Box<Integer>((int)0);
  Box<Integer> x121 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x120, x121, (x119).get(), (x103).get(), (x109).get());
  Box<Integer> x122 = new Box<Integer>((int)0);
  Box<Integer> x123 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x122, x123, (x121).get(), (x105).get(), (x109).get());
  Box<Integer> x124 = new Box<Integer>((int)0);
  Box<Integer> x125 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x124, x125, (x123).get(), (x107).get(), (x109).get());
  Box<Integer> x126 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x126, x3, (arg5[0]), (x110).get());
  Box<Integer> x127 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x127, x3, (arg5[1]), (x112).get());
  Box<Integer> x128 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x128, x3, (arg5[2]), (x114).get());
  Box<Integer> x129 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x129, x3, (arg5[3]), (x116).get());
  Box<Integer> x130 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x130, x3, (arg5[4]), (x118).get());
  Box<Integer> x131 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x131, x3, (arg5[5]), (x120).get());
  Box<Integer> x132 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x132, x3, (arg5[6]), (x122).get());
  Box<Integer> x133 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x133, x3, (arg5[7]), (x124).get());
  int x134 = ((x34).get() & 0x1);
  Box<Integer> x135 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x135, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x7).get());
  Box<Integer> x136 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x136, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x8).get());
  Box<Integer> x137 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x137, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x9).get());
  Box<Integer> x138 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x138, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x10).get());
  Box<Integer> x139 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x139, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x11).get());
  Box<Integer> x140 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x140, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x12).get());
  Box<Integer> x141 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x141, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x13).get());
  Box<Integer> x142 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x142, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x14).get());
  Box<Integer> x143 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x143, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x15).get());
  Box<Integer> x144 = new Box<Integer>((int)0);
  Box<Integer> x145 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x144, x145, 0x0, (x34).get(), (x135).get());
  Box<Integer> x146 = new Box<Integer>((int)0);
  Box<Integer> x147 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x146, x147, (x145).get(), (x35).get(), (x136).get());
  Box<Integer> x148 = new Box<Integer>((int)0);
  Box<Integer> x149 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x148, x149, (x147).get(), (x36).get(), (x137).get());
  Box<Integer> x150 = new Box<Integer>((int)0);
  Box<Integer> x151 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x150, x151, (x149).get(), (x37).get(), (x138).get());
  Box<Integer> x152 = new Box<Integer>((int)0);
  Box<Integer> x153 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x152, x153, (x151).get(), (x38).get(), (x139).get());
  Box<Integer> x154 = new Box<Integer>((int)0);
  Box<Integer> x155 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x154, x155, (x153).get(), (x39).get(), (x140).get());
  Box<Integer> x156 = new Box<Integer>((int)0);
  Box<Integer> x157 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x156, x157, (x155).get(), (x40).get(), (x141).get());
  Box<Integer> x158 = new Box<Integer>((int)0);
  Box<Integer> x159 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x158, x159, (x157).get(), (x41).get(), (x142).get());
  Box<Integer> x160 = new Box<Integer>((int)0);
  Box<Integer> x161 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x160, x161, (x159).get(), (x42).get(), (x143).get());
  Box<Integer> x162 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x162, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x43).get());
  Box<Integer> x163 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x163, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x44).get());
  Box<Integer> x164 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x164, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x45).get());
  Box<Integer> x165 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x165, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x46).get());
  Box<Integer> x166 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x166, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x47).get());
  Box<Integer> x167 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x167, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x48).get());
  Box<Integer> x168 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x168, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x49).get());
  Box<Integer> x169 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x169, x134, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x50).get());
  Box<Integer> x170 = new Box<Integer>((int)0);
  Box<Integer> x171 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x170, x171, 0x0, (x126).get(), (x162).get());
  Box<Integer> x172 = new Box<Integer>((int)0);
  Box<Integer> x173 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x172, x173, (x171).get(), (x127).get(), (x163).get());
  Box<Integer> x174 = new Box<Integer>((int)0);
  Box<Integer> x175 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x174, x175, (x173).get(), (x128).get(), (x164).get());
  Box<Integer> x176 = new Box<Integer>((int)0);
  Box<Integer> x177 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x176, x177, (x175).get(), (x129).get(), (x165).get());
  Box<Integer> x178 = new Box<Integer>((int)0);
  Box<Integer> x179 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x178, x179, (x177).get(), (x130).get(), (x166).get());
  Box<Integer> x180 = new Box<Integer>((int)0);
  Box<Integer> x181 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x180, x181, (x179).get(), (x131).get(), (x167).get());
  Box<Integer> x182 = new Box<Integer>((int)0);
  Box<Integer> x183 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x182, x183, (x181).get(), (x132).get(), (x168).get());
  Box<Integer> x184 = new Box<Integer>((int)0);
  Box<Integer> x185 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x184, x185, (x183).get(), (x133).get(), (x169).get());
  Box<Integer> x186 = new Box<Integer>((int)0);
  Box<Integer> x187 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x186, x187, (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()), (x170).get(), 0xfffffc2f);
  Box<Integer> x188 = new Box<Integer>((int)0);
  Box<Integer> x189 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x188, x189, (x187).get(), (x172).get(), 0xfffffffe);
  Box<Integer> x190 = new Box<Integer>((int)0);
  Box<Integer> x191 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x190, x191, (x189).get(), (x174).get(), 0xffffffff);
  Box<Integer> x192 = new Box<Integer>((int)0);
  Box<Integer> x193 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x192, x193, (x191).get(), (x176).get(), 0xffffffff);
  Box<Integer> x194 = new Box<Integer>((int)0);
  Box<Integer> x195 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x194, x195, (x193).get(), (x178).get(), 0xffffffff);
  Box<Integer> x196 = new Box<Integer>((int)0);
  Box<Integer> x197 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x196, x197, (x195).get(), (x180).get(), 0xffffffff);
  Box<Integer> x198 = new Box<Integer>((int)0);
  Box<Integer> x199 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x198, x199, (x197).get(), (x182).get(), 0xffffffff);
  Box<Integer> x200 = new Box<Integer>((int)0);
  Box<Integer> x201 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x200, x201, (x199).get(), (x184).get(), 0xffffffff);
  Box<Integer> x202 = new Box<Integer>((int)0);
  Box<Integer> x203 = new Box<Integer>((int)0);
  fiat_Secp256K1_subborrowx_u32(x202, x203, (x201).get(), (x185).get(), (int) Integer.toUnsignedLong(((Number) (0x0)).intValue()));
  Box<Integer> x204 = new Box<Integer>((int)0);
  Box<Integer> x205 = new Box<Integer>((int)0);
  fiat_Secp256K1_addcarryx_u32(x204, x205, 0x0, (x6).get(), 0x1);
  int x206 = (((x144).get() >>> 1) | (((x146).get() << 31) & 0xffffffff));
  int x207 = (((x146).get() >>> 1) | (((x148).get() << 31) & 0xffffffff));
  int x208 = (((x148).get() >>> 1) | (((x150).get() << 31) & 0xffffffff));
  int x209 = (((x150).get() >>> 1) | (((x152).get() << 31) & 0xffffffff));
  int x210 = (((x152).get() >>> 1) | (((x154).get() << 31) & 0xffffffff));
  int x211 = (((x154).get() >>> 1) | (((x156).get() << 31) & 0xffffffff));
  int x212 = (((x156).get() >>> 1) | (((x158).get() << 31) & 0xffffffff));
  int x213 = (((x158).get() >>> 1) | (((x160).get() << 31) & 0xffffffff));
  int x214 = (((x160).get() & 0x80000000) | ((x160).get() >>> 1));
  Box<Integer> x215 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x215, (x84).get(), (x67).get(), (x51).get());
  Box<Integer> x216 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x216, (x84).get(), (x69).get(), (x53).get());
  Box<Integer> x217 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x217, (x84).get(), (x71).get(), (x55).get());
  Box<Integer> x218 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x218, (x84).get(), (x73).get(), (x57).get());
  Box<Integer> x219 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x219, (x84).get(), (x75).get(), (x59).get());
  Box<Integer> x220 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x220, (x84).get(), (x77).get(), (x61).get());
  Box<Integer> x221 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x221, (x84).get(), (x79).get(), (x63).get());
  Box<Integer> x222 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x222, (x84).get(), (x81).get(), (x65).get());
  Box<Integer> x223 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x223, (x203).get(), (x186).get(), (x170).get());
  Box<Integer> x224 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x224, (x203).get(), (x188).get(), (x172).get());
  Box<Integer> x225 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x225, (x203).get(), (x190).get(), (x174).get());
  Box<Integer> x226 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x226, (x203).get(), (x192).get(), (x176).get());
  Box<Integer> x227 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x227, (x203).get(), (x194).get(), (x178).get());
  Box<Integer> x228 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x228, (x203).get(), (x196).get(), (x180).get());
  Box<Integer> x229 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x229, (x203).get(), (x198).get(), (x182).get());
  Box<Integer> x230 = new Box<Integer>((int)0);
  fiat_Secp256K1_cmovznz_u32(x230, (x203).get(), (x200).get(), (x184).get());
  out1.set((x204).get());
  out2[0] = (x7).get();
  out2[1] = (x8).get();
  out2[2] = (x9).get();
  out2[3] = (x10).get();
  out2[4] = (x11).get();
  out2[5] = (x12).get();
  out2[6] = (x13).get();
  out2[7] = (x14).get();
  out2[8] = (x15).get();
  out3[0] = x206;
  out3[1] = x207;
  out3[2] = x208;
  out3[3] = x209;
  out3[4] = x210;
  out3[5] = x211;
  out3[6] = x212;
  out3[7] = x213;
  out3[8] = x214;
  out4[0] = (x215).get();
  out4[1] = (x216).get();
  out4[2] = (x217).get();
  out4[3] = (x218).get();
  out4[4] = (x219).get();
  out4[5] = (x220).get();
  out4[6] = (x221).get();
  out4[7] = (x222).get();
  out5[0] = (x223).get();
  out5[1] = (x224).get();
  out5[2] = (x225).get();
  out5[3] = (x226).get();
  out5[4] = (x227).get();
  out5[5] = (x228).get();
  out5[6] = (x229).get();
  out5[7] = (x230).get();
}

/**
 * The function fiat_Secp256K1_divstep_precomp returns the precomputed value for Bernstein-Yang-inversion (in montgomery form). <p>
 * <p>
 * Postconditions: <p>
 *   eval (from_montgomery out1) = ⌊(m - 1) / 2⌋^(if ⌊log2 m⌋ + 1 &lt; 46 then ⌊(49 * (⌊log2 m⌋ + 1) + 80) / 17⌋ else ⌊(49 * (⌊log2 m⌋ + 1) + 57) / 17⌋) <p>
 *   0 ≤ eval out1 &lt; m <p>
 * <p>
 * Output Bounds: <p>
 *   out1: [[0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff], [0x0 ~&gt; 0xffffffff]] <p>
 */
public static void fiat_Secp256K1_divstep_precomp(int[] out1) {
  out1[0] = 0x31525e0a;
  out1[1] = 0xf201a418;
  out1[2] = 0xcd648d85;
  out1[3] = 0x9953f9dd;
  out1[4] = 0x3db210a9;
  out1[5] = 0xe8602946;
  out1[6] = 0x4b03709;
  out1[7] = 0x24fb8a31;
}

}
